import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdCatalogVappTemplateConfig extends cdktf.TerraformMetaArguments {
    /**
    * ID of the catalog containing the vApp Template. Can't be used if a specific VDC identifier is set
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/catalog_vapp_template#catalog_id DataVcdCatalogVappTemplate#catalog_id}
    */
    readonly catalogId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/catalog_vapp_template#id DataVcdCatalogVappTemplate#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Name of the vApp Template. It is optional when a filter is provided
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/catalog_vapp_template#name DataVcdCatalogVappTemplate#name}
    */
    readonly name?: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/catalog_vapp_template#org DataVcdCatalogVappTemplate#org}
    */
    readonly org?: string;
    /**
    * ID of the VDC to which the vApp Template belongs. Can't be used if a specific Catalog identifier is set
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/catalog_vapp_template#vdc_id DataVcdCatalogVappTemplate#vdc_id}
    */
    readonly vdcId?: string;
    /**
    * filter block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/catalog_vapp_template#filter DataVcdCatalogVappTemplate#filter}
    */
    readonly filter?: DataVcdCatalogVappTemplateFilter;
}
export interface DataVcdCatalogVappTemplateLease {
}
export declare function dataVcdCatalogVappTemplateLeaseToTerraform(struct?: DataVcdCatalogVappTemplateLease): any;
export declare function dataVcdCatalogVappTemplateLeaseToHclTerraform(struct?: DataVcdCatalogVappTemplateLease): any;
export declare class DataVcdCatalogVappTemplateLeaseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdCatalogVappTemplateLease | undefined;
    set internalValue(value: DataVcdCatalogVappTemplateLease | undefined);
    get storageLeaseInSec(): number;
}
export declare class DataVcdCatalogVappTemplateLeaseList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdCatalogVappTemplateLeaseOutputReference;
}
export interface DataVcdCatalogVappTemplateMetadataEntry {
}
export declare function dataVcdCatalogVappTemplateMetadataEntryToTerraform(struct?: DataVcdCatalogVappTemplateMetadataEntry): any;
export declare function dataVcdCatalogVappTemplateMetadataEntryToHclTerraform(struct?: DataVcdCatalogVappTemplateMetadataEntry): any;
export declare class DataVcdCatalogVappTemplateMetadataEntryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdCatalogVappTemplateMetadataEntry | undefined;
    set internalValue(value: DataVcdCatalogVappTemplateMetadataEntry | undefined);
    get isSystem(): cdktf.IResolvable;
    get key(): string;
    get type(): string;
    get userAccess(): string;
    get value(): string;
}
export declare class DataVcdCatalogVappTemplateMetadataEntryList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdCatalogVappTemplateMetadataEntryOutputReference;
}
export interface DataVcdCatalogVappTemplateFilterMetadata {
    /**
    * True if is a metadata@SYSTEM key
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/catalog_vapp_template#is_system DataVcdCatalogVappTemplate#is_system}
    */
    readonly isSystem?: boolean | cdktf.IResolvable;
    /**
    * Metadata key (field name)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/catalog_vapp_template#key DataVcdCatalogVappTemplate#key}
    */
    readonly key: string;
    /**
    * Type of metadata value (needed only if "use_api_search" is true)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/catalog_vapp_template#type DataVcdCatalogVappTemplate#type}
    */
    readonly type?: string;
    /**
    * If true, will search the vCD using native metadata query (without regular expressions)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/catalog_vapp_template#use_api_search DataVcdCatalogVappTemplate#use_api_search}
    */
    readonly useApiSearch?: boolean | cdktf.IResolvable;
    /**
    * Metadata value (can be a regular expression if "use_api_search" is false)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/catalog_vapp_template#value DataVcdCatalogVappTemplate#value}
    */
    readonly value: string;
}
export declare function dataVcdCatalogVappTemplateFilterMetadataToTerraform(struct?: DataVcdCatalogVappTemplateFilterMetadata | cdktf.IResolvable): any;
export declare function dataVcdCatalogVappTemplateFilterMetadataToHclTerraform(struct?: DataVcdCatalogVappTemplateFilterMetadata | cdktf.IResolvable): any;
export declare class DataVcdCatalogVappTemplateFilterMetadataOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdCatalogVappTemplateFilterMetadata | cdktf.IResolvable | undefined;
    set internalValue(value: DataVcdCatalogVappTemplateFilterMetadata | cdktf.IResolvable | undefined);
    private _isSystem?;
    get isSystem(): boolean | cdktf.IResolvable;
    set isSystem(value: boolean | cdktf.IResolvable);
    resetIsSystem(): void;
    get isSystemInput(): boolean | cdktf.IResolvable | undefined;
    private _key?;
    get key(): string;
    set key(value: string);
    get keyInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _useApiSearch?;
    get useApiSearch(): boolean | cdktf.IResolvable;
    set useApiSearch(value: boolean | cdktf.IResolvable);
    resetUseApiSearch(): void;
    get useApiSearchInput(): boolean | cdktf.IResolvable | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    get valueInput(): string | undefined;
}
export declare class DataVcdCatalogVappTemplateFilterMetadataList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataVcdCatalogVappTemplateFilterMetadata[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdCatalogVappTemplateFilterMetadataOutputReference;
}
export interface DataVcdCatalogVappTemplateFilter {
    /**
    * Search by date comparison ({>|>=|<|<=|==} yyyy-mm-dd[ hh[:mm[:ss]]])
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/catalog_vapp_template#date DataVcdCatalogVappTemplate#date}
    */
    readonly date?: string;
    /**
    * Retrieves the oldest item
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/catalog_vapp_template#earliest DataVcdCatalogVappTemplate#earliest}
    */
    readonly earliest?: boolean | cdktf.IResolvable;
    /**
    * Retrieves the newest item
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/catalog_vapp_template#latest DataVcdCatalogVappTemplate#latest}
    */
    readonly latest?: boolean | cdktf.IResolvable;
    /**
    * Search by name with a regular expression
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/catalog_vapp_template#name_regex DataVcdCatalogVappTemplate#name_regex}
    */
    readonly nameRegex?: string;
    /**
    * metadata block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/catalog_vapp_template#metadata DataVcdCatalogVappTemplate#metadata}
    */
    readonly metadata?: DataVcdCatalogVappTemplateFilterMetadata[] | cdktf.IResolvable;
}
export declare function dataVcdCatalogVappTemplateFilterToTerraform(struct?: DataVcdCatalogVappTemplateFilterOutputReference | DataVcdCatalogVappTemplateFilter): any;
export declare function dataVcdCatalogVappTemplateFilterToHclTerraform(struct?: DataVcdCatalogVappTemplateFilterOutputReference | DataVcdCatalogVappTemplateFilter): any;
export declare class DataVcdCatalogVappTemplateFilterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataVcdCatalogVappTemplateFilter | undefined;
    set internalValue(value: DataVcdCatalogVappTemplateFilter | undefined);
    private _date?;
    get date(): string;
    set date(value: string);
    resetDate(): void;
    get dateInput(): string | undefined;
    private _earliest?;
    get earliest(): boolean | cdktf.IResolvable;
    set earliest(value: boolean | cdktf.IResolvable);
    resetEarliest(): void;
    get earliestInput(): boolean | cdktf.IResolvable | undefined;
    private _latest?;
    get latest(): boolean | cdktf.IResolvable;
    set latest(value: boolean | cdktf.IResolvable);
    resetLatest(): void;
    get latestInput(): boolean | cdktf.IResolvable | undefined;
    private _nameRegex?;
    get nameRegex(): string;
    set nameRegex(value: string);
    resetNameRegex(): void;
    get nameRegexInput(): string | undefined;
    private _metadata;
    get metadata(): DataVcdCatalogVappTemplateFilterMetadataList;
    putMetadata(value: DataVcdCatalogVappTemplateFilterMetadata[] | cdktf.IResolvable): void;
    resetMetadata(): void;
    get metadataInput(): cdktf.IResolvable | DataVcdCatalogVappTemplateFilterMetadata[] | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/catalog_vapp_template vcd_catalog_vapp_template}
*/
export declare class DataVcdCatalogVappTemplate extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_catalog_vapp_template";
    /**
    * Generates CDKTF code for importing a DataVcdCatalogVappTemplate resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdCatalogVappTemplate to import
    * @param importFromId The id of the existing DataVcdCatalogVappTemplate that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/catalog_vapp_template#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdCatalogVappTemplate to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/catalog_vapp_template vcd_catalog_vapp_template} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdCatalogVappTemplateConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataVcdCatalogVappTemplateConfig);
    private _catalogId?;
    get catalogId(): string;
    set catalogId(value: string);
    resetCatalogId(): void;
    get catalogIdInput(): string | undefined;
    get catalogItemId(): string;
    get created(): string;
    get description(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _inheritedMetadata;
    get inheritedMetadata(): cdktf.StringMap;
    private _lease;
    get lease(): DataVcdCatalogVappTemplateLeaseList;
    private _metadata;
    get metadata(): cdktf.StringMap;
    private _metadataEntry;
    get metadataEntry(): DataVcdCatalogVappTemplateMetadataEntryList;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    private _vdcId?;
    get vdcId(): string;
    set vdcId(value: string);
    resetVdcId(): void;
    get vdcIdInput(): string | undefined;
    get vmNames(): string[];
    private _filter;
    get filter(): DataVcdCatalogVappTemplateFilterOutputReference;
    putFilter(value: DataVcdCatalogVappTemplateFilter): void;
    resetFilter(): void;
    get filterInput(): DataVcdCatalogVappTemplateFilter | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
