import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdEdgegatewayConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/edgegateway#id DataVcdEdgegateway#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * name of the edge gateway. (Optional when 'filter' is used)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/edgegateway#name DataVcdEdgegateway#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/edgegateway#org DataVcdEdgegateway#org}
    */
    readonly org?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/edgegateway#vdc DataVcdEdgegateway#vdc}
    */
    readonly vdc?: string;
    /**
    * filter block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/edgegateway#filter DataVcdEdgegateway#filter}
    */
    readonly filter?: DataVcdEdgegatewayFilter;
}
export interface DataVcdEdgegatewayExternalNetworkSubnetSuballocatePool {
}
export declare function dataVcdEdgegatewayExternalNetworkSubnetSuballocatePoolToTerraform(struct?: DataVcdEdgegatewayExternalNetworkSubnetSuballocatePool): any;
export declare function dataVcdEdgegatewayExternalNetworkSubnetSuballocatePoolToHclTerraform(struct?: DataVcdEdgegatewayExternalNetworkSubnetSuballocatePool): any;
export declare class DataVcdEdgegatewayExternalNetworkSubnetSuballocatePoolOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdEdgegatewayExternalNetworkSubnetSuballocatePool | undefined;
    set internalValue(value: DataVcdEdgegatewayExternalNetworkSubnetSuballocatePool | undefined);
    get endAddress(): string;
    get startAddress(): string;
}
export declare class DataVcdEdgegatewayExternalNetworkSubnetSuballocatePoolList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdEdgegatewayExternalNetworkSubnetSuballocatePoolOutputReference;
}
export interface DataVcdEdgegatewayExternalNetworkSubnet {
}
export declare function dataVcdEdgegatewayExternalNetworkSubnetToTerraform(struct?: DataVcdEdgegatewayExternalNetworkSubnet): any;
export declare function dataVcdEdgegatewayExternalNetworkSubnetToHclTerraform(struct?: DataVcdEdgegatewayExternalNetworkSubnet): any;
export declare class DataVcdEdgegatewayExternalNetworkSubnetOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdEdgegatewayExternalNetworkSubnet | undefined;
    set internalValue(value: DataVcdEdgegatewayExternalNetworkSubnet | undefined);
    get gateway(): string;
    get ipAddress(): string;
    get netmask(): string;
    private _suballocatePool;
    get suballocatePool(): DataVcdEdgegatewayExternalNetworkSubnetSuballocatePoolList;
    get useForDefaultRoute(): cdktf.IResolvable;
}
export declare class DataVcdEdgegatewayExternalNetworkSubnetList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdEdgegatewayExternalNetworkSubnetOutputReference;
}
export interface DataVcdEdgegatewayExternalNetwork {
}
export declare function dataVcdEdgegatewayExternalNetworkToTerraform(struct?: DataVcdEdgegatewayExternalNetwork): any;
export declare function dataVcdEdgegatewayExternalNetworkToHclTerraform(struct?: DataVcdEdgegatewayExternalNetwork): any;
export declare class DataVcdEdgegatewayExternalNetworkOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdEdgegatewayExternalNetwork | undefined;
    set internalValue(value: DataVcdEdgegatewayExternalNetwork | undefined);
    get enableRateLimit(): cdktf.IResolvable;
    get incomingRateLimit(): number;
    get name(): string;
    get outgoingRateLimit(): number;
    private _subnet;
    get subnet(): DataVcdEdgegatewayExternalNetworkSubnetList;
}
export declare class DataVcdEdgegatewayExternalNetworkList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdEdgegatewayExternalNetworkOutputReference;
}
export interface DataVcdEdgegatewayFilter {
    /**
    * Search by name with a regular expression
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/edgegateway#name_regex DataVcdEdgegateway#name_regex}
    */
    readonly nameRegex?: string;
}
export declare function dataVcdEdgegatewayFilterToTerraform(struct?: DataVcdEdgegatewayFilterOutputReference | DataVcdEdgegatewayFilter): any;
export declare function dataVcdEdgegatewayFilterToHclTerraform(struct?: DataVcdEdgegatewayFilterOutputReference | DataVcdEdgegatewayFilter): any;
export declare class DataVcdEdgegatewayFilterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataVcdEdgegatewayFilter | undefined;
    set internalValue(value: DataVcdEdgegatewayFilter | undefined);
    private _nameRegex?;
    get nameRegex(): string;
    set nameRegex(value: string);
    resetNameRegex(): void;
    get nameRegexInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/edgegateway vcd_edgegateway}
*/
export declare class DataVcdEdgegateway extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_edgegateway";
    /**
    * Generates CDKTF code for importing a DataVcdEdgegateway resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdEdgegateway to import
    * @param importFromId The id of the existing DataVcdEdgegateway that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/edgegateway#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdEdgegateway to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/edgegateway vcd_edgegateway} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdEdgegatewayConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataVcdEdgegatewayConfig);
    get configuration(): string;
    get defaultExternalNetworkIp(): string;
    get description(): string;
    get distributedRouting(): cdktf.IResolvable;
    private _externalNetwork;
    get externalNetwork(): DataVcdEdgegatewayExternalNetworkList;
    get externalNetworkIps(): string[];
    get fipsModeEnabled(): cdktf.IResolvable;
    get fwDefaultRuleAction(): string;
    get fwDefaultRuleLoggingEnabled(): cdktf.IResolvable;
    get fwEnabled(): cdktf.IResolvable;
    get haEnabled(): cdktf.IResolvable;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get lbAccelerationEnabled(): cdktf.IResolvable;
    get lbEnabled(): cdktf.IResolvable;
    get lbLoggingEnabled(): cdktf.IResolvable;
    get lbLoglevel(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    get useDefaultRouteForDnsRelay(): cdktf.IResolvable;
    private _vdc?;
    get vdc(): string;
    set vdc(value: string);
    resetVdc(): void;
    get vdcInput(): string | undefined;
    private _filter;
    get filter(): DataVcdEdgegatewayFilterOutputReference;
    putFilter(value: DataVcdEdgegatewayFilter): void;
    resetFilter(): void;
    get filterInput(): DataVcdEdgegatewayFilter | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
