import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdExternalNetworkV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/external_network_v2#id DataVcdExternalNetworkV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/external_network_v2#name DataVcdExternalNetworkV2#name}
    */
    readonly name: string;
}
export interface DataVcdExternalNetworkV2IpScopeStaticIpPool {
}
export declare function dataVcdExternalNetworkV2IpScopeStaticIpPoolToTerraform(struct?: DataVcdExternalNetworkV2IpScopeStaticIpPool): any;
export declare function dataVcdExternalNetworkV2IpScopeStaticIpPoolToHclTerraform(struct?: DataVcdExternalNetworkV2IpScopeStaticIpPool): any;
export declare class DataVcdExternalNetworkV2IpScopeStaticIpPoolOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdExternalNetworkV2IpScopeStaticIpPool | undefined;
    set internalValue(value: DataVcdExternalNetworkV2IpScopeStaticIpPool | undefined);
    get endAddress(): string;
    get startAddress(): string;
}
export declare class DataVcdExternalNetworkV2IpScopeStaticIpPoolList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdExternalNetworkV2IpScopeStaticIpPoolOutputReference;
}
export interface DataVcdExternalNetworkV2IpScope {
}
export declare function dataVcdExternalNetworkV2IpScopeToTerraform(struct?: DataVcdExternalNetworkV2IpScope): any;
export declare function dataVcdExternalNetworkV2IpScopeToHclTerraform(struct?: DataVcdExternalNetworkV2IpScope): any;
export declare class DataVcdExternalNetworkV2IpScopeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdExternalNetworkV2IpScope | undefined;
    set internalValue(value: DataVcdExternalNetworkV2IpScope | undefined);
    get dns1(): string;
    get dns2(): string;
    get dnsSuffix(): string;
    get enabled(): cdktf.IResolvable;
    get gateway(): string;
    get prefixLength(): number;
    private _staticIpPool;
    get staticIpPool(): DataVcdExternalNetworkV2IpScopeStaticIpPoolList;
}
export declare class DataVcdExternalNetworkV2IpScopeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdExternalNetworkV2IpScopeOutputReference;
}
export interface DataVcdExternalNetworkV2NsxtNetwork {
}
export declare function dataVcdExternalNetworkV2NsxtNetworkToTerraform(struct?: DataVcdExternalNetworkV2NsxtNetwork): any;
export declare function dataVcdExternalNetworkV2NsxtNetworkToHclTerraform(struct?: DataVcdExternalNetworkV2NsxtNetwork): any;
export declare class DataVcdExternalNetworkV2NsxtNetworkOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdExternalNetworkV2NsxtNetwork | undefined;
    set internalValue(value: DataVcdExternalNetworkV2NsxtNetwork | undefined);
    get nsxtManagerId(): string;
    get nsxtSegmentName(): string;
    get nsxtTier0RouterId(): string;
}
export declare class DataVcdExternalNetworkV2NsxtNetworkList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdExternalNetworkV2NsxtNetworkOutputReference;
}
export interface DataVcdExternalNetworkV2VsphereNetwork {
}
export declare function dataVcdExternalNetworkV2VsphereNetworkToTerraform(struct?: DataVcdExternalNetworkV2VsphereNetwork): any;
export declare function dataVcdExternalNetworkV2VsphereNetworkToHclTerraform(struct?: DataVcdExternalNetworkV2VsphereNetwork): any;
export declare class DataVcdExternalNetworkV2VsphereNetworkOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdExternalNetworkV2VsphereNetwork | undefined;
    set internalValue(value: DataVcdExternalNetworkV2VsphereNetwork | undefined);
    get portgroupId(): string;
    get vcenterId(): string;
}
export declare class DataVcdExternalNetworkV2VsphereNetworkList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdExternalNetworkV2VsphereNetworkOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/external_network_v2 vcd_external_network_v2}
*/
export declare class DataVcdExternalNetworkV2 extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_external_network_v2";
    /**
    * Generates CDKTF code for importing a DataVcdExternalNetworkV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdExternalNetworkV2 to import
    * @param importFromId The id of the existing DataVcdExternalNetworkV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/external_network_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdExternalNetworkV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/external_network_v2 vcd_external_network_v2} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdExternalNetworkV2Config
    */
    constructor(scope: Construct, id: string, config: DataVcdExternalNetworkV2Config);
    get dedicatedOrgId(): string;
    get description(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _ipScope;
    get ipScope(): DataVcdExternalNetworkV2IpScopeList;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _nsxtNetwork;
    get nsxtNetwork(): DataVcdExternalNetworkV2NsxtNetworkList;
    get useIpSpaces(): cdktf.IResolvable;
    private _vsphereNetwork;
    get vsphereNetwork(): DataVcdExternalNetworkV2VsphereNetworkList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
