import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdIpSpaceCustomQuotaConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ip_space_custom_quota#id DataVcdIpSpaceCustomQuota#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * ID of IP Space
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ip_space_custom_quota#ip_space_id DataVcdIpSpaceCustomQuota#ip_space_id}
    */
    readonly ipSpaceId: string;
    /**
    * Organization ID for which custom quota is set
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ip_space_custom_quota#org_id DataVcdIpSpaceCustomQuota#org_id}
    */
    readonly orgId: string;
}
export interface DataVcdIpSpaceCustomQuotaIpPrefixQuota {
}
export declare function dataVcdIpSpaceCustomQuotaIpPrefixQuotaToTerraform(struct?: DataVcdIpSpaceCustomQuotaIpPrefixQuota): any;
export declare function dataVcdIpSpaceCustomQuotaIpPrefixQuotaToHclTerraform(struct?: DataVcdIpSpaceCustomQuotaIpPrefixQuota): any;
export declare class DataVcdIpSpaceCustomQuotaIpPrefixQuotaOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdIpSpaceCustomQuotaIpPrefixQuota | undefined;
    set internalValue(value: DataVcdIpSpaceCustomQuotaIpPrefixQuota | undefined);
    get prefixLength(): string;
    get quota(): string;
}
export declare class DataVcdIpSpaceCustomQuotaIpPrefixQuotaList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdIpSpaceCustomQuotaIpPrefixQuotaOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ip_space_custom_quota vcd_ip_space_custom_quota}
*/
export declare class DataVcdIpSpaceCustomQuota extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_ip_space_custom_quota";
    /**
    * Generates CDKTF code for importing a DataVcdIpSpaceCustomQuota resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdIpSpaceCustomQuota to import
    * @param importFromId The id of the existing DataVcdIpSpaceCustomQuota that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ip_space_custom_quota#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdIpSpaceCustomQuota to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ip_space_custom_quota vcd_ip_space_custom_quota} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdIpSpaceCustomQuotaConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdIpSpaceCustomQuotaConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _ipPrefixQuota;
    get ipPrefixQuota(): DataVcdIpSpaceCustomQuotaIpPrefixQuotaList;
    get ipRangeQuota(): string;
    private _ipSpaceId?;
    get ipSpaceId(): string;
    set ipSpaceId(value: string);
    get ipSpaceIdInput(): string | undefined;
    private _orgId?;
    get orgId(): string;
    set orgId(value: string);
    get orgIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
