import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdIpSpaceIpAllocationConfig extends cdktf.TerraformMetaArguments {
    /**
    * IP Allocation Description
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ip_space_ip_allocation#description DataVcdIpSpaceIpAllocation#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ip_space_ip_allocation#id DataVcdIpSpaceIpAllocation#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * IP Address or Prefix of the allocation
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ip_space_ip_allocation#ip_address DataVcdIpSpaceIpAllocation#ip_address}
    */
    readonly ipAddress: string;
    /**
    * IP Space ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ip_space_ip_allocation#ip_space_id DataVcdIpSpaceIpAllocation#ip_space_id}
    */
    readonly ipSpaceId: string;
    /**
    * Org ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ip_space_ip_allocation#org_id DataVcdIpSpaceIpAllocation#org_id}
    */
    readonly orgId: string;
    /**
    * Type of IP Allocation. One of 'FLOATING_IP' or 'IP_PREFIX'
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ip_space_ip_allocation#type DataVcdIpSpaceIpAllocation#type}
    */
    readonly type: string;
    /**
    * One of 'UNUSED', 'USED', 'USED_MANUAL
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ip_space_ip_allocation#usage_state DataVcdIpSpaceIpAllocation#usage_state}
    */
    readonly usageState?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ip_space_ip_allocation vcd_ip_space_ip_allocation}
*/
export declare class DataVcdIpSpaceIpAllocation extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_ip_space_ip_allocation";
    /**
    * Generates CDKTF code for importing a DataVcdIpSpaceIpAllocation resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdIpSpaceIpAllocation to import
    * @param importFromId The id of the existing DataVcdIpSpaceIpAllocation that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ip_space_ip_allocation#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdIpSpaceIpAllocation to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ip_space_ip_allocation vcd_ip_space_ip_allocation} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdIpSpaceIpAllocationConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdIpSpaceIpAllocationConfig);
    get allocationDate(): string;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get ip(): string;
    private _ipAddress?;
    get ipAddress(): string;
    set ipAddress(value: string);
    get ipAddressInput(): string | undefined;
    private _ipSpaceId?;
    get ipSpaceId(): string;
    set ipSpaceId(value: string);
    get ipSpaceIdInput(): string | undefined;
    private _orgId?;
    get orgId(): string;
    set orgId(value: string);
    get orgIdInput(): string | undefined;
    get prefixLength(): string;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
    private _usageState?;
    get usageState(): string;
    set usageState(value: string);
    resetUsageState(): void;
    get usageStateInput(): string | undefined;
    get usedById(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
