import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdIpSpaceUplinkConfig extends cdktf.TerraformMetaArguments {
    /**
    * IP Space Uplink description
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ip_space_uplink#description DataVcdIpSpaceUplink#description}
    */
    readonly description?: string;
    /**
    * External Network ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ip_space_uplink#external_network_id DataVcdIpSpaceUplink#external_network_id}
    */
    readonly externalNetworkId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ip_space_uplink#id DataVcdIpSpaceUplink#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Tenant facing name for IP Space Uplink
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ip_space_uplink#name DataVcdIpSpaceUplink#name}
    */
    readonly name: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ip_space_uplink vcd_ip_space_uplink}
*/
export declare class DataVcdIpSpaceUplink extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_ip_space_uplink";
    /**
    * Generates CDKTF code for importing a DataVcdIpSpaceUplink resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdIpSpaceUplink to import
    * @param importFromId The id of the existing DataVcdIpSpaceUplink that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ip_space_uplink#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdIpSpaceUplink to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ip_space_uplink vcd_ip_space_uplink} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdIpSpaceUplinkConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdIpSpaceUplinkConfig);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _externalNetworkId?;
    get externalNetworkId(): string;
    set externalNetworkId(value: string);
    get externalNetworkIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get ipSpaceId(): string;
    get ipSpaceType(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get status(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
