import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdIpSpaceConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ip_space#id DataVcdIpSpace#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Name of IP space
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ip_space#name DataVcdIpSpace#name}
    */
    readonly name: string;
    /**
    * Org ID for 'SHARED' IP spaces
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ip_space#org_id DataVcdIpSpace#org_id}
    */
    readonly orgId?: string;
}
export interface DataVcdIpSpaceIpPrefixPrefix {
}
export declare function dataVcdIpSpaceIpPrefixPrefixToTerraform(struct?: DataVcdIpSpaceIpPrefixPrefix): any;
export declare function dataVcdIpSpaceIpPrefixPrefixToHclTerraform(struct?: DataVcdIpSpaceIpPrefixPrefix): any;
export declare class DataVcdIpSpaceIpPrefixPrefixOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdIpSpaceIpPrefixPrefix | undefined;
    set internalValue(value: DataVcdIpSpaceIpPrefixPrefix | undefined);
    get firstIp(): string;
    get id(): string;
    get prefixCount(): string;
    get prefixLength(): string;
}
export declare class DataVcdIpSpaceIpPrefixPrefixList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdIpSpaceIpPrefixPrefixOutputReference;
}
export interface DataVcdIpSpaceIpPrefix {
}
export declare function dataVcdIpSpaceIpPrefixToTerraform(struct?: DataVcdIpSpaceIpPrefix): any;
export declare function dataVcdIpSpaceIpPrefixToHclTerraform(struct?: DataVcdIpSpaceIpPrefix): any;
export declare class DataVcdIpSpaceIpPrefixOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdIpSpaceIpPrefix | undefined;
    set internalValue(value: DataVcdIpSpaceIpPrefix | undefined);
    get defaultQuota(): string;
    private _prefix;
    get prefix(): DataVcdIpSpaceIpPrefixPrefixList;
}
export declare class DataVcdIpSpaceIpPrefixList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdIpSpaceIpPrefixOutputReference;
}
export interface DataVcdIpSpaceIpRange {
}
export declare function dataVcdIpSpaceIpRangeToTerraform(struct?: DataVcdIpSpaceIpRange): any;
export declare function dataVcdIpSpaceIpRangeToHclTerraform(struct?: DataVcdIpSpaceIpRange): any;
export declare class DataVcdIpSpaceIpRangeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdIpSpaceIpRange | undefined;
    set internalValue(value: DataVcdIpSpaceIpRange | undefined);
    get endAddress(): string;
    get id(): string;
    get startAddress(): string;
}
export declare class DataVcdIpSpaceIpRangeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdIpSpaceIpRangeOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ip_space vcd_ip_space}
*/
export declare class DataVcdIpSpace extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_ip_space";
    /**
    * Generates CDKTF code for importing a DataVcdIpSpace resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdIpSpace to import
    * @param importFromId The id of the existing DataVcdIpSpace that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ip_space#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdIpSpace to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ip_space vcd_ip_space} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdIpSpaceConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdIpSpaceConfig);
    get defaultFirewallRuleCreationEnabled(): cdktf.IResolvable;
    get defaultNoSnatRuleCreationEnabled(): cdktf.IResolvable;
    get defaultSnatRuleCreationEnabled(): cdktf.IResolvable;
    get description(): string;
    get externalScope(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get internalScope(): string[];
    private _ipPrefix;
    get ipPrefix(): DataVcdIpSpaceIpPrefixList;
    private _ipRange;
    get ipRange(): DataVcdIpSpaceIpRangeList;
    get ipRangeQuota(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _orgId?;
    get orgId(): string;
    set orgId(value: string);
    resetOrgId(): void;
    get orgIdInput(): string | undefined;
    get routeAdvertisementEnabled(): cdktf.IResolvable;
    get type(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
