import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdLibraryCertificateConfig extends cdktf.TerraformMetaArguments {
    /**
    * Alias of certificate
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/library_certificate#alias DataVcdLibraryCertificate#alias}
    */
    readonly alias?: string;
    /**
    * Certificate content
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/library_certificate#certificate DataVcdLibraryCertificate#certificate}
    */
    readonly certificate?: string;
    /**
    * Certificate description
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/library_certificate#description DataVcdLibraryCertificate#description}
    */
    readonly description?: string;
    /**
    * Certificate ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/library_certificate#id DataVcdLibraryCertificate#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/library_certificate#org DataVcdLibraryCertificate#org}
    */
    readonly org?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/library_certificate vcd_library_certificate}
*/
export declare class DataVcdLibraryCertificate extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_library_certificate";
    /**
    * Generates CDKTF code for importing a DataVcdLibraryCertificate resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdLibraryCertificate to import
    * @param importFromId The id of the existing DataVcdLibraryCertificate that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/library_certificate#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdLibraryCertificate to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/library_certificate vcd_library_certificate} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdLibraryCertificateConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataVcdLibraryCertificateConfig);
    private _alias?;
    get alias(): string;
    set alias(value: string);
    resetAlias(): void;
    get aliasInput(): string | undefined;
    private _certificate?;
    get certificate(): string;
    set certificate(value: string);
    resetCertificate(): void;
    get certificateInput(): string | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
