import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNetworkIsolatedV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_isolated_v2#id DataVcdNetworkIsolatedV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * A unique name for this network (optional if 'filter' is used)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_isolated_v2#name DataVcdNetworkIsolatedV2#name}
    */
    readonly name?: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_isolated_v2#org DataVcdNetworkIsolatedV2#org}
    */
    readonly org?: string;
    /**
    * ID of VDC or VDC Group
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_isolated_v2#owner_id DataVcdNetworkIsolatedV2#owner_id}
    */
    readonly ownerId?: string;
    /**
    * The name of VDC to use, optional if defined at provider level
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_isolated_v2#vdc DataVcdNetworkIsolatedV2#vdc}
    */
    readonly vdc?: string;
    /**
    * filter block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_isolated_v2#filter DataVcdNetworkIsolatedV2#filter}
    */
    readonly filter?: DataVcdNetworkIsolatedV2Filter;
}
export interface DataVcdNetworkIsolatedV2MetadataEntry {
}
export declare function dataVcdNetworkIsolatedV2MetadataEntryToTerraform(struct?: DataVcdNetworkIsolatedV2MetadataEntry): any;
export declare function dataVcdNetworkIsolatedV2MetadataEntryToHclTerraform(struct?: DataVcdNetworkIsolatedV2MetadataEntry): any;
export declare class DataVcdNetworkIsolatedV2MetadataEntryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNetworkIsolatedV2MetadataEntry | undefined;
    set internalValue(value: DataVcdNetworkIsolatedV2MetadataEntry | undefined);
    get isSystem(): cdktf.IResolvable;
    get key(): string;
    get type(): string;
    get userAccess(): string;
    get value(): string;
}
export declare class DataVcdNetworkIsolatedV2MetadataEntryList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNetworkIsolatedV2MetadataEntryOutputReference;
}
export interface DataVcdNetworkIsolatedV2SecondaryStaticIpPool {
}
export declare function dataVcdNetworkIsolatedV2SecondaryStaticIpPoolToTerraform(struct?: DataVcdNetworkIsolatedV2SecondaryStaticIpPool): any;
export declare function dataVcdNetworkIsolatedV2SecondaryStaticIpPoolToHclTerraform(struct?: DataVcdNetworkIsolatedV2SecondaryStaticIpPool): any;
export declare class DataVcdNetworkIsolatedV2SecondaryStaticIpPoolOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNetworkIsolatedV2SecondaryStaticIpPool | undefined;
    set internalValue(value: DataVcdNetworkIsolatedV2SecondaryStaticIpPool | undefined);
    get endAddress(): string;
    get startAddress(): string;
}
export declare class DataVcdNetworkIsolatedV2SecondaryStaticIpPoolList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNetworkIsolatedV2SecondaryStaticIpPoolOutputReference;
}
export interface DataVcdNetworkIsolatedV2StaticIpPool {
}
export declare function dataVcdNetworkIsolatedV2StaticIpPoolToTerraform(struct?: DataVcdNetworkIsolatedV2StaticIpPool): any;
export declare function dataVcdNetworkIsolatedV2StaticIpPoolToHclTerraform(struct?: DataVcdNetworkIsolatedV2StaticIpPool): any;
export declare class DataVcdNetworkIsolatedV2StaticIpPoolOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNetworkIsolatedV2StaticIpPool | undefined;
    set internalValue(value: DataVcdNetworkIsolatedV2StaticIpPool | undefined);
    get endAddress(): string;
    get startAddress(): string;
}
export declare class DataVcdNetworkIsolatedV2StaticIpPoolList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNetworkIsolatedV2StaticIpPoolOutputReference;
}
export interface DataVcdNetworkIsolatedV2Filter {
    /**
    * Search by IP. The value can be a regular expression
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_isolated_v2#ip DataVcdNetworkIsolatedV2#ip}
    */
    readonly ip?: string;
    /**
    * Search by name with a regular expression
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_isolated_v2#name_regex DataVcdNetworkIsolatedV2#name_regex}
    */
    readonly nameRegex?: string;
}
export declare function dataVcdNetworkIsolatedV2FilterToTerraform(struct?: DataVcdNetworkIsolatedV2FilterOutputReference | DataVcdNetworkIsolatedV2Filter): any;
export declare function dataVcdNetworkIsolatedV2FilterToHclTerraform(struct?: DataVcdNetworkIsolatedV2FilterOutputReference | DataVcdNetworkIsolatedV2Filter): any;
export declare class DataVcdNetworkIsolatedV2FilterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataVcdNetworkIsolatedV2Filter | undefined;
    set internalValue(value: DataVcdNetworkIsolatedV2Filter | undefined);
    private _ip?;
    get ip(): string;
    set ip(value: string);
    resetIp(): void;
    get ipInput(): string | undefined;
    private _nameRegex?;
    get nameRegex(): string;
    set nameRegex(value: string);
    resetNameRegex(): void;
    get nameRegexInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_isolated_v2 vcd_network_isolated_v2}
*/
export declare class DataVcdNetworkIsolatedV2 extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_network_isolated_v2";
    /**
    * Generates CDKTF code for importing a DataVcdNetworkIsolatedV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNetworkIsolatedV2 to import
    * @param importFromId The id of the existing DataVcdNetworkIsolatedV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_isolated_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNetworkIsolatedV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_isolated_v2 vcd_network_isolated_v2} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNetworkIsolatedV2Config = {}
    */
    constructor(scope: Construct, id: string, config?: DataVcdNetworkIsolatedV2Config);
    get description(): string;
    get dns1(): string;
    get dns2(): string;
    get dnsSuffix(): string;
    get dualStackEnabled(): cdktf.IResolvable;
    get gateway(): string;
    get guestVlanAllowed(): cdktf.IResolvable;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get isShared(): cdktf.IResolvable;
    private _metadata;
    get metadata(): cdktf.StringMap;
    private _metadataEntry;
    get metadataEntry(): DataVcdNetworkIsolatedV2MetadataEntryList;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    private _ownerId?;
    get ownerId(): string;
    set ownerId(value: string);
    resetOwnerId(): void;
    get ownerIdInput(): string | undefined;
    get prefixLength(): number;
    get secondaryGateway(): string;
    get secondaryPrefixLength(): string;
    private _secondaryStaticIpPool;
    get secondaryStaticIpPool(): DataVcdNetworkIsolatedV2SecondaryStaticIpPoolList;
    private _staticIpPool;
    get staticIpPool(): DataVcdNetworkIsolatedV2StaticIpPoolList;
    private _vdc?;
    get vdc(): string;
    set vdc(value: string);
    resetVdc(): void;
    get vdcInput(): string | undefined;
    private _filter;
    get filter(): DataVcdNetworkIsolatedV2FilterOutputReference;
    putFilter(value: DataVcdNetworkIsolatedV2Filter): void;
    resetFilter(): void;
    get filterInput(): DataVcdNetworkIsolatedV2Filter | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
