import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNetworkIsolatedConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_isolated#id DataVcdNetworkIsolated#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * A unique name for this network (optional if 'filter' is used)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_isolated#name DataVcdNetworkIsolated#name}
    */
    readonly name?: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_isolated#org DataVcdNetworkIsolated#org}
    */
    readonly org?: string;
    /**
    * The name of VDC to use, optional if defined at provider level
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_isolated#vdc DataVcdNetworkIsolated#vdc}
    */
    readonly vdc?: string;
    /**
    * filter block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_isolated#filter DataVcdNetworkIsolated#filter}
    */
    readonly filter?: DataVcdNetworkIsolatedFilter;
}
export interface DataVcdNetworkIsolatedDhcpPool {
}
export declare function dataVcdNetworkIsolatedDhcpPoolToTerraform(struct?: DataVcdNetworkIsolatedDhcpPool): any;
export declare function dataVcdNetworkIsolatedDhcpPoolToHclTerraform(struct?: DataVcdNetworkIsolatedDhcpPool): any;
export declare class DataVcdNetworkIsolatedDhcpPoolOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNetworkIsolatedDhcpPool | undefined;
    set internalValue(value: DataVcdNetworkIsolatedDhcpPool | undefined);
    get defaultLeaseTime(): number;
    get endAddress(): string;
    get maxLeaseTime(): number;
    get startAddress(): string;
}
export declare class DataVcdNetworkIsolatedDhcpPoolList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNetworkIsolatedDhcpPoolOutputReference;
}
export interface DataVcdNetworkIsolatedMetadataEntry {
}
export declare function dataVcdNetworkIsolatedMetadataEntryToTerraform(struct?: DataVcdNetworkIsolatedMetadataEntry): any;
export declare function dataVcdNetworkIsolatedMetadataEntryToHclTerraform(struct?: DataVcdNetworkIsolatedMetadataEntry): any;
export declare class DataVcdNetworkIsolatedMetadataEntryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNetworkIsolatedMetadataEntry | undefined;
    set internalValue(value: DataVcdNetworkIsolatedMetadataEntry | undefined);
    get isSystem(): cdktf.IResolvable;
    get key(): string;
    get type(): string;
    get userAccess(): string;
    get value(): string;
}
export declare class DataVcdNetworkIsolatedMetadataEntryList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNetworkIsolatedMetadataEntryOutputReference;
}
export interface DataVcdNetworkIsolatedStaticIpPool {
}
export declare function dataVcdNetworkIsolatedStaticIpPoolToTerraform(struct?: DataVcdNetworkIsolatedStaticIpPool): any;
export declare function dataVcdNetworkIsolatedStaticIpPoolToHclTerraform(struct?: DataVcdNetworkIsolatedStaticIpPool): any;
export declare class DataVcdNetworkIsolatedStaticIpPoolOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNetworkIsolatedStaticIpPool | undefined;
    set internalValue(value: DataVcdNetworkIsolatedStaticIpPool | undefined);
    get endAddress(): string;
    get startAddress(): string;
}
export declare class DataVcdNetworkIsolatedStaticIpPoolList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNetworkIsolatedStaticIpPoolOutputReference;
}
export interface DataVcdNetworkIsolatedFilterMetadata {
    /**
    * True if is a metadata@SYSTEM key
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_isolated#is_system DataVcdNetworkIsolated#is_system}
    */
    readonly isSystem?: boolean | cdktf.IResolvable;
    /**
    * Metadata key (field name)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_isolated#key DataVcdNetworkIsolated#key}
    */
    readonly key: string;
    /**
    * Type of metadata value (needed only if "use_api_search" is true)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_isolated#type DataVcdNetworkIsolated#type}
    */
    readonly type?: string;
    /**
    * If true, will search the vCD using native metadata query (without regular expressions)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_isolated#use_api_search DataVcdNetworkIsolated#use_api_search}
    */
    readonly useApiSearch?: boolean | cdktf.IResolvable;
    /**
    * Metadata value (can be a regular expression if "use_api_search" is false)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_isolated#value DataVcdNetworkIsolated#value}
    */
    readonly value: string;
}
export declare function dataVcdNetworkIsolatedFilterMetadataToTerraform(struct?: DataVcdNetworkIsolatedFilterMetadata | cdktf.IResolvable): any;
export declare function dataVcdNetworkIsolatedFilterMetadataToHclTerraform(struct?: DataVcdNetworkIsolatedFilterMetadata | cdktf.IResolvable): any;
export declare class DataVcdNetworkIsolatedFilterMetadataOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNetworkIsolatedFilterMetadata | cdktf.IResolvable | undefined;
    set internalValue(value: DataVcdNetworkIsolatedFilterMetadata | cdktf.IResolvable | undefined);
    private _isSystem?;
    get isSystem(): boolean | cdktf.IResolvable;
    set isSystem(value: boolean | cdktf.IResolvable);
    resetIsSystem(): void;
    get isSystemInput(): boolean | cdktf.IResolvable | undefined;
    private _key?;
    get key(): string;
    set key(value: string);
    get keyInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _useApiSearch?;
    get useApiSearch(): boolean | cdktf.IResolvable;
    set useApiSearch(value: boolean | cdktf.IResolvable);
    resetUseApiSearch(): void;
    get useApiSearchInput(): boolean | cdktf.IResolvable | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    get valueInput(): string | undefined;
}
export declare class DataVcdNetworkIsolatedFilterMetadataList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataVcdNetworkIsolatedFilterMetadata[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNetworkIsolatedFilterMetadataOutputReference;
}
export interface DataVcdNetworkIsolatedFilter {
    /**
    * Search by IP. The value can be a regular expression
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_isolated#ip DataVcdNetworkIsolated#ip}
    */
    readonly ip?: string;
    /**
    * Search by name with a regular expression
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_isolated#name_regex DataVcdNetworkIsolated#name_regex}
    */
    readonly nameRegex?: string;
    /**
    * metadata block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_isolated#metadata DataVcdNetworkIsolated#metadata}
    */
    readonly metadata?: DataVcdNetworkIsolatedFilterMetadata[] | cdktf.IResolvable;
}
export declare function dataVcdNetworkIsolatedFilterToTerraform(struct?: DataVcdNetworkIsolatedFilterOutputReference | DataVcdNetworkIsolatedFilter): any;
export declare function dataVcdNetworkIsolatedFilterToHclTerraform(struct?: DataVcdNetworkIsolatedFilterOutputReference | DataVcdNetworkIsolatedFilter): any;
export declare class DataVcdNetworkIsolatedFilterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataVcdNetworkIsolatedFilter | undefined;
    set internalValue(value: DataVcdNetworkIsolatedFilter | undefined);
    private _ip?;
    get ip(): string;
    set ip(value: string);
    resetIp(): void;
    get ipInput(): string | undefined;
    private _nameRegex?;
    get nameRegex(): string;
    set nameRegex(value: string);
    resetNameRegex(): void;
    get nameRegexInput(): string | undefined;
    private _metadata;
    get metadata(): DataVcdNetworkIsolatedFilterMetadataList;
    putMetadata(value: DataVcdNetworkIsolatedFilterMetadata[] | cdktf.IResolvable): void;
    resetMetadata(): void;
    get metadataInput(): cdktf.IResolvable | DataVcdNetworkIsolatedFilterMetadata[] | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_isolated vcd_network_isolated}
*/
export declare class DataVcdNetworkIsolated extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_network_isolated";
    /**
    * Generates CDKTF code for importing a DataVcdNetworkIsolated resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNetworkIsolated to import
    * @param importFromId The id of the existing DataVcdNetworkIsolated that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_isolated#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNetworkIsolated to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_isolated vcd_network_isolated} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNetworkIsolatedConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataVcdNetworkIsolatedConfig);
    get description(): string;
    private _dhcpPool;
    get dhcpPool(): DataVcdNetworkIsolatedDhcpPoolList;
    get dns1(): string;
    get dns2(): string;
    get dnsSuffix(): string;
    get gateway(): string;
    get href(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _metadata;
    get metadata(): cdktf.StringMap;
    private _metadataEntry;
    get metadataEntry(): DataVcdNetworkIsolatedMetadataEntryList;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get netmask(): string;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    get shared(): cdktf.IResolvable;
    private _staticIpPool;
    get staticIpPool(): DataVcdNetworkIsolatedStaticIpPoolList;
    private _vdc?;
    get vdc(): string;
    set vdc(value: string);
    resetVdc(): void;
    get vdcInput(): string | undefined;
    private _filter;
    get filter(): DataVcdNetworkIsolatedFilterOutputReference;
    putFilter(value: DataVcdNetworkIsolatedFilter): void;
    resetFilter(): void;
    get filterInput(): DataVcdNetworkIsolatedFilter | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
