import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNetworkPoolConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_pool#id DataVcdNetworkPool#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Name of network pool.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_pool#name DataVcdNetworkPool#name}
    */
    readonly name: string;
}
export interface DataVcdNetworkPoolBackingDistributedSwitch {
}
export declare function dataVcdNetworkPoolBackingDistributedSwitchToTerraform(struct?: DataVcdNetworkPoolBackingDistributedSwitch): any;
export declare function dataVcdNetworkPoolBackingDistributedSwitchToHclTerraform(struct?: DataVcdNetworkPoolBackingDistributedSwitch): any;
export declare class DataVcdNetworkPoolBackingDistributedSwitchOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNetworkPoolBackingDistributedSwitch | undefined;
    set internalValue(value: DataVcdNetworkPoolBackingDistributedSwitch | undefined);
    get id(): string;
    get name(): string;
    get type(): string;
}
export declare class DataVcdNetworkPoolBackingDistributedSwitchList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNetworkPoolBackingDistributedSwitchOutputReference;
}
export interface DataVcdNetworkPoolBackingPortGroup {
}
export declare function dataVcdNetworkPoolBackingPortGroupToTerraform(struct?: DataVcdNetworkPoolBackingPortGroup): any;
export declare function dataVcdNetworkPoolBackingPortGroupToHclTerraform(struct?: DataVcdNetworkPoolBackingPortGroup): any;
export declare class DataVcdNetworkPoolBackingPortGroupOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNetworkPoolBackingPortGroup | undefined;
    set internalValue(value: DataVcdNetworkPoolBackingPortGroup | undefined);
    get id(): string;
    get name(): string;
    get type(): string;
}
export declare class DataVcdNetworkPoolBackingPortGroupList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNetworkPoolBackingPortGroupOutputReference;
}
export interface DataVcdNetworkPoolBackingRangeId {
}
export declare function dataVcdNetworkPoolBackingRangeIdToTerraform(struct?: DataVcdNetworkPoolBackingRangeId): any;
export declare function dataVcdNetworkPoolBackingRangeIdToHclTerraform(struct?: DataVcdNetworkPoolBackingRangeId): any;
export declare class DataVcdNetworkPoolBackingRangeIdOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNetworkPoolBackingRangeId | undefined;
    set internalValue(value: DataVcdNetworkPoolBackingRangeId | undefined);
    get endId(): number;
    get startId(): number;
}
export declare class DataVcdNetworkPoolBackingRangeIdList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNetworkPoolBackingRangeIdOutputReference;
}
export interface DataVcdNetworkPoolBackingTransportZone {
}
export declare function dataVcdNetworkPoolBackingTransportZoneToTerraform(struct?: DataVcdNetworkPoolBackingTransportZone): any;
export declare function dataVcdNetworkPoolBackingTransportZoneToHclTerraform(struct?: DataVcdNetworkPoolBackingTransportZone): any;
export declare class DataVcdNetworkPoolBackingTransportZoneOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNetworkPoolBackingTransportZone | undefined;
    set internalValue(value: DataVcdNetworkPoolBackingTransportZone | undefined);
    get id(): string;
    get name(): string;
    get type(): string;
}
export declare class DataVcdNetworkPoolBackingTransportZoneList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNetworkPoolBackingTransportZoneOutputReference;
}
export interface DataVcdNetworkPoolBacking {
}
export declare function dataVcdNetworkPoolBackingToTerraform(struct?: DataVcdNetworkPoolBacking): any;
export declare function dataVcdNetworkPoolBackingToHclTerraform(struct?: DataVcdNetworkPoolBacking): any;
export declare class DataVcdNetworkPoolBackingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNetworkPoolBacking | undefined;
    set internalValue(value: DataVcdNetworkPoolBacking | undefined);
    private _distributedSwitch;
    get distributedSwitch(): DataVcdNetworkPoolBackingDistributedSwitchList;
    private _portGroup;
    get portGroup(): DataVcdNetworkPoolBackingPortGroupList;
    private _rangeId;
    get rangeId(): DataVcdNetworkPoolBackingRangeIdList;
    private _transportZone;
    get transportZone(): DataVcdNetworkPoolBackingTransportZoneList;
}
export declare class DataVcdNetworkPoolBackingList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNetworkPoolBackingOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_pool vcd_network_pool}
*/
export declare class DataVcdNetworkPool extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_network_pool";
    /**
    * Generates CDKTF code for importing a DataVcdNetworkPool resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNetworkPool to import
    * @param importFromId The id of the existing DataVcdNetworkPool that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_pool#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNetworkPool to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_pool vcd_network_pool} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNetworkPoolConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNetworkPoolConfig);
    private _backing;
    get backing(): DataVcdNetworkPoolBackingList;
    get description(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get networkProviderId(): string;
    get networkProviderName(): string;
    get networkProviderType(): string;
    get promiscuousMode(): cdktf.IResolvable;
    get status(): string;
    get totalBackingsCount(): number;
    get type(): string;
    get usedBackingsCount(): number;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
