import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNetworkRoutedV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Edge gateway name in which Routed network is located
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_routed_v2#edge_gateway_id DataVcdNetworkRoutedV2#edge_gateway_id}
    */
    readonly edgeGatewayId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_routed_v2#id DataVcdNetworkRoutedV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * A unique name for this network (optional if 'filter' is used)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_routed_v2#name DataVcdNetworkRoutedV2#name}
    */
    readonly name?: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_routed_v2#org DataVcdNetworkRoutedV2#org}
    */
    readonly org?: string;
    /**
    * The name of VDC to use, optional if defined at provider level
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_routed_v2#vdc DataVcdNetworkRoutedV2#vdc}
    */
    readonly vdc?: string;
    /**
    * filter block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_routed_v2#filter DataVcdNetworkRoutedV2#filter}
    */
    readonly filter?: DataVcdNetworkRoutedV2Filter;
}
export interface DataVcdNetworkRoutedV2MetadataEntry {
}
export declare function dataVcdNetworkRoutedV2MetadataEntryToTerraform(struct?: DataVcdNetworkRoutedV2MetadataEntry): any;
export declare function dataVcdNetworkRoutedV2MetadataEntryToHclTerraform(struct?: DataVcdNetworkRoutedV2MetadataEntry): any;
export declare class DataVcdNetworkRoutedV2MetadataEntryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNetworkRoutedV2MetadataEntry | undefined;
    set internalValue(value: DataVcdNetworkRoutedV2MetadataEntry | undefined);
    get isSystem(): cdktf.IResolvable;
    get key(): string;
    get type(): string;
    get userAccess(): string;
    get value(): string;
}
export declare class DataVcdNetworkRoutedV2MetadataEntryList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNetworkRoutedV2MetadataEntryOutputReference;
}
export interface DataVcdNetworkRoutedV2SecondaryStaticIpPool {
}
export declare function dataVcdNetworkRoutedV2SecondaryStaticIpPoolToTerraform(struct?: DataVcdNetworkRoutedV2SecondaryStaticIpPool): any;
export declare function dataVcdNetworkRoutedV2SecondaryStaticIpPoolToHclTerraform(struct?: DataVcdNetworkRoutedV2SecondaryStaticIpPool): any;
export declare class DataVcdNetworkRoutedV2SecondaryStaticIpPoolOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNetworkRoutedV2SecondaryStaticIpPool | undefined;
    set internalValue(value: DataVcdNetworkRoutedV2SecondaryStaticIpPool | undefined);
    get endAddress(): string;
    get startAddress(): string;
}
export declare class DataVcdNetworkRoutedV2SecondaryStaticIpPoolList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNetworkRoutedV2SecondaryStaticIpPoolOutputReference;
}
export interface DataVcdNetworkRoutedV2StaticIpPool {
}
export declare function dataVcdNetworkRoutedV2StaticIpPoolToTerraform(struct?: DataVcdNetworkRoutedV2StaticIpPool): any;
export declare function dataVcdNetworkRoutedV2StaticIpPoolToHclTerraform(struct?: DataVcdNetworkRoutedV2StaticIpPool): any;
export declare class DataVcdNetworkRoutedV2StaticIpPoolOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNetworkRoutedV2StaticIpPool | undefined;
    set internalValue(value: DataVcdNetworkRoutedV2StaticIpPool | undefined);
    get endAddress(): string;
    get startAddress(): string;
}
export declare class DataVcdNetworkRoutedV2StaticIpPoolList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNetworkRoutedV2StaticIpPoolOutputReference;
}
export interface DataVcdNetworkRoutedV2Filter {
    /**
    * Search by IP. The value can be a regular expression
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_routed_v2#ip DataVcdNetworkRoutedV2#ip}
    */
    readonly ip?: string;
    /**
    * Search by name with a regular expression
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_routed_v2#name_regex DataVcdNetworkRoutedV2#name_regex}
    */
    readonly nameRegex?: string;
}
export declare function dataVcdNetworkRoutedV2FilterToTerraform(struct?: DataVcdNetworkRoutedV2FilterOutputReference | DataVcdNetworkRoutedV2Filter): any;
export declare function dataVcdNetworkRoutedV2FilterToHclTerraform(struct?: DataVcdNetworkRoutedV2FilterOutputReference | DataVcdNetworkRoutedV2Filter): any;
export declare class DataVcdNetworkRoutedV2FilterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataVcdNetworkRoutedV2Filter | undefined;
    set internalValue(value: DataVcdNetworkRoutedV2Filter | undefined);
    private _ip?;
    get ip(): string;
    set ip(value: string);
    resetIp(): void;
    get ipInput(): string | undefined;
    private _nameRegex?;
    get nameRegex(): string;
    set nameRegex(value: string);
    resetNameRegex(): void;
    get nameRegexInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_routed_v2 vcd_network_routed_v2}
*/
export declare class DataVcdNetworkRoutedV2 extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_network_routed_v2";
    /**
    * Generates CDKTF code for importing a DataVcdNetworkRoutedV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNetworkRoutedV2 to import
    * @param importFromId The id of the existing DataVcdNetworkRoutedV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_routed_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNetworkRoutedV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_routed_v2 vcd_network_routed_v2} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNetworkRoutedV2Config = {}
    */
    constructor(scope: Construct, id: string, config?: DataVcdNetworkRoutedV2Config);
    get description(): string;
    get dns1(): string;
    get dns2(): string;
    get dnsSuffix(): string;
    get dualStackEnabled(): cdktf.IResolvable;
    private _edgeGatewayId?;
    get edgeGatewayId(): string;
    set edgeGatewayId(value: string);
    resetEdgeGatewayId(): void;
    get edgeGatewayIdInput(): string | undefined;
    get gateway(): string;
    get guestVlanAllowed(): cdktf.IResolvable;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get interfaceType(): string;
    private _metadata;
    get metadata(): cdktf.StringMap;
    private _metadataEntry;
    get metadataEntry(): DataVcdNetworkRoutedV2MetadataEntryList;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    get ownerId(): string;
    get prefixLength(): number;
    get routeAdvertisementEnabled(): cdktf.IResolvable;
    get secondaryGateway(): string;
    get secondaryPrefixLength(): string;
    private _secondaryStaticIpPool;
    get secondaryStaticIpPool(): DataVcdNetworkRoutedV2SecondaryStaticIpPoolList;
    private _staticIpPool;
    get staticIpPool(): DataVcdNetworkRoutedV2StaticIpPoolList;
    private _vdc?;
    get vdc(): string;
    set vdc(value: string);
    resetVdc(): void;
    get vdcInput(): string | undefined;
    private _filter;
    get filter(): DataVcdNetworkRoutedV2FilterOutputReference;
    putFilter(value: DataVcdNetworkRoutedV2Filter): void;
    resetFilter(): void;
    get filterInput(): DataVcdNetworkRoutedV2Filter | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
