import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNetworkRoutedConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_routed#id DataVcdNetworkRouted#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * A unique name for this network (optional if 'filter' is used)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_routed#name DataVcdNetworkRouted#name}
    */
    readonly name?: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_routed#org DataVcdNetworkRouted#org}
    */
    readonly org?: string;
    /**
    * The name of VDC to use, optional if defined at provider level
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_routed#vdc DataVcdNetworkRouted#vdc}
    */
    readonly vdc?: string;
    /**
    * filter block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_routed#filter DataVcdNetworkRouted#filter}
    */
    readonly filter?: DataVcdNetworkRoutedFilter;
}
export interface DataVcdNetworkRoutedDhcpPool {
}
export declare function dataVcdNetworkRoutedDhcpPoolToTerraform(struct?: DataVcdNetworkRoutedDhcpPool): any;
export declare function dataVcdNetworkRoutedDhcpPoolToHclTerraform(struct?: DataVcdNetworkRoutedDhcpPool): any;
export declare class DataVcdNetworkRoutedDhcpPoolOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNetworkRoutedDhcpPool | undefined;
    set internalValue(value: DataVcdNetworkRoutedDhcpPool | undefined);
    get defaultLeaseTime(): number;
    get endAddress(): string;
    get maxLeaseTime(): number;
    get startAddress(): string;
}
export declare class DataVcdNetworkRoutedDhcpPoolList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNetworkRoutedDhcpPoolOutputReference;
}
export interface DataVcdNetworkRoutedMetadataEntry {
}
export declare function dataVcdNetworkRoutedMetadataEntryToTerraform(struct?: DataVcdNetworkRoutedMetadataEntry): any;
export declare function dataVcdNetworkRoutedMetadataEntryToHclTerraform(struct?: DataVcdNetworkRoutedMetadataEntry): any;
export declare class DataVcdNetworkRoutedMetadataEntryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNetworkRoutedMetadataEntry | undefined;
    set internalValue(value: DataVcdNetworkRoutedMetadataEntry | undefined);
    get isSystem(): cdktf.IResolvable;
    get key(): string;
    get type(): string;
    get userAccess(): string;
    get value(): string;
}
export declare class DataVcdNetworkRoutedMetadataEntryList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNetworkRoutedMetadataEntryOutputReference;
}
export interface DataVcdNetworkRoutedStaticIpPool {
}
export declare function dataVcdNetworkRoutedStaticIpPoolToTerraform(struct?: DataVcdNetworkRoutedStaticIpPool): any;
export declare function dataVcdNetworkRoutedStaticIpPoolToHclTerraform(struct?: DataVcdNetworkRoutedStaticIpPool): any;
export declare class DataVcdNetworkRoutedStaticIpPoolOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNetworkRoutedStaticIpPool | undefined;
    set internalValue(value: DataVcdNetworkRoutedStaticIpPool | undefined);
    get endAddress(): string;
    get startAddress(): string;
}
export declare class DataVcdNetworkRoutedStaticIpPoolList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNetworkRoutedStaticIpPoolOutputReference;
}
export interface DataVcdNetworkRoutedFilterMetadata {
    /**
    * True if is a metadata@SYSTEM key
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_routed#is_system DataVcdNetworkRouted#is_system}
    */
    readonly isSystem?: boolean | cdktf.IResolvable;
    /**
    * Metadata key (field name)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_routed#key DataVcdNetworkRouted#key}
    */
    readonly key: string;
    /**
    * Type of metadata value (needed only if "use_api_search" is true)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_routed#type DataVcdNetworkRouted#type}
    */
    readonly type?: string;
    /**
    * If true, will search the vCD using native metadata query (without regular expressions)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_routed#use_api_search DataVcdNetworkRouted#use_api_search}
    */
    readonly useApiSearch?: boolean | cdktf.IResolvable;
    /**
    * Metadata value (can be a regular expression if "use_api_search" is false)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_routed#value DataVcdNetworkRouted#value}
    */
    readonly value: string;
}
export declare function dataVcdNetworkRoutedFilterMetadataToTerraform(struct?: DataVcdNetworkRoutedFilterMetadata | cdktf.IResolvable): any;
export declare function dataVcdNetworkRoutedFilterMetadataToHclTerraform(struct?: DataVcdNetworkRoutedFilterMetadata | cdktf.IResolvable): any;
export declare class DataVcdNetworkRoutedFilterMetadataOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNetworkRoutedFilterMetadata | cdktf.IResolvable | undefined;
    set internalValue(value: DataVcdNetworkRoutedFilterMetadata | cdktf.IResolvable | undefined);
    private _isSystem?;
    get isSystem(): boolean | cdktf.IResolvable;
    set isSystem(value: boolean | cdktf.IResolvable);
    resetIsSystem(): void;
    get isSystemInput(): boolean | cdktf.IResolvable | undefined;
    private _key?;
    get key(): string;
    set key(value: string);
    get keyInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _useApiSearch?;
    get useApiSearch(): boolean | cdktf.IResolvable;
    set useApiSearch(value: boolean | cdktf.IResolvable);
    resetUseApiSearch(): void;
    get useApiSearchInput(): boolean | cdktf.IResolvable | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    get valueInput(): string | undefined;
}
export declare class DataVcdNetworkRoutedFilterMetadataList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataVcdNetworkRoutedFilterMetadata[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNetworkRoutedFilterMetadataOutputReference;
}
export interface DataVcdNetworkRoutedFilter {
    /**
    * Search by IP. The value can be a regular expression
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_routed#ip DataVcdNetworkRouted#ip}
    */
    readonly ip?: string;
    /**
    * Search by name with a regular expression
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_routed#name_regex DataVcdNetworkRouted#name_regex}
    */
    readonly nameRegex?: string;
    /**
    * metadata block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_routed#metadata DataVcdNetworkRouted#metadata}
    */
    readonly metadata?: DataVcdNetworkRoutedFilterMetadata[] | cdktf.IResolvable;
}
export declare function dataVcdNetworkRoutedFilterToTerraform(struct?: DataVcdNetworkRoutedFilterOutputReference | DataVcdNetworkRoutedFilter): any;
export declare function dataVcdNetworkRoutedFilterToHclTerraform(struct?: DataVcdNetworkRoutedFilterOutputReference | DataVcdNetworkRoutedFilter): any;
export declare class DataVcdNetworkRoutedFilterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataVcdNetworkRoutedFilter | undefined;
    set internalValue(value: DataVcdNetworkRoutedFilter | undefined);
    private _ip?;
    get ip(): string;
    set ip(value: string);
    resetIp(): void;
    get ipInput(): string | undefined;
    private _nameRegex?;
    get nameRegex(): string;
    set nameRegex(value: string);
    resetNameRegex(): void;
    get nameRegexInput(): string | undefined;
    private _metadata;
    get metadata(): DataVcdNetworkRoutedFilterMetadataList;
    putMetadata(value: DataVcdNetworkRoutedFilterMetadata[] | cdktf.IResolvable): void;
    resetMetadata(): void;
    get metadataInput(): cdktf.IResolvable | DataVcdNetworkRoutedFilterMetadata[] | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_routed vcd_network_routed}
*/
export declare class DataVcdNetworkRouted extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_network_routed";
    /**
    * Generates CDKTF code for importing a DataVcdNetworkRouted resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNetworkRouted to import
    * @param importFromId The id of the existing DataVcdNetworkRouted that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_routed#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNetworkRouted to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/network_routed vcd_network_routed} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNetworkRoutedConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataVcdNetworkRoutedConfig);
    get description(): string;
    private _dhcpPool;
    get dhcpPool(): DataVcdNetworkRoutedDhcpPoolList;
    get dns1(): string;
    get dns2(): string;
    get dnsSuffix(): string;
    get edgeGateway(): string;
    get gateway(): string;
    get href(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get interfaceType(): string;
    private _metadata;
    get metadata(): cdktf.StringMap;
    private _metadataEntry;
    get metadataEntry(): DataVcdNetworkRoutedMetadataEntryList;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get netmask(): string;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    get shared(): cdktf.IResolvable;
    private _staticIpPool;
    get staticIpPool(): DataVcdNetworkRoutedStaticIpPoolList;
    private _vdc?;
    get vdc(): string;
    set vdc(value: string);
    resetVdc(): void;
    get vdcInput(): string | undefined;
    private _filter;
    get filter(): DataVcdNetworkRoutedFilterOutputReference;
    putFilter(value: DataVcdNetworkRoutedFilter): void;
    resetFilter(): void;
    get filterInput(): DataVcdNetworkRoutedFilter | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
