import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxtAlbEdgegatewayServiceEngineGroupConfig extends cdktf.TerraformMetaArguments {
    /**
    * Edge Gateway ID in which ALB Service Engine Group should be located
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_edgegateway_service_engine_group#edge_gateway_id DataVcdNsxtAlbEdgegatewayServiceEngineGroup#edge_gateway_id}
    */
    readonly edgeGatewayId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_edgegateway_service_engine_group#id DataVcdNsxtAlbEdgegatewayServiceEngineGroup#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_edgegateway_service_engine_group#org DataVcdNsxtAlbEdgegatewayServiceEngineGroup#org}
    */
    readonly org?: string;
    /**
    * Service Engine Group ID which is attached to NSX-T Edge Gateway
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_edgegateway_service_engine_group#service_engine_group_id DataVcdNsxtAlbEdgegatewayServiceEngineGroup#service_engine_group_id}
    */
    readonly serviceEngineGroupId?: string;
    /**
    * Service Engine Group Name which is attached to NSX-T Edge Gateway
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_edgegateway_service_engine_group#service_engine_group_name DataVcdNsxtAlbEdgegatewayServiceEngineGroup#service_engine_group_name}
    */
    readonly serviceEngineGroupName?: string;
    /**
    * The name of VDC to use, optional if defined at provider level
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_edgegateway_service_engine_group#vdc DataVcdNsxtAlbEdgegatewayServiceEngineGroup#vdc}
    */
    readonly vdc?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_edgegateway_service_engine_group vcd_nsxt_alb_edgegateway_service_engine_group}
*/
export declare class DataVcdNsxtAlbEdgegatewayServiceEngineGroup extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxt_alb_edgegateway_service_engine_group";
    /**
    * Generates CDKTF code for importing a DataVcdNsxtAlbEdgegatewayServiceEngineGroup resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxtAlbEdgegatewayServiceEngineGroup to import
    * @param importFromId The id of the existing DataVcdNsxtAlbEdgegatewayServiceEngineGroup that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_edgegateway_service_engine_group#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxtAlbEdgegatewayServiceEngineGroup to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_edgegateway_service_engine_group vcd_nsxt_alb_edgegateway_service_engine_group} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxtAlbEdgegatewayServiceEngineGroupConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNsxtAlbEdgegatewayServiceEngineGroupConfig);
    get deployedVirtualServices(): number;
    private _edgeGatewayId?;
    get edgeGatewayId(): string;
    set edgeGatewayId(value: string);
    get edgeGatewayIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get maxVirtualServices(): number;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    get reservedVirtualServices(): string;
    private _serviceEngineGroupId?;
    get serviceEngineGroupId(): string;
    set serviceEngineGroupId(value: string);
    resetServiceEngineGroupId(): void;
    get serviceEngineGroupIdInput(): string | undefined;
    private _serviceEngineGroupName?;
    get serviceEngineGroupName(): string;
    set serviceEngineGroupName(value: string);
    resetServiceEngineGroupName(): void;
    get serviceEngineGroupNameInput(): string | undefined;
    private _vdc?;
    get vdc(): string;
    set vdc(value: string);
    resetVdc(): void;
    get vdcInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
