import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxtAlbImportableCloudConfig extends cdktf.TerraformMetaArguments {
    /**
    * NSX-T ALB Controller ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_importable_cloud#controller_id DataVcdNsxtAlbImportableCloud#controller_id}
    */
    readonly controllerId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_importable_cloud#id DataVcdNsxtAlbImportableCloud#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * NSX-T ALB Importable Cloud Name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_importable_cloud#name DataVcdNsxtAlbImportableCloud#name}
    */
    readonly name: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_importable_cloud vcd_nsxt_alb_importable_cloud}
*/
export declare class DataVcdNsxtAlbImportableCloud extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxt_alb_importable_cloud";
    /**
    * Generates CDKTF code for importing a DataVcdNsxtAlbImportableCloud resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxtAlbImportableCloud to import
    * @param importFromId The id of the existing DataVcdNsxtAlbImportableCloud that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_importable_cloud#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxtAlbImportableCloud to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_importable_cloud vcd_nsxt_alb_importable_cloud} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxtAlbImportableCloudConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNsxtAlbImportableCloudConfig);
    get alreadyImported(): cdktf.IResolvable;
    private _controllerId?;
    get controllerId(): string;
    set controllerId(value: string);
    get controllerIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get networkPoolId(): string;
    get networkPoolName(): string;
    get transportZoneName(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
