import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxtAlbPoolConfig extends cdktf.TerraformMetaArguments {
    /**
    * IDs of associated virtual services
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_pool#associated_virtual_service_ids DataVcdNsxtAlbPool#associated_virtual_service_ids}
    */
    readonly associatedVirtualServiceIds?: string[];
    /**
    * Edge gateway ID in which ALB Pool should be created
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_pool#edge_gateway_id DataVcdNsxtAlbPool#edge_gateway_id}
    */
    readonly edgeGatewayId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_pool#id DataVcdNsxtAlbPool#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Name of ALB Pool
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_pool#name DataVcdNsxtAlbPool#name}
    */
    readonly name: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_pool#org DataVcdNsxtAlbPool#org}
    */
    readonly org?: string;
    /**
    * Monitors if the traffic is accepted by node (default true)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_pool#passive_monitoring_enabled DataVcdNsxtAlbPool#passive_monitoring_enabled}
    */
    readonly passiveMonitoringEnabled?: boolean | cdktf.IResolvable;
    /**
    * The name of VDC to use, optional if defined at provider level
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_pool#vdc DataVcdNsxtAlbPool#vdc}
    */
    readonly vdc?: string;
}
export interface DataVcdNsxtAlbPoolHealthMonitor {
}
export declare function dataVcdNsxtAlbPoolHealthMonitorToTerraform(struct?: DataVcdNsxtAlbPoolHealthMonitor): any;
export declare function dataVcdNsxtAlbPoolHealthMonitorToHclTerraform(struct?: DataVcdNsxtAlbPoolHealthMonitor): any;
export declare class DataVcdNsxtAlbPoolHealthMonitorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbPoolHealthMonitor | undefined;
    set internalValue(value: DataVcdNsxtAlbPoolHealthMonitor | undefined);
    get name(): string;
    get systemDefined(): cdktf.IResolvable;
    get type(): string;
}
export declare class DataVcdNsxtAlbPoolHealthMonitorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbPoolHealthMonitorOutputReference;
}
export interface DataVcdNsxtAlbPoolMember {
}
export declare function dataVcdNsxtAlbPoolMemberToTerraform(struct?: DataVcdNsxtAlbPoolMember): any;
export declare function dataVcdNsxtAlbPoolMemberToHclTerraform(struct?: DataVcdNsxtAlbPoolMember): any;
export declare class DataVcdNsxtAlbPoolMemberOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbPoolMember | undefined;
    set internalValue(value: DataVcdNsxtAlbPoolMember | undefined);
    get detailedHealthMessage(): string;
    get enabled(): cdktf.IResolvable;
    get healthStatus(): string;
    get ipAddress(): string;
    get markedDownBy(): string[];
    get port(): number;
    get ratio(): number;
}
export declare class DataVcdNsxtAlbPoolMemberList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbPoolMemberOutputReference;
}
export interface DataVcdNsxtAlbPoolPersistenceProfile {
}
export declare function dataVcdNsxtAlbPoolPersistenceProfileToTerraform(struct?: DataVcdNsxtAlbPoolPersistenceProfile): any;
export declare function dataVcdNsxtAlbPoolPersistenceProfileToHclTerraform(struct?: DataVcdNsxtAlbPoolPersistenceProfile): any;
export declare class DataVcdNsxtAlbPoolPersistenceProfileOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtAlbPoolPersistenceProfile | undefined;
    set internalValue(value: DataVcdNsxtAlbPoolPersistenceProfile | undefined);
    get name(): string;
    get type(): string;
    get value(): string;
}
export declare class DataVcdNsxtAlbPoolPersistenceProfileList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtAlbPoolPersistenceProfileOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_pool vcd_nsxt_alb_pool}
*/
export declare class DataVcdNsxtAlbPool extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxt_alb_pool";
    /**
    * Generates CDKTF code for importing a DataVcdNsxtAlbPool resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxtAlbPool to import
    * @param importFromId The id of the existing DataVcdNsxtAlbPool that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_pool#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxtAlbPool to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_pool vcd_nsxt_alb_pool} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxtAlbPoolConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNsxtAlbPoolConfig);
    get algorithm(): string;
    private _associatedVirtualServiceIds?;
    get associatedVirtualServiceIds(): string[];
    set associatedVirtualServiceIds(value: string[]);
    resetAssociatedVirtualServiceIds(): void;
    get associatedVirtualServiceIdsInput(): string[] | undefined;
    get associatedVirtualServices(): string[];
    get caCertificateIds(): string[];
    get cnCheckEnabled(): cdktf.IResolvable;
    get defaultPort(): number;
    get description(): string;
    get domainNames(): string[];
    private _edgeGatewayId?;
    get edgeGatewayId(): string;
    set edgeGatewayId(value: string);
    get edgeGatewayIdInput(): string | undefined;
    get enabled(): cdktf.IResolvable;
    get enabledMemberCount(): number;
    get gracefulTimeoutPeriod(): number;
    get healthMessage(): string;
    private _healthMonitor;
    get healthMonitor(): DataVcdNsxtAlbPoolHealthMonitorList;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _member;
    get member(): DataVcdNsxtAlbPoolMemberList;
    get memberCount(): number;
    get memberGroupId(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    private _passiveMonitoringEnabled?;
    get passiveMonitoringEnabled(): boolean | cdktf.IResolvable;
    set passiveMonitoringEnabled(value: boolean | cdktf.IResolvable);
    resetPassiveMonitoringEnabled(): void;
    get passiveMonitoringEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _persistenceProfile;
    get persistenceProfile(): DataVcdNsxtAlbPoolPersistenceProfileList;
    get sslEnabled(): cdktf.IResolvable;
    get upMemberCount(): number;
    private _vdc?;
    get vdc(): string;
    set vdc(value: string);
    resetVdc(): void;
    get vdcInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
