import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxtAlbServiceEngineGroupConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_service_engine_group#id DataVcdNsxtAlbServiceEngineGroup#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * NSX-T ALB Service Engine Group name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_service_engine_group#name DataVcdNsxtAlbServiceEngineGroup#name}
    */
    readonly name: string;
    /**
    * Boolean value that shows if virtual services are overallocated
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_service_engine_group#overallocated DataVcdNsxtAlbServiceEngineGroup#overallocated}
    */
    readonly overallocated?: boolean | cdktf.IResolvable;
    /**
    * Boolean value that shows if sync should be performed on every refresh
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_service_engine_group#sync_on_refresh DataVcdNsxtAlbServiceEngineGroup#sync_on_refresh}
    */
    readonly syncOnRefresh?: boolean | cdktf.IResolvable;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_service_engine_group vcd_nsxt_alb_service_engine_group}
*/
export declare class DataVcdNsxtAlbServiceEngineGroup extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxt_alb_service_engine_group";
    /**
    * Generates CDKTF code for importing a DataVcdNsxtAlbServiceEngineGroup resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxtAlbServiceEngineGroup to import
    * @param importFromId The id of the existing DataVcdNsxtAlbServiceEngineGroup that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_service_engine_group#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxtAlbServiceEngineGroup to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_service_engine_group vcd_nsxt_alb_service_engine_group} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxtAlbServiceEngineGroupConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNsxtAlbServiceEngineGroupConfig);
    get albCloudId(): string;
    get deployedVirtualServices(): number;
    get description(): string;
    get haMode(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get maxVirtualServices(): number;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _overallocated?;
    get overallocated(): boolean | cdktf.IResolvable;
    set overallocated(value: boolean | cdktf.IResolvable);
    resetOverallocated(): void;
    get overallocatedInput(): boolean | cdktf.IResolvable | undefined;
    get reservationModel(): string;
    get reservedVirtualServices(): number;
    get supportedFeatureSet(): string;
    private _syncOnRefresh?;
    get syncOnRefresh(): boolean | cdktf.IResolvable;
    set syncOnRefresh(value: boolean | cdktf.IResolvable);
    resetSyncOnRefresh(): void;
    get syncOnRefreshInput(): boolean | cdktf.IResolvable | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
