import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxtAlbSettingsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Edge gateway ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_settings#edge_gateway_id DataVcdNsxtAlbSettings#edge_gateway_id}
    */
    readonly edgeGatewayId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_settings#id DataVcdNsxtAlbSettings#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_settings#org DataVcdNsxtAlbSettings#org}
    */
    readonly org?: string;
    /**
    * Optional custom network CIDR definition for ALB Service Engine placement (VCD default is 192.168.255.1/25)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_settings#service_network_specification DataVcdNsxtAlbSettings#service_network_specification}
    */
    readonly serviceNetworkSpecification?: string;
    /**
    * The name of VDC to use, optional if defined at provider level
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_settings#vdc DataVcdNsxtAlbSettings#vdc}
    */
    readonly vdc?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_settings vcd_nsxt_alb_settings}
*/
export declare class DataVcdNsxtAlbSettings extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxt_alb_settings";
    /**
    * Generates CDKTF code for importing a DataVcdNsxtAlbSettings resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxtAlbSettings to import
    * @param importFromId The id of the existing DataVcdNsxtAlbSettings that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_settings#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxtAlbSettings to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_alb_settings vcd_nsxt_alb_settings} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxtAlbSettingsConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNsxtAlbSettingsConfig);
    private _edgeGatewayId?;
    get edgeGatewayId(): string;
    set edgeGatewayId(value: string);
    get edgeGatewayIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get ipv6ServiceNetworkSpecification(): string;
    get isActive(): cdktf.IResolvable;
    get isTransparentModeEnabled(): cdktf.IResolvable;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    private _serviceNetworkSpecification?;
    get serviceNetworkSpecification(): string;
    set serviceNetworkSpecification(value: string);
    resetServiceNetworkSpecification(): void;
    get serviceNetworkSpecificationInput(): string | undefined;
    get supportedFeatureSet(): string;
    private _vdc?;
    get vdc(): string;
    set vdc(value: string);
    resetVdc(): void;
    get vdcInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
