import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxtDistributedFirewallRuleAConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_distributed_firewall_rule#id DataVcdNsxtDistributedFirewallRuleA#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Firewall Rule name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_distributed_firewall_rule#name DataVcdNsxtDistributedFirewallRuleA#name}
    */
    readonly name: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_distributed_firewall_rule#org DataVcdNsxtDistributedFirewallRuleA#org}
    */
    readonly org?: string;
    /**
    * ID of VDC Group for Distributed Firewall
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_distributed_firewall_rule#vdc_group_id DataVcdNsxtDistributedFirewallRuleA#vdc_group_id}
    */
    readonly vdcGroupId: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_distributed_firewall_rule vcd_nsxt_distributed_firewall_rule}
*/
export declare class DataVcdNsxtDistributedFirewallRuleA extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxt_distributed_firewall_rule";
    /**
    * Generates CDKTF code for importing a DataVcdNsxtDistributedFirewallRuleA resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxtDistributedFirewallRuleA to import
    * @param importFromId The id of the existing DataVcdNsxtDistributedFirewallRuleA that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_distributed_firewall_rule#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxtDistributedFirewallRuleA to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_distributed_firewall_rule vcd_nsxt_distributed_firewall_rule} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxtDistributedFirewallRuleAConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNsxtDistributedFirewallRuleAConfig);
    get action(): string;
    get appPortProfileIds(): string[];
    get comment(): string;
    get description(): string;
    get destinationGroupsExcluded(): cdktf.IResolvable;
    get destinationIds(): string[];
    get direction(): string;
    get enabled(): cdktf.IResolvable;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get ipProtocol(): string;
    get logging(): cdktf.IResolvable;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get networkContextProfileIds(): string[];
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    get sourceGroupsExcluded(): cdktf.IResolvable;
    get sourceIds(): string[];
    private _vdcGroupId?;
    get vdcGroupId(): string;
    set vdcGroupId(value: string);
    get vdcGroupIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
