import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxtDistributedFirewallConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_distributed_firewall#id DataVcdNsxtDistributedFirewall#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_distributed_firewall#org DataVcdNsxtDistributedFirewall#org}
    */
    readonly org?: string;
    /**
    * The ID of VDC Group
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_distributed_firewall#vdc_group_id DataVcdNsxtDistributedFirewall#vdc_group_id}
    */
    readonly vdcGroupId: string;
}
export interface DataVcdNsxtDistributedFirewallRule {
}
export declare function dataVcdNsxtDistributedFirewallRuleToTerraform(struct?: DataVcdNsxtDistributedFirewallRule): any;
export declare function dataVcdNsxtDistributedFirewallRuleToHclTerraform(struct?: DataVcdNsxtDistributedFirewallRule): any;
export declare class DataVcdNsxtDistributedFirewallRuleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtDistributedFirewallRule | undefined;
    set internalValue(value: DataVcdNsxtDistributedFirewallRule | undefined);
    get action(): string;
    get appPortProfileIds(): string[];
    get comment(): string;
    get description(): string;
    get destinationGroupsExcluded(): cdktf.IResolvable;
    get destinationIds(): string[];
    get direction(): string;
    get enabled(): cdktf.IResolvable;
    get id(): string;
    get ipProtocol(): string;
    get logging(): cdktf.IResolvable;
    get name(): string;
    get networkContextProfileIds(): string[];
    get sourceGroupsExcluded(): cdktf.IResolvable;
    get sourceIds(): string[];
}
export declare class DataVcdNsxtDistributedFirewallRuleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtDistributedFirewallRuleOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_distributed_firewall vcd_nsxt_distributed_firewall}
*/
export declare class DataVcdNsxtDistributedFirewall extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxt_distributed_firewall";
    /**
    * Generates CDKTF code for importing a DataVcdNsxtDistributedFirewall resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxtDistributedFirewall to import
    * @param importFromId The id of the existing DataVcdNsxtDistributedFirewall that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_distributed_firewall#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxtDistributedFirewall to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_distributed_firewall vcd_nsxt_distributed_firewall} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxtDistributedFirewallConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNsxtDistributedFirewallConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    private _rule;
    get rule(): DataVcdNsxtDistributedFirewallRuleList;
    private _vdcGroupId?;
    get vdcGroupId(): string;
    set vdcGroupId(value: string);
    get vdcGroupIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
