import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxtDynamicSecurityGroupConfig extends cdktf.TerraformMetaArguments {
    /**
    * Dynamic Security Group description
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_dynamic_security_group#description DataVcdNsxtDynamicSecurityGroup#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_dynamic_security_group#id DataVcdNsxtDynamicSecurityGroup#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Dynamic Security Group name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_dynamic_security_group#name DataVcdNsxtDynamicSecurityGroup#name}
    */
    readonly name: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_dynamic_security_group#org DataVcdNsxtDynamicSecurityGroup#org}
    */
    readonly org?: string;
    /**
    * VDC Group ID in which Dynamic Security Group is located
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_dynamic_security_group#vdc_group_id DataVcdNsxtDynamicSecurityGroup#vdc_group_id}
    */
    readonly vdcGroupId: string;
}
export interface DataVcdNsxtDynamicSecurityGroupCriteriaRule {
}
export declare function dataVcdNsxtDynamicSecurityGroupCriteriaRuleToTerraform(struct?: DataVcdNsxtDynamicSecurityGroupCriteriaRule): any;
export declare function dataVcdNsxtDynamicSecurityGroupCriteriaRuleToHclTerraform(struct?: DataVcdNsxtDynamicSecurityGroupCriteriaRule): any;
export declare class DataVcdNsxtDynamicSecurityGroupCriteriaRuleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtDynamicSecurityGroupCriteriaRule | undefined;
    set internalValue(value: DataVcdNsxtDynamicSecurityGroupCriteriaRule | undefined);
    get operator(): string;
    get type(): string;
    get value(): string;
}
export declare class DataVcdNsxtDynamicSecurityGroupCriteriaRuleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtDynamicSecurityGroupCriteriaRuleOutputReference;
}
export interface DataVcdNsxtDynamicSecurityGroupCriteria {
}
export declare function dataVcdNsxtDynamicSecurityGroupCriteriaToTerraform(struct?: DataVcdNsxtDynamicSecurityGroupCriteria): any;
export declare function dataVcdNsxtDynamicSecurityGroupCriteriaToHclTerraform(struct?: DataVcdNsxtDynamicSecurityGroupCriteria): any;
export declare class DataVcdNsxtDynamicSecurityGroupCriteriaOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtDynamicSecurityGroupCriteria | undefined;
    set internalValue(value: DataVcdNsxtDynamicSecurityGroupCriteria | undefined);
    private _rule;
    get rule(): DataVcdNsxtDynamicSecurityGroupCriteriaRuleList;
}
export declare class DataVcdNsxtDynamicSecurityGroupCriteriaList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtDynamicSecurityGroupCriteriaOutputReference;
}
export interface DataVcdNsxtDynamicSecurityGroupMemberVms {
}
export declare function dataVcdNsxtDynamicSecurityGroupMemberVmsToTerraform(struct?: DataVcdNsxtDynamicSecurityGroupMemberVms): any;
export declare function dataVcdNsxtDynamicSecurityGroupMemberVmsToHclTerraform(struct?: DataVcdNsxtDynamicSecurityGroupMemberVms): any;
export declare class DataVcdNsxtDynamicSecurityGroupMemberVmsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtDynamicSecurityGroupMemberVms | undefined;
    set internalValue(value: DataVcdNsxtDynamicSecurityGroupMemberVms | undefined);
    get vappId(): string;
    get vappName(): string;
    get vmId(): string;
    get vmName(): string;
}
export declare class DataVcdNsxtDynamicSecurityGroupMemberVmsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtDynamicSecurityGroupMemberVmsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_dynamic_security_group vcd_nsxt_dynamic_security_group}
*/
export declare class DataVcdNsxtDynamicSecurityGroup extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxt_dynamic_security_group";
    /**
    * Generates CDKTF code for importing a DataVcdNsxtDynamicSecurityGroup resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxtDynamicSecurityGroup to import
    * @param importFromId The id of the existing DataVcdNsxtDynamicSecurityGroup that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_dynamic_security_group#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxtDynamicSecurityGroup to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_dynamic_security_group vcd_nsxt_dynamic_security_group} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxtDynamicSecurityGroupConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNsxtDynamicSecurityGroupConfig);
    private _criteria;
    get criteria(): DataVcdNsxtDynamicSecurityGroupCriteriaList;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _memberVms;
    get memberVms(): DataVcdNsxtDynamicSecurityGroupMemberVmsList;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    private _vdcGroupId?;
    get vdcGroupId(): string;
    set vdcGroupId(value: string);
    get vdcGroupIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
