import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxtEdgegatewayBgpIpPrefixListConfig extends cdktf.TerraformMetaArguments {
    /**
    * Edge gateway ID for BGP IP Prefix List Configuration
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway_bgp_ip_prefix_list#edge_gateway_id DataVcdNsxtEdgegatewayBgpIpPrefixList#edge_gateway_id}
    */
    readonly edgeGatewayId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway_bgp_ip_prefix_list#id DataVcdNsxtEdgegatewayBgpIpPrefixList#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * BGP IP Prefix List name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway_bgp_ip_prefix_list#name DataVcdNsxtEdgegatewayBgpIpPrefixList#name}
    */
    readonly name: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway_bgp_ip_prefix_list#org DataVcdNsxtEdgegatewayBgpIpPrefixList#org}
    */
    readonly org?: string;
}
export interface DataVcdNsxtEdgegatewayBgpIpPrefixListIpPrefix {
}
export declare function dataVcdNsxtEdgegatewayBgpIpPrefixListIpPrefixToTerraform(struct?: DataVcdNsxtEdgegatewayBgpIpPrefixListIpPrefix): any;
export declare function dataVcdNsxtEdgegatewayBgpIpPrefixListIpPrefixToHclTerraform(struct?: DataVcdNsxtEdgegatewayBgpIpPrefixListIpPrefix): any;
export declare class DataVcdNsxtEdgegatewayBgpIpPrefixListIpPrefixOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtEdgegatewayBgpIpPrefixListIpPrefix | undefined;
    set internalValue(value: DataVcdNsxtEdgegatewayBgpIpPrefixListIpPrefix | undefined);
    get action(): string;
    get greaterThanOrEqualTo(): number;
    get lessThanOrEqualTo(): number;
    get network(): string;
}
export declare class DataVcdNsxtEdgegatewayBgpIpPrefixListIpPrefixList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtEdgegatewayBgpIpPrefixListIpPrefixOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway_bgp_ip_prefix_list vcd_nsxt_edgegateway_bgp_ip_prefix_list}
*/
export declare class DataVcdNsxtEdgegatewayBgpIpPrefixList extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxt_edgegateway_bgp_ip_prefix_list";
    /**
    * Generates CDKTF code for importing a DataVcdNsxtEdgegatewayBgpIpPrefixList resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxtEdgegatewayBgpIpPrefixList to import
    * @param importFromId The id of the existing DataVcdNsxtEdgegatewayBgpIpPrefixList that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway_bgp_ip_prefix_list#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxtEdgegatewayBgpIpPrefixList to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway_bgp_ip_prefix_list vcd_nsxt_edgegateway_bgp_ip_prefix_list} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxtEdgegatewayBgpIpPrefixListConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNsxtEdgegatewayBgpIpPrefixListConfig);
    get description(): string;
    private _edgeGatewayId?;
    get edgeGatewayId(): string;
    set edgeGatewayId(value: string);
    get edgeGatewayIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _ipPrefix;
    get ipPrefix(): DataVcdNsxtEdgegatewayBgpIpPrefixListIpPrefixList;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
