import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxtEdgegatewayBgpNeighborConfig extends cdktf.TerraformMetaArguments {
    /**
    * Edge gateway ID for BGP Neighbor Configuration
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway_bgp_neighbor#edge_gateway_id DataVcdNsxtEdgegatewayBgpNeighbor#edge_gateway_id}
    */
    readonly edgeGatewayId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway_bgp_neighbor#id DataVcdNsxtEdgegatewayBgpNeighbor#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * BGP Neighbor IP address (IPv4 or IPv6)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway_bgp_neighbor#ip_address DataVcdNsxtEdgegatewayBgpNeighbor#ip_address}
    */
    readonly ipAddress: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway_bgp_neighbor#org DataVcdNsxtEdgegatewayBgpNeighbor#org}
    */
    readonly org?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway_bgp_neighbor vcd_nsxt_edgegateway_bgp_neighbor}
*/
export declare class DataVcdNsxtEdgegatewayBgpNeighbor extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxt_edgegateway_bgp_neighbor";
    /**
    * Generates CDKTF code for importing a DataVcdNsxtEdgegatewayBgpNeighbor resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxtEdgegatewayBgpNeighbor to import
    * @param importFromId The id of the existing DataVcdNsxtEdgegatewayBgpNeighbor that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway_bgp_neighbor#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxtEdgegatewayBgpNeighbor to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway_bgp_neighbor vcd_nsxt_edgegateway_bgp_neighbor} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxtEdgegatewayBgpNeighborConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNsxtEdgegatewayBgpNeighborConfig);
    get allowAsIn(): cdktf.IResolvable;
    get bfdDeadMultiple(): number;
    get bfdEnabled(): cdktf.IResolvable;
    get bfdInterval(): number;
    private _edgeGatewayId?;
    get edgeGatewayId(): string;
    set edgeGatewayId(value: string);
    get edgeGatewayIdInput(): string | undefined;
    get gracefulRestartMode(): string;
    get holdDownTimer(): number;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get inFilterIpPrefixListId(): string;
    private _ipAddress?;
    get ipAddress(): string;
    set ipAddress(value: string);
    get ipAddressInput(): string | undefined;
    get keepAliveTimer(): number;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    get outFilterIpPrefixListId(): string;
    get password(): string;
    get remoteAsNumber(): string;
    get routeFiltering(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
