import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxtEdgegatewayDnsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Edge gateway ID for DNS configuration
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway_dns#edge_gateway_id DataVcdNsxtEdgegatewayDns#edge_gateway_id}
    */
    readonly edgeGatewayId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway_dns#id DataVcdNsxtEdgegatewayDns#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway_dns#org DataVcdNsxtEdgegatewayDns#org}
    */
    readonly org?: string;
}
export interface DataVcdNsxtEdgegatewayDnsConditionalForwarderZone {
}
export declare function dataVcdNsxtEdgegatewayDnsConditionalForwarderZoneToTerraform(struct?: DataVcdNsxtEdgegatewayDnsConditionalForwarderZone): any;
export declare function dataVcdNsxtEdgegatewayDnsConditionalForwarderZoneToHclTerraform(struct?: DataVcdNsxtEdgegatewayDnsConditionalForwarderZone): any;
export declare class DataVcdNsxtEdgegatewayDnsConditionalForwarderZoneOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtEdgegatewayDnsConditionalForwarderZone | undefined;
    set internalValue(value: DataVcdNsxtEdgegatewayDnsConditionalForwarderZone | undefined);
    get domainNames(): string[];
    get id(): string;
    get name(): string;
    get upstreamServers(): string[];
}
export declare class DataVcdNsxtEdgegatewayDnsConditionalForwarderZoneList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtEdgegatewayDnsConditionalForwarderZoneOutputReference;
}
export interface DataVcdNsxtEdgegatewayDnsDefaultForwarderZone {
}
export declare function dataVcdNsxtEdgegatewayDnsDefaultForwarderZoneToTerraform(struct?: DataVcdNsxtEdgegatewayDnsDefaultForwarderZone): any;
export declare function dataVcdNsxtEdgegatewayDnsDefaultForwarderZoneToHclTerraform(struct?: DataVcdNsxtEdgegatewayDnsDefaultForwarderZone): any;
export declare class DataVcdNsxtEdgegatewayDnsDefaultForwarderZoneOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtEdgegatewayDnsDefaultForwarderZone | undefined;
    set internalValue(value: DataVcdNsxtEdgegatewayDnsDefaultForwarderZone | undefined);
    get id(): string;
    get name(): string;
    get upstreamServers(): string[];
}
export declare class DataVcdNsxtEdgegatewayDnsDefaultForwarderZoneList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtEdgegatewayDnsDefaultForwarderZoneOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway_dns vcd_nsxt_edgegateway_dns}
*/
export declare class DataVcdNsxtEdgegatewayDns extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxt_edgegateway_dns";
    /**
    * Generates CDKTF code for importing a DataVcdNsxtEdgegatewayDns resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxtEdgegatewayDns to import
    * @param importFromId The id of the existing DataVcdNsxtEdgegatewayDns that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway_dns#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxtEdgegatewayDns to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway_dns vcd_nsxt_edgegateway_dns} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxtEdgegatewayDnsConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNsxtEdgegatewayDnsConfig);
    private _conditionalForwarderZone;
    get conditionalForwarderZone(): DataVcdNsxtEdgegatewayDnsConditionalForwarderZoneList;
    private _defaultForwarderZone;
    get defaultForwarderZone(): DataVcdNsxtEdgegatewayDnsDefaultForwarderZoneList;
    private _edgeGatewayId?;
    get edgeGatewayId(): string;
    set edgeGatewayId(value: string);
    get edgeGatewayIdInput(): string | undefined;
    get enabled(): cdktf.IResolvable;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get listenerIp(): string;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    get snatRuleEnabled(): cdktf.IResolvable;
    get snatRuleIpAddress(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
