import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxtEdgegatewayStaticRouteConfig extends cdktf.TerraformMetaArguments {
    /**
    * Edge gateway ID for Static Route configuration
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway_static_route#edge_gateway_id DataVcdNsxtEdgegatewayStaticRoute#edge_gateway_id}
    */
    readonly edgeGatewayId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway_static_route#id DataVcdNsxtEdgegatewayStaticRoute#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Name of Static Route
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway_static_route#name DataVcdNsxtEdgegatewayStaticRoute#name}
    */
    readonly name: string;
    /**
    * Network CIDR (e.g. 192.168.1.1/24) for Static Route
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway_static_route#network_cidr DataVcdNsxtEdgegatewayStaticRoute#network_cidr}
    */
    readonly networkCidr?: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway_static_route#org DataVcdNsxtEdgegatewayStaticRoute#org}
    */
    readonly org?: string;
}
export interface DataVcdNsxtEdgegatewayStaticRouteNextHopScope {
}
export declare function dataVcdNsxtEdgegatewayStaticRouteNextHopScopeToTerraform(struct?: DataVcdNsxtEdgegatewayStaticRouteNextHopScope): any;
export declare function dataVcdNsxtEdgegatewayStaticRouteNextHopScopeToHclTerraform(struct?: DataVcdNsxtEdgegatewayStaticRouteNextHopScope): any;
export declare class DataVcdNsxtEdgegatewayStaticRouteNextHopScopeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtEdgegatewayStaticRouteNextHopScope | undefined;
    set internalValue(value: DataVcdNsxtEdgegatewayStaticRouteNextHopScope | undefined);
    get id(): string;
    get name(): string;
    get type(): string;
}
export declare class DataVcdNsxtEdgegatewayStaticRouteNextHopScopeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtEdgegatewayStaticRouteNextHopScopeOutputReference;
}
export interface DataVcdNsxtEdgegatewayStaticRouteNextHop {
}
export declare function dataVcdNsxtEdgegatewayStaticRouteNextHopToTerraform(struct?: DataVcdNsxtEdgegatewayStaticRouteNextHop): any;
export declare function dataVcdNsxtEdgegatewayStaticRouteNextHopToHclTerraform(struct?: DataVcdNsxtEdgegatewayStaticRouteNextHop): any;
export declare class DataVcdNsxtEdgegatewayStaticRouteNextHopOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtEdgegatewayStaticRouteNextHop | undefined;
    set internalValue(value: DataVcdNsxtEdgegatewayStaticRouteNextHop | undefined);
    get adminDistance(): number;
    get ipAddress(): string;
    private _scope;
    get scope(): DataVcdNsxtEdgegatewayStaticRouteNextHopScopeList;
}
export declare class DataVcdNsxtEdgegatewayStaticRouteNextHopList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtEdgegatewayStaticRouteNextHopOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway_static_route vcd_nsxt_edgegateway_static_route}
*/
export declare class DataVcdNsxtEdgegatewayStaticRoute extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxt_edgegateway_static_route";
    /**
    * Generates CDKTF code for importing a DataVcdNsxtEdgegatewayStaticRoute resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxtEdgegatewayStaticRoute to import
    * @param importFromId The id of the existing DataVcdNsxtEdgegatewayStaticRoute that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway_static_route#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxtEdgegatewayStaticRoute to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway_static_route vcd_nsxt_edgegateway_static_route} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxtEdgegatewayStaticRouteConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNsxtEdgegatewayStaticRouteConfig);
    get description(): string;
    private _edgeGatewayId?;
    get edgeGatewayId(): string;
    set edgeGatewayId(value: string);
    get edgeGatewayIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _networkCidr?;
    get networkCidr(): string;
    set networkCidr(value: string);
    resetNetworkCidr(): void;
    get networkCidrInput(): string | undefined;
    private _nextHop;
    get nextHop(): DataVcdNsxtEdgegatewayStaticRouteNextHopList;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
