import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxtEdgegatewayConfig extends cdktf.TerraformMetaArguments {
    /**
    * NSX-T Edge Cluster ID.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway#edge_cluster_id DataVcdNsxtEdgegateway#edge_cluster_id}
    */
    readonly edgeClusterId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway#id DataVcdNsxtEdgegateway#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Edge Gateway name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway#name DataVcdNsxtEdgegateway#name}
    */
    readonly name: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway#org DataVcdNsxtEdgegateway#org}
    */
    readonly org?: string;
    /**
    * ID of VDC or VDC Group
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway#owner_id DataVcdNsxtEdgegateway#owner_id}
    */
    readonly ownerId?: string;
    /**
    * The name of VDC to use, optional if defined at provider level
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway#vdc DataVcdNsxtEdgegateway#vdc}
    */
    readonly vdc?: string;
}
export interface DataVcdNsxtEdgegatewayExternalNetwork {
}
export declare function dataVcdNsxtEdgegatewayExternalNetworkToTerraform(struct?: DataVcdNsxtEdgegatewayExternalNetwork): any;
export declare function dataVcdNsxtEdgegatewayExternalNetworkToHclTerraform(struct?: DataVcdNsxtEdgegatewayExternalNetwork): any;
export declare class DataVcdNsxtEdgegatewayExternalNetworkOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtEdgegatewayExternalNetwork | undefined;
    set internalValue(value: DataVcdNsxtEdgegatewayExternalNetwork | undefined);
    get allocatedIpCount(): number;
    get externalNetworkId(): string;
    get gateway(): string;
    get prefixLength(): number;
    get primaryIp(): string;
}
export declare class DataVcdNsxtEdgegatewayExternalNetworkList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtEdgegatewayExternalNetworkOutputReference;
}
export interface DataVcdNsxtEdgegatewaySubnetAllocatedIps {
}
export declare function dataVcdNsxtEdgegatewaySubnetAllocatedIpsToTerraform(struct?: DataVcdNsxtEdgegatewaySubnetAllocatedIps): any;
export declare function dataVcdNsxtEdgegatewaySubnetAllocatedIpsToHclTerraform(struct?: DataVcdNsxtEdgegatewaySubnetAllocatedIps): any;
export declare class DataVcdNsxtEdgegatewaySubnetAllocatedIpsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtEdgegatewaySubnetAllocatedIps | undefined;
    set internalValue(value: DataVcdNsxtEdgegatewaySubnetAllocatedIps | undefined);
    get endAddress(): string;
    get startAddress(): string;
}
export declare class DataVcdNsxtEdgegatewaySubnetAllocatedIpsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtEdgegatewaySubnetAllocatedIpsOutputReference;
}
export interface DataVcdNsxtEdgegatewaySubnet {
}
export declare function dataVcdNsxtEdgegatewaySubnetToTerraform(struct?: DataVcdNsxtEdgegatewaySubnet): any;
export declare function dataVcdNsxtEdgegatewaySubnetToHclTerraform(struct?: DataVcdNsxtEdgegatewaySubnet): any;
export declare class DataVcdNsxtEdgegatewaySubnetOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtEdgegatewaySubnet | undefined;
    set internalValue(value: DataVcdNsxtEdgegatewaySubnet | undefined);
    private _allocatedIps;
    get allocatedIps(): DataVcdNsxtEdgegatewaySubnetAllocatedIpsList;
    get gateway(): string;
    get prefixLength(): number;
    get primaryIp(): string;
}
export declare class DataVcdNsxtEdgegatewaySubnetList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtEdgegatewaySubnetOutputReference;
}
export interface DataVcdNsxtEdgegatewaySubnetWithIpCount {
}
export declare function dataVcdNsxtEdgegatewaySubnetWithIpCountToTerraform(struct?: DataVcdNsxtEdgegatewaySubnetWithIpCount): any;
export declare function dataVcdNsxtEdgegatewaySubnetWithIpCountToHclTerraform(struct?: DataVcdNsxtEdgegatewaySubnetWithIpCount): any;
export declare class DataVcdNsxtEdgegatewaySubnetWithIpCountOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtEdgegatewaySubnetWithIpCount | undefined;
    set internalValue(value: DataVcdNsxtEdgegatewaySubnetWithIpCount | undefined);
    get allocatedIpCount(): number;
    get gateway(): string;
    get prefixLength(): number;
    get primaryIp(): string;
}
export declare class DataVcdNsxtEdgegatewaySubnetWithIpCountList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtEdgegatewaySubnetWithIpCountOutputReference;
}
export interface DataVcdNsxtEdgegatewaySubnetWithTotalIpCount {
}
export declare function dataVcdNsxtEdgegatewaySubnetWithTotalIpCountToTerraform(struct?: DataVcdNsxtEdgegatewaySubnetWithTotalIpCount): any;
export declare function dataVcdNsxtEdgegatewaySubnetWithTotalIpCountToHclTerraform(struct?: DataVcdNsxtEdgegatewaySubnetWithTotalIpCount): any;
export declare class DataVcdNsxtEdgegatewaySubnetWithTotalIpCountOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtEdgegatewaySubnetWithTotalIpCount | undefined;
    set internalValue(value: DataVcdNsxtEdgegatewaySubnetWithTotalIpCount | undefined);
    get gateway(): string;
    get prefixLength(): number;
    get primaryIp(): string;
}
export declare class DataVcdNsxtEdgegatewaySubnetWithTotalIpCountList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtEdgegatewaySubnetWithTotalIpCountOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway vcd_nsxt_edgegateway}
*/
export declare class DataVcdNsxtEdgegateway extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxt_edgegateway";
    /**
    * Generates CDKTF code for importing a DataVcdNsxtEdgegateway resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxtEdgegateway to import
    * @param importFromId The id of the existing DataVcdNsxtEdgegateway that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxtEdgegateway to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_edgegateway vcd_nsxt_edgegateway} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxtEdgegatewayConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNsxtEdgegatewayConfig);
    get dedicateExternalNetwork(): cdktf.IResolvable;
    get description(): string;
    private _edgeClusterId?;
    get edgeClusterId(): string;
    set edgeClusterId(value: string);
    resetEdgeClusterId(): void;
    get edgeClusterIdInput(): string | undefined;
    private _externalNetwork;
    get externalNetwork(): DataVcdNsxtEdgegatewayExternalNetworkList;
    get externalNetworkAllocatedIpCount(): number;
    get externalNetworkId(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    private _ownerId?;
    get ownerId(): string;
    set ownerId(value: string);
    resetOwnerId(): void;
    get ownerIdInput(): string | undefined;
    get primaryIp(): string;
    private _subnet;
    get subnet(): DataVcdNsxtEdgegatewaySubnetList;
    private _subnetWithIpCount;
    get subnetWithIpCount(): DataVcdNsxtEdgegatewaySubnetWithIpCountList;
    private _subnetWithTotalIpCount;
    get subnetWithTotalIpCount(): DataVcdNsxtEdgegatewaySubnetWithTotalIpCountList;
    get totalAllocatedIpCount(): number;
    get unusedIpCount(): number;
    get useIpSpaces(): cdktf.IResolvable;
    get usedIpCount(): number;
    private _vdc?;
    get vdc(): string;
    set vdc(value: string);
    resetVdc(): void;
    get vdcInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
