import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxtGlobalDefaultSegmentProfileTemplateConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_global_default_segment_profile_template#id DataVcdNsxtGlobalDefaultSegmentProfileTemplate#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_global_default_segment_profile_template vcd_nsxt_global_default_segment_profile_template}
*/
export declare class DataVcdNsxtGlobalDefaultSegmentProfileTemplate extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxt_global_default_segment_profile_template";
    /**
    * Generates CDKTF code for importing a DataVcdNsxtGlobalDefaultSegmentProfileTemplate resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxtGlobalDefaultSegmentProfileTemplate to import
    * @param importFromId The id of the existing DataVcdNsxtGlobalDefaultSegmentProfileTemplate that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_global_default_segment_profile_template#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxtGlobalDefaultSegmentProfileTemplate to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_global_default_segment_profile_template vcd_nsxt_global_default_segment_profile_template} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxtGlobalDefaultSegmentProfileTemplateConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataVcdNsxtGlobalDefaultSegmentProfileTemplateConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get vappNetworksDefaultSegmentProfileTemplateId(): string;
    get vdcNetworksDefaultSegmentProfileTemplateId(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
