import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxtIpsecVpnTunnelConfig extends cdktf.TerraformMetaArguments {
    /**
    * Edge gateway name in which IP Sec VPN configuration is located
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_ipsec_vpn_tunnel#edge_gateway_id DataVcdNsxtIpsecVpnTunnel#edge_gateway_id}
    */
    readonly edgeGatewayId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_ipsec_vpn_tunnel#id DataVcdNsxtIpsecVpnTunnel#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Name of IP Sec VPN configuration
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_ipsec_vpn_tunnel#name DataVcdNsxtIpsecVpnTunnel#name}
    */
    readonly name: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_ipsec_vpn_tunnel#org DataVcdNsxtIpsecVpnTunnel#org}
    */
    readonly org?: string;
    /**
    * The name of VDC to use, optional if defined at provider level
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_ipsec_vpn_tunnel#vdc DataVcdNsxtIpsecVpnTunnel#vdc}
    */
    readonly vdc?: string;
}
export interface DataVcdNsxtIpsecVpnTunnelSecurityProfileCustomization {
}
export declare function dataVcdNsxtIpsecVpnTunnelSecurityProfileCustomizationToTerraform(struct?: DataVcdNsxtIpsecVpnTunnelSecurityProfileCustomization): any;
export declare function dataVcdNsxtIpsecVpnTunnelSecurityProfileCustomizationToHclTerraform(struct?: DataVcdNsxtIpsecVpnTunnelSecurityProfileCustomization): any;
export declare class DataVcdNsxtIpsecVpnTunnelSecurityProfileCustomizationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtIpsecVpnTunnelSecurityProfileCustomization | undefined;
    set internalValue(value: DataVcdNsxtIpsecVpnTunnelSecurityProfileCustomization | undefined);
    get dpdProbeInternal(): number;
    get ikeDhGroups(): string[];
    get ikeDigestAlgorithms(): string[];
    get ikeEncryptionAlgorithms(): string[];
    get ikeSaLifetime(): number;
    get ikeVersion(): string;
    get tunnelDfPolicy(): string;
    get tunnelDhGroups(): string[];
    get tunnelDigestAlgorithms(): string[];
    get tunnelEncryptionAlgorithms(): string[];
    get tunnelPfsEnabled(): cdktf.IResolvable;
    get tunnelSaLifetime(): number;
}
export declare class DataVcdNsxtIpsecVpnTunnelSecurityProfileCustomizationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtIpsecVpnTunnelSecurityProfileCustomizationOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_ipsec_vpn_tunnel vcd_nsxt_ipsec_vpn_tunnel}
*/
export declare class DataVcdNsxtIpsecVpnTunnel extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxt_ipsec_vpn_tunnel";
    /**
    * Generates CDKTF code for importing a DataVcdNsxtIpsecVpnTunnel resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxtIpsecVpnTunnel to import
    * @param importFromId The id of the existing DataVcdNsxtIpsecVpnTunnel that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_ipsec_vpn_tunnel#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxtIpsecVpnTunnel to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_ipsec_vpn_tunnel vcd_nsxt_ipsec_vpn_tunnel} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxtIpsecVpnTunnelConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNsxtIpsecVpnTunnelConfig);
    get authenticationMode(): string;
    get caCertificateId(): string;
    get certificateId(): string;
    get description(): string;
    private _edgeGatewayId?;
    get edgeGatewayId(): string;
    set edgeGatewayId(value: string);
    get edgeGatewayIdInput(): string | undefined;
    get enabled(): cdktf.IResolvable;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get ikeFailReason(): string;
    get ikeServiceStatus(): string;
    get localIpAddress(): string;
    get localNetworks(): string[];
    get logging(): cdktf.IResolvable;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    get preSharedKey(): string;
    get remoteId(): string;
    get remoteIpAddress(): string;
    get remoteNetworks(): string[];
    get securityProfile(): string;
    private _securityProfileCustomization;
    get securityProfileCustomization(): DataVcdNsxtIpsecVpnTunnelSecurityProfileCustomizationList;
    get status(): string;
    private _vdc?;
    get vdc(): string;
    set vdc(value: string);
    resetVdc(): void;
    get vdcInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
