import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxtNetworkContextProfileConfig extends cdktf.TerraformMetaArguments {
    /**
    * Context ID can be one of VDC, VDC Group, or NSX-T Manager ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_network_context_profile#context_id DataVcdNsxtNetworkContextProfile#context_id}
    */
    readonly contextId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_network_context_profile#id DataVcdNsxtNetworkContextProfile#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Edge gateway name in which NAT Rule is located
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_network_context_profile#name DataVcdNsxtNetworkContextProfile#name}
    */
    readonly name: string;
    /**
    * 'SYSTEM', 'PROVIDER', 'TENANT'
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_network_context_profile#scope DataVcdNsxtNetworkContextProfile#scope}
    */
    readonly scope?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_network_context_profile vcd_nsxt_network_context_profile}
*/
export declare class DataVcdNsxtNetworkContextProfile extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxt_network_context_profile";
    /**
    * Generates CDKTF code for importing a DataVcdNsxtNetworkContextProfile resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxtNetworkContextProfile to import
    * @param importFromId The id of the existing DataVcdNsxtNetworkContextProfile that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_network_context_profile#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxtNetworkContextProfile to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_network_context_profile vcd_nsxt_network_context_profile} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxtNetworkContextProfileConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNsxtNetworkContextProfileConfig);
    private _contextId?;
    get contextId(): string;
    set contextId(value: string);
    get contextIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _scope?;
    get scope(): string;
    set scope(value: string);
    resetScope(): void;
    get scopeInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
