import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxtNetworkDhcpBindingConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_network_dhcp_binding#id DataVcdNsxtNetworkDhcpBinding#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Name of DHCP binding
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_network_dhcp_binding#name DataVcdNsxtNetworkDhcpBinding#name}
    */
    readonly name: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_network_dhcp_binding#org DataVcdNsxtNetworkDhcpBinding#org}
    */
    readonly org?: string;
    /**
    * Parent Org VDC network ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_network_dhcp_binding#org_network_id DataVcdNsxtNetworkDhcpBinding#org_network_id}
    */
    readonly orgNetworkId: string;
}
export interface DataVcdNsxtNetworkDhcpBindingDhcpV4Config {
}
export declare function dataVcdNsxtNetworkDhcpBindingDhcpV4ConfigToTerraform(struct?: DataVcdNsxtNetworkDhcpBindingDhcpV4Config): any;
export declare function dataVcdNsxtNetworkDhcpBindingDhcpV4ConfigToHclTerraform(struct?: DataVcdNsxtNetworkDhcpBindingDhcpV4Config): any;
export declare class DataVcdNsxtNetworkDhcpBindingDhcpV4ConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtNetworkDhcpBindingDhcpV4Config | undefined;
    set internalValue(value: DataVcdNsxtNetworkDhcpBindingDhcpV4Config | undefined);
    get gatewayIpAddress(): string;
    get hostname(): string;
}
export declare class DataVcdNsxtNetworkDhcpBindingDhcpV4ConfigList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtNetworkDhcpBindingDhcpV4ConfigOutputReference;
}
export interface DataVcdNsxtNetworkDhcpBindingDhcpV6Config {
}
export declare function dataVcdNsxtNetworkDhcpBindingDhcpV6ConfigToTerraform(struct?: DataVcdNsxtNetworkDhcpBindingDhcpV6Config): any;
export declare function dataVcdNsxtNetworkDhcpBindingDhcpV6ConfigToHclTerraform(struct?: DataVcdNsxtNetworkDhcpBindingDhcpV6Config): any;
export declare class DataVcdNsxtNetworkDhcpBindingDhcpV6ConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtNetworkDhcpBindingDhcpV6Config | undefined;
    set internalValue(value: DataVcdNsxtNetworkDhcpBindingDhcpV6Config | undefined);
    get dnsServers(): string[];
    get sntpServers(): string[];
}
export declare class DataVcdNsxtNetworkDhcpBindingDhcpV6ConfigList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtNetworkDhcpBindingDhcpV6ConfigOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_network_dhcp_binding vcd_nsxt_network_dhcp_binding}
*/
export declare class DataVcdNsxtNetworkDhcpBinding extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxt_network_dhcp_binding";
    /**
    * Generates CDKTF code for importing a DataVcdNsxtNetworkDhcpBinding resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxtNetworkDhcpBinding to import
    * @param importFromId The id of the existing DataVcdNsxtNetworkDhcpBinding that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_network_dhcp_binding#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxtNetworkDhcpBinding to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_network_dhcp_binding vcd_nsxt_network_dhcp_binding} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxtNetworkDhcpBindingConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNsxtNetworkDhcpBindingConfig);
    get bindingType(): string;
    get description(): string;
    private _dhcpV4Config;
    get dhcpV4Config(): DataVcdNsxtNetworkDhcpBindingDhcpV4ConfigList;
    private _dhcpV6Config;
    get dhcpV6Config(): DataVcdNsxtNetworkDhcpBindingDhcpV6ConfigList;
    get dnsServers(): string[];
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get ipAddress(): string;
    get leaseTime(): number;
    get macAddress(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    private _orgNetworkId?;
    get orgNetworkId(): string;
    set orgNetworkId(value: string);
    get orgNetworkIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
