import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxtNetworkImportedConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_network_imported#id DataVcdNsxtNetworkImported#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * A unique name for this network (optional if 'filter' is used)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_network_imported#name DataVcdNsxtNetworkImported#name}
    */
    readonly name?: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_network_imported#org DataVcdNsxtNetworkImported#org}
    */
    readonly org?: string;
    /**
    * ID of VDC or VDC Group
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_network_imported#owner_id DataVcdNsxtNetworkImported#owner_id}
    */
    readonly ownerId?: string;
    /**
    * The name of VDC to use, optional if defined at provider level
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_network_imported#vdc DataVcdNsxtNetworkImported#vdc}
    */
    readonly vdc?: string;
    /**
    * filter block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_network_imported#filter DataVcdNsxtNetworkImported#filter}
    */
    readonly filter?: DataVcdNsxtNetworkImportedFilter;
}
export interface DataVcdNsxtNetworkImportedSecondaryStaticIpPool {
}
export declare function dataVcdNsxtNetworkImportedSecondaryStaticIpPoolToTerraform(struct?: DataVcdNsxtNetworkImportedSecondaryStaticIpPool): any;
export declare function dataVcdNsxtNetworkImportedSecondaryStaticIpPoolToHclTerraform(struct?: DataVcdNsxtNetworkImportedSecondaryStaticIpPool): any;
export declare class DataVcdNsxtNetworkImportedSecondaryStaticIpPoolOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtNetworkImportedSecondaryStaticIpPool | undefined;
    set internalValue(value: DataVcdNsxtNetworkImportedSecondaryStaticIpPool | undefined);
    get endAddress(): string;
    get startAddress(): string;
}
export declare class DataVcdNsxtNetworkImportedSecondaryStaticIpPoolList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtNetworkImportedSecondaryStaticIpPoolOutputReference;
}
export interface DataVcdNsxtNetworkImportedStaticIpPool {
}
export declare function dataVcdNsxtNetworkImportedStaticIpPoolToTerraform(struct?: DataVcdNsxtNetworkImportedStaticIpPool): any;
export declare function dataVcdNsxtNetworkImportedStaticIpPoolToHclTerraform(struct?: DataVcdNsxtNetworkImportedStaticIpPool): any;
export declare class DataVcdNsxtNetworkImportedStaticIpPoolOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxtNetworkImportedStaticIpPool | undefined;
    set internalValue(value: DataVcdNsxtNetworkImportedStaticIpPool | undefined);
    get endAddress(): string;
    get startAddress(): string;
}
export declare class DataVcdNsxtNetworkImportedStaticIpPoolList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxtNetworkImportedStaticIpPoolOutputReference;
}
export interface DataVcdNsxtNetworkImportedFilter {
    /**
    * Search by IP. The value can be a regular expression
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_network_imported#ip DataVcdNsxtNetworkImported#ip}
    */
    readonly ip?: string;
    /**
    * Search by name with a regular expression
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_network_imported#name_regex DataVcdNsxtNetworkImported#name_regex}
    */
    readonly nameRegex?: string;
}
export declare function dataVcdNsxtNetworkImportedFilterToTerraform(struct?: DataVcdNsxtNetworkImportedFilterOutputReference | DataVcdNsxtNetworkImportedFilter): any;
export declare function dataVcdNsxtNetworkImportedFilterToHclTerraform(struct?: DataVcdNsxtNetworkImportedFilterOutputReference | DataVcdNsxtNetworkImportedFilter): any;
export declare class DataVcdNsxtNetworkImportedFilterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataVcdNsxtNetworkImportedFilter | undefined;
    set internalValue(value: DataVcdNsxtNetworkImportedFilter | undefined);
    private _ip?;
    get ip(): string;
    set ip(value: string);
    resetIp(): void;
    get ipInput(): string | undefined;
    private _nameRegex?;
    get nameRegex(): string;
    set nameRegex(value: string);
    resetNameRegex(): void;
    get nameRegexInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_network_imported vcd_nsxt_network_imported}
*/
export declare class DataVcdNsxtNetworkImported extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxt_network_imported";
    /**
    * Generates CDKTF code for importing a DataVcdNsxtNetworkImported resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxtNetworkImported to import
    * @param importFromId The id of the existing DataVcdNsxtNetworkImported that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_network_imported#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxtNetworkImported to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_network_imported vcd_nsxt_network_imported} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxtNetworkImportedConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataVcdNsxtNetworkImportedConfig);
    get description(): string;
    get dns1(): string;
    get dns2(): string;
    get dnsSuffix(): string;
    get dualStackEnabled(): cdktf.IResolvable;
    get dvpgId(): string;
    get gateway(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get nsxtLogicalSwitchId(): string;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    private _ownerId?;
    get ownerId(): string;
    set ownerId(value: string);
    resetOwnerId(): void;
    get ownerIdInput(): string | undefined;
    get prefixLength(): number;
    get secondaryGateway(): string;
    get secondaryPrefixLength(): string;
    private _secondaryStaticIpPool;
    get secondaryStaticIpPool(): DataVcdNsxtNetworkImportedSecondaryStaticIpPoolList;
    private _staticIpPool;
    get staticIpPool(): DataVcdNsxtNetworkImportedStaticIpPoolList;
    private _vdc?;
    get vdc(): string;
    set vdc(value: string);
    resetVdc(): void;
    get vdcInput(): string | undefined;
    private _filter;
    get filter(): DataVcdNsxtNetworkImportedFilterOutputReference;
    putFilter(value: DataVcdNsxtNetworkImportedFilter): void;
    resetFilter(): void;
    get filterInput(): DataVcdNsxtNetworkImportedFilter | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
