import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxtNetworkSegmentProfileConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_network_segment_profile#id DataVcdNsxtNetworkSegmentProfile#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_network_segment_profile#org DataVcdNsxtNetworkSegmentProfile#org}
    */
    readonly org?: string;
    /**
    * ID of the Organization Network that uses the Segment Profile Template
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_network_segment_profile#org_network_id DataVcdNsxtNetworkSegmentProfile#org_network_id}
    */
    readonly orgNetworkId: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_network_segment_profile vcd_nsxt_network_segment_profile}
*/
export declare class DataVcdNsxtNetworkSegmentProfile extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxt_network_segment_profile";
    /**
    * Generates CDKTF code for importing a DataVcdNsxtNetworkSegmentProfile resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxtNetworkSegmentProfile to import
    * @param importFromId The id of the existing DataVcdNsxtNetworkSegmentProfile that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_network_segment_profile#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxtNetworkSegmentProfile to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_network_segment_profile vcd_nsxt_network_segment_profile} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxtNetworkSegmentProfileConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNsxtNetworkSegmentProfileConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get ipDiscoveryProfileId(): string;
    get macDiscoveryProfileId(): string;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    private _orgNetworkId?;
    get orgNetworkId(): string;
    set orgNetworkId(value: string);
    get orgNetworkIdInput(): string | undefined;
    get qosProfileId(): string;
    get segmentProfileTemplateId(): string;
    get segmentProfileTemplateName(): string;
    get segmentSecurityProfileId(): string;
    get spoofGuardProfileId(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
