import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxtSegmentIpDiscoveryProfileConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_segment_ip_discovery_profile#id DataVcdNsxtSegmentIpDiscoveryProfile#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Name of Segment IP Discovery Profile
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_segment_ip_discovery_profile#name DataVcdNsxtSegmentIpDiscoveryProfile#name}
    */
    readonly name: string;
    /**
    * ID of NSX-T Manager
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_segment_ip_discovery_profile#nsxt_manager_id DataVcdNsxtSegmentIpDiscoveryProfile#nsxt_manager_id}
    */
    readonly nsxtManagerId?: string;
    /**
    * ID of VDC Group
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_segment_ip_discovery_profile#vdc_group_id DataVcdNsxtSegmentIpDiscoveryProfile#vdc_group_id}
    */
    readonly vdcGroupId?: string;
    /**
    * ID of VDC
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_segment_ip_discovery_profile#vdc_id DataVcdNsxtSegmentIpDiscoveryProfile#vdc_id}
    */
    readonly vdcId?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_segment_ip_discovery_profile vcd_nsxt_segment_ip_discovery_profile}
*/
export declare class DataVcdNsxtSegmentIpDiscoveryProfile extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxt_segment_ip_discovery_profile";
    /**
    * Generates CDKTF code for importing a DataVcdNsxtSegmentIpDiscoveryProfile resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxtSegmentIpDiscoveryProfile to import
    * @param importFromId The id of the existing DataVcdNsxtSegmentIpDiscoveryProfile that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_segment_ip_discovery_profile#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxtSegmentIpDiscoveryProfile to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_segment_ip_discovery_profile vcd_nsxt_segment_ip_discovery_profile} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxtSegmentIpDiscoveryProfileConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNsxtSegmentIpDiscoveryProfileConfig);
    get arpBindingLimit(): number;
    get arpBindingTimeout(): number;
    get description(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get isArpSnoopingEnabled(): cdktf.IResolvable;
    get isDhcpSnoopingV4Enabled(): cdktf.IResolvable;
    get isDhcpSnoopingV6Enabled(): cdktf.IResolvable;
    get isDuplicateIpDetectionEnabled(): cdktf.IResolvable;
    get isNdSnoopingEnabled(): cdktf.IResolvable;
    get isTofuEnabled(): cdktf.IResolvable;
    get isVmtoolsV4Enabled(): cdktf.IResolvable;
    get isVmtoolsV6Enabled(): cdktf.IResolvable;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get ndSnoopingLimit(): number;
    private _nsxtManagerId?;
    get nsxtManagerId(): string;
    set nsxtManagerId(value: string);
    resetNsxtManagerId(): void;
    get nsxtManagerIdInput(): string | undefined;
    private _vdcGroupId?;
    get vdcGroupId(): string;
    set vdcGroupId(value: string);
    resetVdcGroupId(): void;
    get vdcGroupIdInput(): string | undefined;
    private _vdcId?;
    get vdcId(): string;
    set vdcId(value: string);
    resetVdcId(): void;
    get vdcIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
