import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxtSegmentQosProfileConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_segment_qos_profile#id DataVcdNsxtSegmentQosProfile#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Name of Segment QoS Profile
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_segment_qos_profile#name DataVcdNsxtSegmentQosProfile#name}
    */
    readonly name: string;
    /**
    * ID of NSX-T Manager
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_segment_qos_profile#nsxt_manager_id DataVcdNsxtSegmentQosProfile#nsxt_manager_id}
    */
    readonly nsxtManagerId?: string;
    /**
    * ID of VDC Group
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_segment_qos_profile#vdc_group_id DataVcdNsxtSegmentQosProfile#vdc_group_id}
    */
    readonly vdcGroupId?: string;
    /**
    * ID of VDC
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_segment_qos_profile#vdc_id DataVcdNsxtSegmentQosProfile#vdc_id}
    */
    readonly vdcId?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_segment_qos_profile vcd_nsxt_segment_qos_profile}
*/
export declare class DataVcdNsxtSegmentQosProfile extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxt_segment_qos_profile";
    /**
    * Generates CDKTF code for importing a DataVcdNsxtSegmentQosProfile resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxtSegmentQosProfile to import
    * @param importFromId The id of the existing DataVcdNsxtSegmentQosProfile that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_segment_qos_profile#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxtSegmentQosProfile to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_segment_qos_profile vcd_nsxt_segment_qos_profile} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxtSegmentQosProfileConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNsxtSegmentQosProfileConfig);
    get classOfService(): number;
    get description(): string;
    get dscpPriority(): number;
    get dscpTrustMode(): string;
    get egressRateLimiterAvgBandwidth(): number;
    get egressRateLimiterBurstSize(): number;
    get egressRateLimiterPeakBandwidth(): number;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get ingressBroadcastRateLimiterAvgBandwidth(): number;
    get ingressBroadcastRateLimiterBurstSize(): number;
    get ingressBroadcastRateLimiterPeakBandwidth(): number;
    get ingressRateLimiterAvgBandwidth(): number;
    get ingressRateLimiterBurstSize(): number;
    get ingressRateLimiterPeakBandwidth(): number;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _nsxtManagerId?;
    get nsxtManagerId(): string;
    set nsxtManagerId(value: string);
    resetNsxtManagerId(): void;
    get nsxtManagerIdInput(): string | undefined;
    private _vdcGroupId?;
    get vdcGroupId(): string;
    set vdcGroupId(value: string);
    resetVdcGroupId(): void;
    get vdcGroupIdInput(): string | undefined;
    private _vdcId?;
    get vdcId(): string;
    set vdcId(value: string);
    resetVdcId(): void;
    get vdcIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
