import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxtTier0RouterConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_tier0_router#id DataVcdNsxtTier0Router#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Name of NSX-T Tier-0 router.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_tier0_router#name DataVcdNsxtTier0Router#name}
    */
    readonly name: string;
    /**
    * ID of NSX-T manager.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_tier0_router#nsxt_manager_id DataVcdNsxtTier0Router#nsxt_manager_id}
    */
    readonly nsxtManagerId: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_tier0_router vcd_nsxt_tier0_router}
*/
export declare class DataVcdNsxtTier0Router extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxt_tier0_router";
    /**
    * Generates CDKTF code for importing a DataVcdNsxtTier0Router resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxtTier0Router to import
    * @param importFromId The id of the existing DataVcdNsxtTier0Router that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_tier0_router#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxtTier0Router to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxt_tier0_router vcd_nsxt_tier0_router} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxtTier0RouterConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNsxtTier0RouterConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get isAssigned(): cdktf.IResolvable;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _nsxtManagerId?;
    get nsxtManagerId(): string;
    set nsxtManagerId(value: string);
    get nsxtManagerIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
