import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxvApplicationFinderConfig extends cdktf.TerraformMetaArguments {
    /**
    * Convert the search to case sensitive
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_application_finder#case_sensitive DataVcdNsxvApplicationFinder#case_sensitive}
    */
    readonly caseSensitive?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_application_finder#id DataVcdNsxvApplicationFinder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Regular expression used to search applications or groups
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_application_finder#search_expression DataVcdNsxvApplicationFinder#search_expression}
    */
    readonly searchExpression: string;
    /**
    * Type of object. One of 'application', 'application_group'
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_application_finder#type DataVcdNsxvApplicationFinder#type}
    */
    readonly type: string;
    /**
    * The ID of VDC
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_application_finder#vdc_id DataVcdNsxvApplicationFinder#vdc_id}
    */
    readonly vdcId: string;
}
export interface DataVcdNsxvApplicationFinderObjects {
}
export declare function dataVcdNsxvApplicationFinderObjectsToTerraform(struct?: DataVcdNsxvApplicationFinderObjects): any;
export declare function dataVcdNsxvApplicationFinderObjectsToHclTerraform(struct?: DataVcdNsxvApplicationFinderObjects): any;
export declare class DataVcdNsxvApplicationFinderObjectsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxvApplicationFinderObjects | undefined;
    set internalValue(value: DataVcdNsxvApplicationFinderObjects | undefined);
    get name(): string;
    get type(): string;
    get value(): string;
}
export declare class DataVcdNsxvApplicationFinderObjectsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxvApplicationFinderObjectsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_application_finder vcd_nsxv_application_finder}
*/
export declare class DataVcdNsxvApplicationFinder extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxv_application_finder";
    /**
    * Generates CDKTF code for importing a DataVcdNsxvApplicationFinder resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxvApplicationFinder to import
    * @param importFromId The id of the existing DataVcdNsxvApplicationFinder that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_application_finder#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxvApplicationFinder to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_application_finder vcd_nsxv_application_finder} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxvApplicationFinderConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNsxvApplicationFinderConfig);
    private _caseSensitive?;
    get caseSensitive(): boolean | cdktf.IResolvable;
    set caseSensitive(value: boolean | cdktf.IResolvable);
    resetCaseSensitive(): void;
    get caseSensitiveInput(): boolean | cdktf.IResolvable | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _objects;
    get objects(): DataVcdNsxvApplicationFinderObjectsList;
    private _searchExpression?;
    get searchExpression(): string;
    set searchExpression(value: string);
    get searchExpressionInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
    private _vdcId?;
    get vdcId(): string;
    set vdcId(value: string);
    get vdcIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
