import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxvApplicationGroupConfig extends cdktf.TerraformMetaArguments {
    /**
    * Name of the object
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_application_group#name DataVcdNsxvApplicationGroup#name}
    */
    readonly name: string;
    /**
    * The ID of VDC
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_application_group#vdc_id DataVcdNsxvApplicationGroup#vdc_id}
    */
    readonly vdcId: string;
}
export interface DataVcdNsxvApplicationGroupApplications {
}
export declare function dataVcdNsxvApplicationGroupApplicationsToTerraform(struct?: DataVcdNsxvApplicationGroupApplications): any;
export declare function dataVcdNsxvApplicationGroupApplicationsToHclTerraform(struct?: DataVcdNsxvApplicationGroupApplications): any;
export declare class DataVcdNsxvApplicationGroupApplicationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxvApplicationGroupApplications | undefined;
    set internalValue(value: DataVcdNsxvApplicationGroupApplications | undefined);
    get name(): string;
    get value(): string;
}
export declare class DataVcdNsxvApplicationGroupApplicationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxvApplicationGroupApplicationsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_application_group vcd_nsxv_application_group}
*/
export declare class DataVcdNsxvApplicationGroup extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxv_application_group";
    /**
    * Generates CDKTF code for importing a DataVcdNsxvApplicationGroup resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxvApplicationGroup to import
    * @param importFromId The id of the existing DataVcdNsxvApplicationGroup that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_application_group#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxvApplicationGroup to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_application_group vcd_nsxv_application_group} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxvApplicationGroupConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNsxvApplicationGroupConfig);
    private _applications;
    get applications(): DataVcdNsxvApplicationGroupApplicationsList;
    get id(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _vdcId?;
    get vdcId(): string;
    set vdcId(value: string);
    get vdcIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
