import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxvApplicationConfig extends cdktf.TerraformMetaArguments {
    /**
    * Name of the object
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_application#name DataVcdNsxvApplication#name}
    */
    readonly name: string;
    /**
    * The ID of VDC
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_application#vdc_id DataVcdNsxvApplication#vdc_id}
    */
    readonly vdcId: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_application vcd_nsxv_application}
*/
export declare class DataVcdNsxvApplication extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxv_application";
    /**
    * Generates CDKTF code for importing a DataVcdNsxvApplication resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxvApplication to import
    * @param importFromId The id of the existing DataVcdNsxvApplication that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_application#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxvApplication to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_application vcd_nsxv_application} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxvApplicationConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNsxvApplicationConfig);
    get appGuid(): string;
    get id(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get ports(): string;
    get protocol(): string;
    get sourcePort(): string;
    private _vdcId?;
    get vdcId(): string;
    set vdcId(value: string);
    get vdcIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
