import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxvDhcpRelayConfig extends cdktf.TerraformMetaArguments {
    /**
    * Edge gateway name for DHCP relay settings
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_dhcp_relay#edge_gateway DataVcdNsxvDhcpRelay#edge_gateway}
    */
    readonly edgeGateway: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_dhcp_relay#id DataVcdNsxvDhcpRelay#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_dhcp_relay#org DataVcdNsxvDhcpRelay#org}
    */
    readonly org?: string;
    /**
    * The name of VDC to use, optional if defined at provider level
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_dhcp_relay#vdc DataVcdNsxvDhcpRelay#vdc}
    */
    readonly vdc?: string;
}
export interface DataVcdNsxvDhcpRelayRelayAgent {
}
export declare function dataVcdNsxvDhcpRelayRelayAgentToTerraform(struct?: DataVcdNsxvDhcpRelayRelayAgent): any;
export declare function dataVcdNsxvDhcpRelayRelayAgentToHclTerraform(struct?: DataVcdNsxvDhcpRelayRelayAgent): any;
export declare class DataVcdNsxvDhcpRelayRelayAgentOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxvDhcpRelayRelayAgent | undefined;
    set internalValue(value: DataVcdNsxvDhcpRelayRelayAgent | undefined);
    get gatewayIpAddress(): string;
    get networkName(): string;
}
export declare class DataVcdNsxvDhcpRelayRelayAgentList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxvDhcpRelayRelayAgentOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_dhcp_relay vcd_nsxv_dhcp_relay}
*/
export declare class DataVcdNsxvDhcpRelay extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxv_dhcp_relay";
    /**
    * Generates CDKTF code for importing a DataVcdNsxvDhcpRelay resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxvDhcpRelay to import
    * @param importFromId The id of the existing DataVcdNsxvDhcpRelay that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_dhcp_relay#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxvDhcpRelay to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_dhcp_relay vcd_nsxv_dhcp_relay} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxvDhcpRelayConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNsxvDhcpRelayConfig);
    get domainNames(): string[];
    private _edgeGateway?;
    get edgeGateway(): string;
    set edgeGateway(value: string);
    get edgeGatewayInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get ipAddresses(): string[];
    get ipSets(): string[];
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    private _relayAgent;
    get relayAgent(): DataVcdNsxvDhcpRelayRelayAgentList;
    private _vdc?;
    get vdc(): string;
    set vdc(value: string);
    resetVdc(): void;
    get vdcInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
