import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxvDistributedFirewallConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_distributed_firewall#id DataVcdNsxvDistributedFirewall#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The ID of VDC
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_distributed_firewall#vdc_id DataVcdNsxvDistributedFirewall#vdc_id}
    */
    readonly vdcId: string;
}
export interface DataVcdNsxvDistributedFirewallRuleApplication {
}
export declare function dataVcdNsxvDistributedFirewallRuleApplicationToTerraform(struct?: DataVcdNsxvDistributedFirewallRuleApplication): any;
export declare function dataVcdNsxvDistributedFirewallRuleApplicationToHclTerraform(struct?: DataVcdNsxvDistributedFirewallRuleApplication): any;
export declare class DataVcdNsxvDistributedFirewallRuleApplicationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxvDistributedFirewallRuleApplication | undefined;
    set internalValue(value: DataVcdNsxvDistributedFirewallRuleApplication | undefined);
    get destinationPort(): string;
    get name(): string;
    get protocol(): string;
    get sourcePort(): string;
    get type(): string;
    get value(): string;
}
export declare class DataVcdNsxvDistributedFirewallRuleApplicationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxvDistributedFirewallRuleApplicationOutputReference;
}
export interface DataVcdNsxvDistributedFirewallRuleAppliedTo {
}
export declare function dataVcdNsxvDistributedFirewallRuleAppliedToToTerraform(struct?: DataVcdNsxvDistributedFirewallRuleAppliedTo): any;
export declare function dataVcdNsxvDistributedFirewallRuleAppliedToToHclTerraform(struct?: DataVcdNsxvDistributedFirewallRuleAppliedTo): any;
export declare class DataVcdNsxvDistributedFirewallRuleAppliedToOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxvDistributedFirewallRuleAppliedTo | undefined;
    set internalValue(value: DataVcdNsxvDistributedFirewallRuleAppliedTo | undefined);
    get name(): string;
    get type(): string;
    get value(): string;
}
export declare class DataVcdNsxvDistributedFirewallRuleAppliedToList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxvDistributedFirewallRuleAppliedToOutputReference;
}
export interface DataVcdNsxvDistributedFirewallRuleDestination {
}
export declare function dataVcdNsxvDistributedFirewallRuleDestinationToTerraform(struct?: DataVcdNsxvDistributedFirewallRuleDestination): any;
export declare function dataVcdNsxvDistributedFirewallRuleDestinationToHclTerraform(struct?: DataVcdNsxvDistributedFirewallRuleDestination): any;
export declare class DataVcdNsxvDistributedFirewallRuleDestinationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxvDistributedFirewallRuleDestination | undefined;
    set internalValue(value: DataVcdNsxvDistributedFirewallRuleDestination | undefined);
    get name(): string;
    get type(): string;
    get value(): string;
}
export declare class DataVcdNsxvDistributedFirewallRuleDestinationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxvDistributedFirewallRuleDestinationOutputReference;
}
export interface DataVcdNsxvDistributedFirewallRuleSource {
}
export declare function dataVcdNsxvDistributedFirewallRuleSourceToTerraform(struct?: DataVcdNsxvDistributedFirewallRuleSource): any;
export declare function dataVcdNsxvDistributedFirewallRuleSourceToHclTerraform(struct?: DataVcdNsxvDistributedFirewallRuleSource): any;
export declare class DataVcdNsxvDistributedFirewallRuleSourceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxvDistributedFirewallRuleSource | undefined;
    set internalValue(value: DataVcdNsxvDistributedFirewallRuleSource | undefined);
    get name(): string;
    get type(): string;
    get value(): string;
}
export declare class DataVcdNsxvDistributedFirewallRuleSourceList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxvDistributedFirewallRuleSourceOutputReference;
}
export interface DataVcdNsxvDistributedFirewallRule {
}
export declare function dataVcdNsxvDistributedFirewallRuleToTerraform(struct?: DataVcdNsxvDistributedFirewallRule): any;
export declare function dataVcdNsxvDistributedFirewallRuleToHclTerraform(struct?: DataVcdNsxvDistributedFirewallRule): any;
export declare class DataVcdNsxvDistributedFirewallRuleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxvDistributedFirewallRule | undefined;
    set internalValue(value: DataVcdNsxvDistributedFirewallRule | undefined);
    get action(): string;
    private _application;
    get application(): DataVcdNsxvDistributedFirewallRuleApplicationList;
    private _appliedTo;
    get appliedTo(): DataVcdNsxvDistributedFirewallRuleAppliedToList;
    private _destination;
    get destination(): DataVcdNsxvDistributedFirewallRuleDestinationList;
    get direction(): string;
    get enabled(): cdktf.IResolvable;
    get excludeDestination(): cdktf.IResolvable;
    get excludeSource(): cdktf.IResolvable;
    get id(): number;
    get logged(): cdktf.IResolvable;
    get name(): string;
    get packetType(): string;
    private _source;
    get source(): DataVcdNsxvDistributedFirewallRuleSourceList;
}
export declare class DataVcdNsxvDistributedFirewallRuleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxvDistributedFirewallRuleOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_distributed_firewall vcd_nsxv_distributed_firewall}
*/
export declare class DataVcdNsxvDistributedFirewall extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxv_distributed_firewall";
    /**
    * Generates CDKTF code for importing a DataVcdNsxvDistributedFirewall resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxvDistributedFirewall to import
    * @param importFromId The id of the existing DataVcdNsxvDistributedFirewall that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_distributed_firewall#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxvDistributedFirewall to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_distributed_firewall vcd_nsxv_distributed_firewall} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxvDistributedFirewallConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNsxvDistributedFirewallConfig);
    get enabled(): cdktf.IResolvable;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _rule;
    get rule(): DataVcdNsxvDistributedFirewallRuleList;
    private _vdcId?;
    get vdcId(): string;
    set vdcId(value: string);
    get vdcIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
