import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxvDnatConfig extends cdktf.TerraformMetaArguments {
    /**
    * Edge gateway name in which the NAT rule is located
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_dnat#edge_gateway DataVcdNsxvDnat#edge_gateway}
    */
    readonly edgeGateway: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_dnat#id DataVcdNsxvDnat#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_dnat#org DataVcdNsxvDnat#org}
    */
    readonly org?: string;
    /**
    * NAT rule ID for lookup
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_dnat#rule_id DataVcdNsxvDnat#rule_id}
    */
    readonly ruleId: string;
    /**
    * The name of VDC to use, optional if defined at provider level
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_dnat#vdc DataVcdNsxvDnat#vdc}
    */
    readonly vdc?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_dnat vcd_nsxv_dnat}
*/
export declare class DataVcdNsxvDnat extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxv_dnat";
    /**
    * Generates CDKTF code for importing a DataVcdNsxvDnat resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxvDnat to import
    * @param importFromId The id of the existing DataVcdNsxvDnat that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_dnat#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxvDnat to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_dnat vcd_nsxv_dnat} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxvDnatConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNsxvDnatConfig);
    get description(): string;
    private _edgeGateway?;
    get edgeGateway(): string;
    set edgeGateway(value: string);
    get edgeGatewayInput(): string | undefined;
    get enabled(): cdktf.IResolvable;
    get icmpType(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get loggingEnabled(): cdktf.IResolvable;
    get networkName(): string;
    get networkType(): string;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    get originalAddress(): string;
    get originalPort(): string;
    get protocol(): string;
    private _ruleId?;
    get ruleId(): string;
    set ruleId(value: string);
    get ruleIdInput(): string | undefined;
    get ruleTag(): number;
    get ruleType(): string;
    get translatedAddress(): string;
    get translatedPort(): string;
    private _vdc?;
    get vdc(): string;
    set vdc(value: string);
    resetVdc(): void;
    get vdcInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
