import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdNsxvFirewallRuleConfig extends cdktf.TerraformMetaArguments {
    /**
    * Edge gateway name in which the firewall rule is located
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_firewall_rule#edge_gateway DataVcdNsxvFirewallRule#edge_gateway}
    */
    readonly edgeGateway: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_firewall_rule#id DataVcdNsxvFirewallRule#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_firewall_rule#org DataVcdNsxvFirewallRule#org}
    */
    readonly org?: string;
    /**
    * Firewall rule ID for lookup
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_firewall_rule#rule_id DataVcdNsxvFirewallRule#rule_id}
    */
    readonly ruleId: string;
    /**
    * The name of VDC to use, optional if defined at provider level
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_firewall_rule#vdc DataVcdNsxvFirewallRule#vdc}
    */
    readonly vdc?: string;
}
export interface DataVcdNsxvFirewallRuleDestination {
}
export declare function dataVcdNsxvFirewallRuleDestinationToTerraform(struct?: DataVcdNsxvFirewallRuleDestination): any;
export declare function dataVcdNsxvFirewallRuleDestinationToHclTerraform(struct?: DataVcdNsxvFirewallRuleDestination): any;
export declare class DataVcdNsxvFirewallRuleDestinationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxvFirewallRuleDestination | undefined;
    set internalValue(value: DataVcdNsxvFirewallRuleDestination | undefined);
    get exclude(): cdktf.IResolvable;
    get gatewayInterfaces(): string[];
    get ipAddresses(): string[];
    get ipSets(): string[];
    get orgNetworks(): string[];
    get vmIds(): string[];
}
export declare class DataVcdNsxvFirewallRuleDestinationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxvFirewallRuleDestinationOutputReference;
}
export interface DataVcdNsxvFirewallRuleService {
}
export declare function dataVcdNsxvFirewallRuleServiceToTerraform(struct?: DataVcdNsxvFirewallRuleService): any;
export declare function dataVcdNsxvFirewallRuleServiceToHclTerraform(struct?: DataVcdNsxvFirewallRuleService): any;
export declare class DataVcdNsxvFirewallRuleServiceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxvFirewallRuleService | undefined;
    set internalValue(value: DataVcdNsxvFirewallRuleService | undefined);
    get port(): string;
    get protocol(): string;
    get sourcePort(): string;
}
export declare class DataVcdNsxvFirewallRuleServiceList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxvFirewallRuleServiceOutputReference;
}
export interface DataVcdNsxvFirewallRuleSource {
}
export declare function dataVcdNsxvFirewallRuleSourceToTerraform(struct?: DataVcdNsxvFirewallRuleSource): any;
export declare function dataVcdNsxvFirewallRuleSourceToHclTerraform(struct?: DataVcdNsxvFirewallRuleSource): any;
export declare class DataVcdNsxvFirewallRuleSourceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdNsxvFirewallRuleSource | undefined;
    set internalValue(value: DataVcdNsxvFirewallRuleSource | undefined);
    get exclude(): cdktf.IResolvable;
    get gatewayInterfaces(): string[];
    get ipAddresses(): string[];
    get ipSets(): string[];
    get orgNetworks(): string[];
    get vmIds(): string[];
}
export declare class DataVcdNsxvFirewallRuleSourceList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdNsxvFirewallRuleSourceOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_firewall_rule vcd_nsxv_firewall_rule}
*/
export declare class DataVcdNsxvFirewallRule extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_nsxv_firewall_rule";
    /**
    * Generates CDKTF code for importing a DataVcdNsxvFirewallRule resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdNsxvFirewallRule to import
    * @param importFromId The id of the existing DataVcdNsxvFirewallRule that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_firewall_rule#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdNsxvFirewallRule to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/nsxv_firewall_rule vcd_nsxv_firewall_rule} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdNsxvFirewallRuleConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdNsxvFirewallRuleConfig);
    get action(): string;
    private _destination;
    get destination(): DataVcdNsxvFirewallRuleDestinationList;
    private _edgeGateway?;
    get edgeGateway(): string;
    set edgeGateway(value: string);
    get edgeGatewayInput(): string | undefined;
    get enabled(): cdktf.IResolvable;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get loggingEnabled(): cdktf.IResolvable;
    get name(): string;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    private _ruleId?;
    get ruleId(): string;
    set ruleId(value: string);
    get ruleIdInput(): string | undefined;
    get ruleTag(): number;
    get ruleType(): string;
    private _service;
    get service(): DataVcdNsxvFirewallRuleServiceList;
    private _source;
    get source(): DataVcdNsxvFirewallRuleSourceList;
    private _vdc?;
    get vdc(): string;
    set vdc(value: string);
    resetVdc(): void;
    get vdcInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
