import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdOrgLdapConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org_ldap#id DataVcdOrgLdap#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Organization ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org_ldap#org_id DataVcdOrgLdap#org_id}
    */
    readonly orgId: string;
}
export interface DataVcdOrgLdapCustomSettingsGroupAttributes {
}
export declare function dataVcdOrgLdapCustomSettingsGroupAttributesToTerraform(struct?: DataVcdOrgLdapCustomSettingsGroupAttributes): any;
export declare function dataVcdOrgLdapCustomSettingsGroupAttributesToHclTerraform(struct?: DataVcdOrgLdapCustomSettingsGroupAttributes): any;
export declare class DataVcdOrgLdapCustomSettingsGroupAttributesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdOrgLdapCustomSettingsGroupAttributes | undefined;
    set internalValue(value: DataVcdOrgLdapCustomSettingsGroupAttributes | undefined);
    get groupBackLinkIdentifier(): string;
    get groupMembershipIdentifier(): string;
    get membership(): string;
    get name(): string;
    get objectClass(): string;
    get uniqueIdentifier(): string;
}
export declare class DataVcdOrgLdapCustomSettingsGroupAttributesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdOrgLdapCustomSettingsGroupAttributesOutputReference;
}
export interface DataVcdOrgLdapCustomSettingsUserAttributes {
}
export declare function dataVcdOrgLdapCustomSettingsUserAttributesToTerraform(struct?: DataVcdOrgLdapCustomSettingsUserAttributes): any;
export declare function dataVcdOrgLdapCustomSettingsUserAttributesToHclTerraform(struct?: DataVcdOrgLdapCustomSettingsUserAttributes): any;
export declare class DataVcdOrgLdapCustomSettingsUserAttributesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdOrgLdapCustomSettingsUserAttributes | undefined;
    set internalValue(value: DataVcdOrgLdapCustomSettingsUserAttributes | undefined);
    get displayName(): string;
    get email(): string;
    get givenName(): string;
    get groupBackLinkIdentifier(): string;
    get groupMembershipIdentifier(): string;
    get objectClass(): string;
    get surname(): string;
    get telephone(): string;
    get uniqueIdentifier(): string;
    get username(): string;
}
export declare class DataVcdOrgLdapCustomSettingsUserAttributesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdOrgLdapCustomSettingsUserAttributesOutputReference;
}
export interface DataVcdOrgLdapCustomSettings {
}
export declare function dataVcdOrgLdapCustomSettingsToTerraform(struct?: DataVcdOrgLdapCustomSettings): any;
export declare function dataVcdOrgLdapCustomSettingsToHclTerraform(struct?: DataVcdOrgLdapCustomSettings): any;
export declare class DataVcdOrgLdapCustomSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdOrgLdapCustomSettings | undefined;
    set internalValue(value: DataVcdOrgLdapCustomSettings | undefined);
    get authenticationMethod(): string;
    get baseDistinguishedName(): string;
    get connectorType(): string;
    private _groupAttributes;
    get groupAttributes(): DataVcdOrgLdapCustomSettingsGroupAttributesList;
    get isSsl(): cdktf.IResolvable;
    get password(): string;
    get port(): number;
    get server(): string;
    private _userAttributes;
    get userAttributes(): DataVcdOrgLdapCustomSettingsUserAttributesList;
    get username(): string;
}
export declare class DataVcdOrgLdapCustomSettingsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdOrgLdapCustomSettingsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org_ldap vcd_org_ldap}
*/
export declare class DataVcdOrgLdap extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_org_ldap";
    /**
    * Generates CDKTF code for importing a DataVcdOrgLdap resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdOrgLdap to import
    * @param importFromId The id of the existing DataVcdOrgLdap that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org_ldap#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdOrgLdap to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org_ldap vcd_org_ldap} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdOrgLdapConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdOrgLdapConfig);
    private _customSettings;
    get customSettings(): DataVcdOrgLdapCustomSettingsList;
    get customUserOu(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get ldapMode(): string;
    private _orgId?;
    get orgId(): string;
    set orgId(value: string);
    get orgIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
