import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdOrgSamlMetadataConfig extends cdktf.TerraformMetaArguments {
    /**
    * Optional file name where to store the metadata
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org_saml_metadata#file_name DataVcdOrgSamlMetadata#file_name}
    */
    readonly fileName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org_saml_metadata#id DataVcdOrgSamlMetadata#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * ID of the Org from which we want the SAML metadata
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org_saml_metadata#org_id DataVcdOrgSamlMetadata#org_id}
    */
    readonly orgId: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org_saml_metadata vcd_org_saml_metadata}
*/
export declare class DataVcdOrgSamlMetadata extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_org_saml_metadata";
    /**
    * Generates CDKTF code for importing a DataVcdOrgSamlMetadata resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdOrgSamlMetadata to import
    * @param importFromId The id of the existing DataVcdOrgSamlMetadata that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org_saml_metadata#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdOrgSamlMetadata to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org_saml_metadata vcd_org_saml_metadata} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdOrgSamlMetadataConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdOrgSamlMetadataConfig);
    private _fileName?;
    get fileName(): string;
    set fileName(value: string);
    resetFileName(): void;
    get fileNameInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get metadataText(): string;
    private _orgId?;
    get orgId(): string;
    set orgId(value: string);
    get orgIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
