import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdOrgUserConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org_user#id DataVcdOrgUser#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * User's name. Required if "user_id" is not set
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org_user#name DataVcdOrgUser#name}
    */
    readonly name?: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org_user#org DataVcdOrgUser#org}
    */
    readonly org?: string;
    /**
    * User's id. Required if "name" is not set
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org_user#user_id DataVcdOrgUser#user_id}
    */
    readonly userId?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org_user vcd_org_user}
*/
export declare class DataVcdOrgUser extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_org_user";
    /**
    * Generates CDKTF code for importing a DataVcdOrgUser resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdOrgUser to import
    * @param importFromId The id of the existing DataVcdOrgUser that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org_user#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdOrgUser to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org_user vcd_org_user} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdOrgUserConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataVcdOrgUserConfig);
    get deployedVmQuota(): number;
    get description(): string;
    get emailAddress(): string;
    get enabled(): cdktf.IResolvable;
    get fullName(): string;
    get groupNames(): string[];
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get instantMessaging(): string;
    get isExternal(): cdktf.IResolvable;
    get isGroupRole(): cdktf.IResolvable;
    get isLocked(): cdktf.IResolvable;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    get providerType(): string;
    get role(): string;
    get storedVmQuota(): number;
    get telephone(): string;
    private _userId?;
    get userId(): string;
    set userId(value: string);
    resetUserId(): void;
    get userIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
