import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdOrgVdcNsxtNetworkProfileConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org_vdc_nsxt_network_profile#id DataVcdOrgVdcNsxtNetworkProfile#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org_vdc_nsxt_network_profile#org DataVcdOrgVdcNsxtNetworkProfile#org}
    */
    readonly org?: string;
    /**
    * The name of VDC to use, optional if defined at provider level
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org_vdc_nsxt_network_profile#vdc DataVcdOrgVdcNsxtNetworkProfile#vdc}
    */
    readonly vdc?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org_vdc_nsxt_network_profile vcd_org_vdc_nsxt_network_profile}
*/
export declare class DataVcdOrgVdcNsxtNetworkProfile extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_org_vdc_nsxt_network_profile";
    /**
    * Generates CDKTF code for importing a DataVcdOrgVdcNsxtNetworkProfile resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdOrgVdcNsxtNetworkProfile to import
    * @param importFromId The id of the existing DataVcdOrgVdcNsxtNetworkProfile that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org_vdc_nsxt_network_profile#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdOrgVdcNsxtNetworkProfile to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org_vdc_nsxt_network_profile vcd_org_vdc_nsxt_network_profile} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdOrgVdcNsxtNetworkProfileConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataVcdOrgVdcNsxtNetworkProfileConfig);
    get edgeClusterId(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    get vappNetworksDefaultSegmentProfileTemplateId(): string;
    private _vdc?;
    get vdc(): string;
    set vdc(value: string);
    resetVdc(): void;
    get vdcInput(): string | undefined;
    get vdcNetworksDefaultSegmentProfileTemplateId(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
