import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdOrgVdcConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org_vdc#id DataVcdOrgVdc#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org_vdc#name DataVcdOrgVdc#name}
    */
    readonly name: string;
    /**
    * Organization to create the VDC in
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org_vdc#org DataVcdOrgVdc#org}
    */
    readonly org?: string;
}
export interface DataVcdOrgVdcComputeCapacityCpu {
}
export declare function dataVcdOrgVdcComputeCapacityCpuToTerraform(struct?: DataVcdOrgVdcComputeCapacityCpu): any;
export declare function dataVcdOrgVdcComputeCapacityCpuToHclTerraform(struct?: DataVcdOrgVdcComputeCapacityCpu): any;
export declare class DataVcdOrgVdcComputeCapacityCpuOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdOrgVdcComputeCapacityCpu | undefined;
    set internalValue(value: DataVcdOrgVdcComputeCapacityCpu | undefined);
    get allocated(): number;
    get limit(): number;
    get reserved(): number;
    get used(): number;
}
export declare class DataVcdOrgVdcComputeCapacityCpuList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdOrgVdcComputeCapacityCpuOutputReference;
}
export interface DataVcdOrgVdcComputeCapacityMemory {
}
export declare function dataVcdOrgVdcComputeCapacityMemoryToTerraform(struct?: DataVcdOrgVdcComputeCapacityMemory): any;
export declare function dataVcdOrgVdcComputeCapacityMemoryToHclTerraform(struct?: DataVcdOrgVdcComputeCapacityMemory): any;
export declare class DataVcdOrgVdcComputeCapacityMemoryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdOrgVdcComputeCapacityMemory | undefined;
    set internalValue(value: DataVcdOrgVdcComputeCapacityMemory | undefined);
    get allocated(): number;
    get limit(): number;
    get reserved(): number;
    get used(): number;
}
export declare class DataVcdOrgVdcComputeCapacityMemoryList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdOrgVdcComputeCapacityMemoryOutputReference;
}
export interface DataVcdOrgVdcComputeCapacity {
}
export declare function dataVcdOrgVdcComputeCapacityToTerraform(struct?: DataVcdOrgVdcComputeCapacity): any;
export declare function dataVcdOrgVdcComputeCapacityToHclTerraform(struct?: DataVcdOrgVdcComputeCapacity): any;
export declare class DataVcdOrgVdcComputeCapacityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdOrgVdcComputeCapacity | undefined;
    set internalValue(value: DataVcdOrgVdcComputeCapacity | undefined);
    private _cpu;
    get cpu(): DataVcdOrgVdcComputeCapacityCpuList;
    private _memory;
    get memory(): DataVcdOrgVdcComputeCapacityMemoryList;
}
export declare class DataVcdOrgVdcComputeCapacityList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdOrgVdcComputeCapacityOutputReference;
}
export interface DataVcdOrgVdcMetadataEntry {
}
export declare function dataVcdOrgVdcMetadataEntryToTerraform(struct?: DataVcdOrgVdcMetadataEntry): any;
export declare function dataVcdOrgVdcMetadataEntryToHclTerraform(struct?: DataVcdOrgVdcMetadataEntry): any;
export declare class DataVcdOrgVdcMetadataEntryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdOrgVdcMetadataEntry | undefined;
    set internalValue(value: DataVcdOrgVdcMetadataEntry | undefined);
    get isSystem(): cdktf.IResolvable;
    get key(): string;
    get type(): string;
    get userAccess(): string;
    get value(): string;
}
export declare class DataVcdOrgVdcMetadataEntryList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdOrgVdcMetadataEntryOutputReference;
}
export interface DataVcdOrgVdcStorageProfile {
}
export declare function dataVcdOrgVdcStorageProfileToTerraform(struct?: DataVcdOrgVdcStorageProfile): any;
export declare function dataVcdOrgVdcStorageProfileToHclTerraform(struct?: DataVcdOrgVdcStorageProfile): any;
export declare class DataVcdOrgVdcStorageProfileOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdOrgVdcStorageProfile | undefined;
    set internalValue(value: DataVcdOrgVdcStorageProfile | undefined);
    get default(): cdktf.IResolvable;
    get enabled(): cdktf.IResolvable;
    get limit(): number;
    get name(): string;
    get storageUsedInMb(): number;
}
export declare class DataVcdOrgVdcStorageProfileList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdOrgVdcStorageProfileOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org_vdc vcd_org_vdc}
*/
export declare class DataVcdOrgVdc extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_org_vdc";
    /**
    * Generates CDKTF code for importing a DataVcdOrgVdc resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdOrgVdc to import
    * @param importFromId The id of the existing DataVcdOrgVdc that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org_vdc#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdOrgVdc to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org_vdc vcd_org_vdc} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdOrgVdcConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdOrgVdcConfig);
    get allocationModel(): string;
    get allowOverCommit(): cdktf.IResolvable;
    private _computeCapacity;
    get computeCapacity(): DataVcdOrgVdcComputeCapacityList;
    get cpuGuaranteed(): number;
    get cpuSpeed(): number;
    get defaultComputePolicyId(): string;
    get defaultVmSizingPolicyId(): string;
    get description(): string;
    get edgeClusterId(): string;
    get elasticity(): cdktf.IResolvable;
    get enableFastProvisioning(): cdktf.IResolvable;
    get enableNsxvDistributedFirewall(): cdktf.IResolvable;
    get enableThinProvisioning(): cdktf.IResolvable;
    get enableVmDiscovery(): cdktf.IResolvable;
    get enabled(): cdktf.IResolvable;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get includeVmMemoryOverhead(): cdktf.IResolvable;
    get memoryGuaranteed(): number;
    private _metadata;
    get metadata(): cdktf.StringMap;
    private _metadataEntry;
    get metadataEntry(): DataVcdOrgVdcMetadataEntryList;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get networkPoolName(): string;
    get networkQuota(): number;
    get nicQuota(): number;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    get providerVdcName(): string;
    private _storageProfile;
    get storageProfile(): DataVcdOrgVdcStorageProfileList;
    get vmPlacementPolicyIds(): string[];
    get vmQuota(): number;
    get vmSizingPolicyIds(): string[];
    get vmVgpuPolicyIds(): string[];
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
