import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdOrgConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org#id DataVcdOrg#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Organization name for lookup
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org#name DataVcdOrg#name}
    */
    readonly name: string;
}
export interface DataVcdOrgMetadataEntry {
}
export declare function dataVcdOrgMetadataEntryToTerraform(struct?: DataVcdOrgMetadataEntry): any;
export declare function dataVcdOrgMetadataEntryToHclTerraform(struct?: DataVcdOrgMetadataEntry): any;
export declare class DataVcdOrgMetadataEntryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdOrgMetadataEntry | undefined;
    set internalValue(value: DataVcdOrgMetadataEntry | undefined);
    get isSystem(): cdktf.IResolvable;
    get key(): string;
    get type(): string;
    get userAccess(): string;
    get value(): string;
}
export declare class DataVcdOrgMetadataEntryList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdOrgMetadataEntryOutputReference;
}
export interface DataVcdOrgVappLease {
}
export declare function dataVcdOrgVappLeaseToTerraform(struct?: DataVcdOrgVappLease): any;
export declare function dataVcdOrgVappLeaseToHclTerraform(struct?: DataVcdOrgVappLease): any;
export declare class DataVcdOrgVappLeaseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdOrgVappLease | undefined;
    set internalValue(value: DataVcdOrgVappLease | undefined);
    get deleteOnStorageLeaseExpiration(): cdktf.IResolvable;
    get maximumRuntimeLeaseInSec(): number;
    get maximumStorageLeaseInSec(): number;
    get powerOffOnRuntimeLeaseExpiration(): cdktf.IResolvable;
}
export declare class DataVcdOrgVappLeaseList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdOrgVappLeaseOutputReference;
}
export interface DataVcdOrgVappTemplateLease {
}
export declare function dataVcdOrgVappTemplateLeaseToTerraform(struct?: DataVcdOrgVappTemplateLease): any;
export declare function dataVcdOrgVappTemplateLeaseToHclTerraform(struct?: DataVcdOrgVappTemplateLease): any;
export declare class DataVcdOrgVappTemplateLeaseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdOrgVappTemplateLease | undefined;
    set internalValue(value: DataVcdOrgVappTemplateLease | undefined);
    get deleteOnStorageLeaseExpiration(): cdktf.IResolvable;
    get maximumStorageLeaseInSec(): number;
}
export declare class DataVcdOrgVappTemplateLeaseList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdOrgVappTemplateLeaseOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org vcd_org}
*/
export declare class DataVcdOrg extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_org";
    /**
    * Generates CDKTF code for importing a DataVcdOrg resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdOrg to import
    * @param importFromId The id of the existing DataVcdOrg that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdOrg to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/org vcd_org} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdOrgConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdOrgConfig);
    get canPublishCatalogs(): cdktf.IResolvable;
    get canPublishExternalCatalogs(): cdktf.IResolvable;
    get canSubscribeExternalCatalogs(): cdktf.IResolvable;
    get delayAfterPowerOnSeconds(): number;
    get deployedVmQuota(): number;
    get description(): string;
    get fullName(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get isEnabled(): cdktf.IResolvable;
    get listOfCatalogs(): string[];
    get listOfVdcs(): string[];
    private _metadata;
    get metadata(): cdktf.StringMap;
    private _metadataEntry;
    get metadataEntry(): DataVcdOrgMetadataEntryList;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get numberOfCatalogs(): number;
    get numberOfVdcs(): number;
    get storedVmQuota(): number;
    private _vappLease;
    get vappLease(): DataVcdOrgVappLeaseList;
    private _vappTemplateLease;
    get vappTemplateLease(): DataVcdOrgVappTemplateLeaseList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
