import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdPortgroupConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/portgroup#id DataVcdPortgroup#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Name of NSX-T Tier-0 router.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/portgroup#name DataVcdPortgroup#name}
    */
    readonly name: string;
    /**
    * Portgroup type. One of 'NETWORK', 'DV_PORTGROUP'
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/portgroup#type DataVcdPortgroup#type}
    */
    readonly type: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/portgroup vcd_portgroup}
*/
export declare class DataVcdPortgroup extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_portgroup";
    /**
    * Generates CDKTF code for importing a DataVcdPortgroup resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdPortgroup to import
    * @param importFromId The id of the existing DataVcdPortgroup that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/portgroup#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdPortgroup to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/portgroup vcd_portgroup} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdPortgroupConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdPortgroupConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
