import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdProviderVdcConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/provider_vdc#id DataVcdProviderVdc#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Name of the Provider VDC
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/provider_vdc#name DataVcdProviderVdc#name}
    */
    readonly name: string;
}
export interface DataVcdProviderVdcComputeCapacityCpu {
}
export declare function dataVcdProviderVdcComputeCapacityCpuToTerraform(struct?: DataVcdProviderVdcComputeCapacityCpu): any;
export declare function dataVcdProviderVdcComputeCapacityCpuToHclTerraform(struct?: DataVcdProviderVdcComputeCapacityCpu): any;
export declare class DataVcdProviderVdcComputeCapacityCpuOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdProviderVdcComputeCapacityCpu | undefined;
    set internalValue(value: DataVcdProviderVdcComputeCapacityCpu | undefined);
    get allocation(): number;
    get overhead(): number;
    get reserved(): number;
    get total(): number;
    get units(): string;
    get used(): number;
}
export declare class DataVcdProviderVdcComputeCapacityCpuList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdProviderVdcComputeCapacityCpuOutputReference;
}
export interface DataVcdProviderVdcComputeCapacityMemory {
}
export declare function dataVcdProviderVdcComputeCapacityMemoryToTerraform(struct?: DataVcdProviderVdcComputeCapacityMemory): any;
export declare function dataVcdProviderVdcComputeCapacityMemoryToHclTerraform(struct?: DataVcdProviderVdcComputeCapacityMemory): any;
export declare class DataVcdProviderVdcComputeCapacityMemoryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdProviderVdcComputeCapacityMemory | undefined;
    set internalValue(value: DataVcdProviderVdcComputeCapacityMemory | undefined);
    get allocation(): number;
    get overhead(): number;
    get reserved(): number;
    get total(): number;
    get units(): string;
    get used(): number;
}
export declare class DataVcdProviderVdcComputeCapacityMemoryList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdProviderVdcComputeCapacityMemoryOutputReference;
}
export interface DataVcdProviderVdcComputeCapacity {
}
export declare function dataVcdProviderVdcComputeCapacityToTerraform(struct?: DataVcdProviderVdcComputeCapacity): any;
export declare function dataVcdProviderVdcComputeCapacityToHclTerraform(struct?: DataVcdProviderVdcComputeCapacity): any;
export declare class DataVcdProviderVdcComputeCapacityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdProviderVdcComputeCapacity | undefined;
    set internalValue(value: DataVcdProviderVdcComputeCapacity | undefined);
    private _cpu;
    get cpu(): DataVcdProviderVdcComputeCapacityCpuList;
    get isElastic(): cdktf.IResolvable;
    get isHa(): cdktf.IResolvable;
    private _memory;
    get memory(): DataVcdProviderVdcComputeCapacityMemoryList;
}
export declare class DataVcdProviderVdcComputeCapacityList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdProviderVdcComputeCapacityOutputReference;
}
export interface DataVcdProviderVdcMetadataEntry {
}
export declare function dataVcdProviderVdcMetadataEntryToTerraform(struct?: DataVcdProviderVdcMetadataEntry): any;
export declare function dataVcdProviderVdcMetadataEntryToHclTerraform(struct?: DataVcdProviderVdcMetadataEntry): any;
export declare class DataVcdProviderVdcMetadataEntryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdProviderVdcMetadataEntry | undefined;
    set internalValue(value: DataVcdProviderVdcMetadataEntry | undefined);
    get isSystem(): cdktf.IResolvable;
    get key(): string;
    get type(): string;
    get userAccess(): string;
    get value(): string;
}
export declare class DataVcdProviderVdcMetadataEntryList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdProviderVdcMetadataEntryOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/provider_vdc vcd_provider_vdc}
*/
export declare class DataVcdProviderVdc extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_provider_vdc";
    /**
    * Generates CDKTF code for importing a DataVcdProviderVdc resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdProviderVdc to import
    * @param importFromId The id of the existing DataVcdProviderVdc that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/provider_vdc#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdProviderVdc to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/provider_vdc vcd_provider_vdc} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdProviderVdcConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdProviderVdcConfig);
    get capabilities(): string[];
    private _computeCapacity;
    get computeCapacity(): DataVcdProviderVdcComputeCapacityList;
    get computeProviderScope(): string;
    get description(): string;
    get externalNetworkIds(): string[];
    get highestSupportedHardwareVersion(): string;
    get hostIds(): string[];
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get isEnabled(): cdktf.IResolvable;
    private _metadata;
    get metadata(): cdktf.StringMap;
    private _metadataEntry;
    get metadataEntry(): DataVcdProviderVdcMetadataEntryList;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get networkPoolIds(): string[];
    get nsxtManagerId(): string;
    get resourcePoolIds(): string[];
    get status(): number;
    get storageContainerIds(): string[];
    get storageProfileIds(): string[];
    get storageProfileNames(): string[];
    get universalNetworkPoolId(): string;
    get vcenterId(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
