import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdRdeInterfaceBehaviorConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/rde_interface_behavior#id DataVcdRdeInterfaceBehavior#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The name of the Behavior to fetch
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/rde_interface_behavior#name DataVcdRdeInterfaceBehavior#name}
    */
    readonly name: string;
    /**
    * The ID of the RDE Interface that owns the Behavior to fetch
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/rde_interface_behavior#rde_interface_id DataVcdRdeInterfaceBehavior#rde_interface_id}
    */
    readonly rdeInterfaceId: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/rde_interface_behavior vcd_rde_interface_behavior}
*/
export declare class DataVcdRdeInterfaceBehavior extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_rde_interface_behavior";
    /**
    * Generates CDKTF code for importing a DataVcdRdeInterfaceBehavior resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdRdeInterfaceBehavior to import
    * @param importFromId The id of the existing DataVcdRdeInterfaceBehavior that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/rde_interface_behavior#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdRdeInterfaceBehavior to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/rde_interface_behavior vcd_rde_interface_behavior} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdRdeInterfaceBehaviorConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdRdeInterfaceBehaviorConfig);
    get description(): string;
    private _execution;
    get execution(): cdktf.StringMap;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _rdeInterfaceId?;
    get rdeInterfaceId(): string;
    set rdeInterfaceId(value: string);
    get rdeInterfaceIdInput(): string | undefined;
    get ref(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
