import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdRdeTypeBehaviorConfig extends cdktf.TerraformMetaArguments {
    /**
    * The ID of either a RDE Interface Behavior or RDE Type Behavior
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/rde_type_behavior#behavior_id DataVcdRdeTypeBehavior#behavior_id}
    */
    readonly behaviorId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/rde_type_behavior#id DataVcdRdeTypeBehavior#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The ID of the RDE Type that owns the Behavior to fetch
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/rde_type_behavior#rde_type_id DataVcdRdeTypeBehavior#rde_type_id}
    */
    readonly rdeTypeId: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/rde_type_behavior vcd_rde_type_behavior}
*/
export declare class DataVcdRdeTypeBehavior extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_rde_type_behavior";
    /**
    * Generates CDKTF code for importing a DataVcdRdeTypeBehavior resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdRdeTypeBehavior to import
    * @param importFromId The id of the existing DataVcdRdeTypeBehavior that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/rde_type_behavior#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdRdeTypeBehavior to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/rde_type_behavior vcd_rde_type_behavior} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdRdeTypeBehaviorConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdRdeTypeBehaviorConfig);
    private _behaviorId?;
    get behaviorId(): string;
    set behaviorId(value: string);
    get behaviorIdInput(): string | undefined;
    get description(): string;
    private _execution;
    get execution(): cdktf.StringMap;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get name(): string;
    private _rdeTypeId?;
    get rdeTypeId(): string;
    set rdeTypeId(value: string);
    get rdeTypeIdInput(): string | undefined;
    get ref(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
