import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdResourceSchemaConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/resource_schema#id DataVcdResourceSchema#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Unique name of the structure
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/resource_schema#name DataVcdResourceSchema#name}
    */
    readonly name: string;
    /**
    * Which resource we should list
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/resource_schema#resource_type DataVcdResourceSchema#resource_type}
    */
    readonly resourceType: string;
}
export interface DataVcdResourceSchemaAttributes {
}
export declare function dataVcdResourceSchemaAttributesToTerraform(struct?: DataVcdResourceSchemaAttributes): any;
export declare function dataVcdResourceSchemaAttributesToHclTerraform(struct?: DataVcdResourceSchemaAttributes): any;
export declare class DataVcdResourceSchemaAttributesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdResourceSchemaAttributes | undefined;
    set internalValue(value: DataVcdResourceSchemaAttributes | undefined);
    get computed(): cdktf.IResolvable;
    get description(): string;
    get name(): string;
    get optional(): cdktf.IResolvable;
    get required(): cdktf.IResolvable;
    get sensitive(): cdktf.IResolvable;
    get type(): string;
}
export declare class DataVcdResourceSchemaAttributesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdResourceSchemaAttributesOutputReference;
}
export interface DataVcdResourceSchemaBlockAttributesAttributes {
}
export declare function dataVcdResourceSchemaBlockAttributesAttributesToTerraform(struct?: DataVcdResourceSchemaBlockAttributesAttributes): any;
export declare function dataVcdResourceSchemaBlockAttributesAttributesToHclTerraform(struct?: DataVcdResourceSchemaBlockAttributesAttributes): any;
export declare class DataVcdResourceSchemaBlockAttributesAttributesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdResourceSchemaBlockAttributesAttributes | undefined;
    set internalValue(value: DataVcdResourceSchemaBlockAttributesAttributes | undefined);
    get computed(): cdktf.IResolvable;
    get description(): string;
    get name(): string;
    get optional(): cdktf.IResolvable;
    get required(): cdktf.IResolvable;
    get sensitive(): cdktf.IResolvable;
    get type(): string;
}
export declare class DataVcdResourceSchemaBlockAttributesAttributesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdResourceSchemaBlockAttributesAttributesOutputReference;
}
export interface DataVcdResourceSchemaBlockAttributes {
}
export declare function dataVcdResourceSchemaBlockAttributesToTerraform(struct?: DataVcdResourceSchemaBlockAttributes): any;
export declare function dataVcdResourceSchemaBlockAttributesToHclTerraform(struct?: DataVcdResourceSchemaBlockAttributes): any;
export declare class DataVcdResourceSchemaBlockAttributesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdResourceSchemaBlockAttributes | undefined;
    set internalValue(value: DataVcdResourceSchemaBlockAttributes | undefined);
    private _attributes;
    get attributes(): DataVcdResourceSchemaBlockAttributesAttributesList;
    get name(): string;
    get nestingMode(): string;
}
export declare class DataVcdResourceSchemaBlockAttributesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdResourceSchemaBlockAttributesOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/resource_schema vcd_resource_schema}
*/
export declare class DataVcdResourceSchema extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_resource_schema";
    /**
    * Generates CDKTF code for importing a DataVcdResourceSchema resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdResourceSchema to import
    * @param importFromId The id of the existing DataVcdResourceSchema that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/resource_schema#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdResourceSchema to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/resource_schema vcd_resource_schema} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdResourceSchemaConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdResourceSchemaConfig);
    private _attributes;
    get attributes(): DataVcdResourceSchemaAttributesList;
    private _blockAttributes;
    get blockAttributes(): DataVcdResourceSchemaBlockAttributesList;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _resourceType?;
    get resourceType(): string;
    set resourceType(value: string);
    get resourceTypeInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
