import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdRightConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/right#id DataVcdRight#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Name of Right.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/right#name DataVcdRight#name}
    */
    readonly name: string;
}
export interface DataVcdRightImpliedRights {
}
export declare function dataVcdRightImpliedRightsToTerraform(struct?: DataVcdRightImpliedRights): any;
export declare function dataVcdRightImpliedRightsToHclTerraform(struct?: DataVcdRightImpliedRights): any;
export declare class DataVcdRightImpliedRightsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdRightImpliedRights | undefined;
    set internalValue(value: DataVcdRightImpliedRights | undefined);
    get id(): string;
    get name(): string;
}
export declare class DataVcdRightImpliedRightsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdRightImpliedRightsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/right vcd_right}
*/
export declare class DataVcdRight extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_right";
    /**
    * Generates CDKTF code for importing a DataVcdRight resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdRight to import
    * @param importFromId The id of the existing DataVcdRight that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/right#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdRight to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/right vcd_right} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdRightConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdRightConfig);
    get bundleKey(): string;
    get categoryId(): string;
    get description(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _impliedRights;
    get impliedRights(): DataVcdRightImpliedRightsList;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get rightType(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
