import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdRightsBundleConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/rights_bundle#id DataVcdRightsBundle#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Name of rights bundle.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/rights_bundle#name DataVcdRightsBundle#name}
    */
    readonly name: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/rights_bundle vcd_rights_bundle}
*/
export declare class DataVcdRightsBundle extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_rights_bundle";
    /**
    * Generates CDKTF code for importing a DataVcdRightsBundle resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdRightsBundle to import
    * @param importFromId The id of the existing DataVcdRightsBundle that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/rights_bundle#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdRightsBundle to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/rights_bundle vcd_rights_bundle} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdRightsBundleConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdRightsBundleConfig);
    get bundleKey(): string;
    get description(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get publishToAllTenants(): cdktf.IResolvable;
    get readOnly(): cdktf.IResolvable;
    get rights(): string[];
    get tenants(): string[];
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
