import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdSubscribedCatalogConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/subscribed_catalog#id DataVcdSubscribedCatalog#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/subscribed_catalog#name DataVcdSubscribedCatalog#name}
    */
    readonly name: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/subscribed_catalog#org DataVcdSubscribedCatalog#org}
    */
    readonly org?: string;
    /**
    * filter block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/subscribed_catalog#filter DataVcdSubscribedCatalog#filter}
    */
    readonly filter?: DataVcdSubscribedCatalogFilter;
}
export interface DataVcdSubscribedCatalogFilterMetadata {
    /**
    * True if is a metadata@SYSTEM key
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/subscribed_catalog#is_system DataVcdSubscribedCatalog#is_system}
    */
    readonly isSystem?: boolean | cdktf.IResolvable;
    /**
    * Metadata key (field name)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/subscribed_catalog#key DataVcdSubscribedCatalog#key}
    */
    readonly key: string;
    /**
    * Type of metadata value (needed only if "use_api_search" is true)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/subscribed_catalog#type DataVcdSubscribedCatalog#type}
    */
    readonly type?: string;
    /**
    * If true, will search the vCD using native metadata query (without regular expressions)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/subscribed_catalog#use_api_search DataVcdSubscribedCatalog#use_api_search}
    */
    readonly useApiSearch?: boolean | cdktf.IResolvable;
    /**
    * Metadata value (can be a regular expression if "use_api_search" is false)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/subscribed_catalog#value DataVcdSubscribedCatalog#value}
    */
    readonly value: string;
}
export declare function dataVcdSubscribedCatalogFilterMetadataToTerraform(struct?: DataVcdSubscribedCatalogFilterMetadata | cdktf.IResolvable): any;
export declare function dataVcdSubscribedCatalogFilterMetadataToHclTerraform(struct?: DataVcdSubscribedCatalogFilterMetadata | cdktf.IResolvable): any;
export declare class DataVcdSubscribedCatalogFilterMetadataOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdSubscribedCatalogFilterMetadata | cdktf.IResolvable | undefined;
    set internalValue(value: DataVcdSubscribedCatalogFilterMetadata | cdktf.IResolvable | undefined);
    private _isSystem?;
    get isSystem(): boolean | cdktf.IResolvable;
    set isSystem(value: boolean | cdktf.IResolvable);
    resetIsSystem(): void;
    get isSystemInput(): boolean | cdktf.IResolvable | undefined;
    private _key?;
    get key(): string;
    set key(value: string);
    get keyInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _useApiSearch?;
    get useApiSearch(): boolean | cdktf.IResolvable;
    set useApiSearch(value: boolean | cdktf.IResolvable);
    resetUseApiSearch(): void;
    get useApiSearchInput(): boolean | cdktf.IResolvable | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    get valueInput(): string | undefined;
}
export declare class DataVcdSubscribedCatalogFilterMetadataList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataVcdSubscribedCatalogFilterMetadata[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdSubscribedCatalogFilterMetadataOutputReference;
}
export interface DataVcdSubscribedCatalogFilter {
    /**
    * Search by date comparison ({>|>=|<|<=|==} yyyy-mm-dd[ hh[:mm[:ss]]])
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/subscribed_catalog#date DataVcdSubscribedCatalog#date}
    */
    readonly date?: string;
    /**
    * Retrieves the oldest item
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/subscribed_catalog#earliest DataVcdSubscribedCatalog#earliest}
    */
    readonly earliest?: boolean | cdktf.IResolvable;
    /**
    * Retrieves the newest item
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/subscribed_catalog#latest DataVcdSubscribedCatalog#latest}
    */
    readonly latest?: boolean | cdktf.IResolvable;
    /**
    * Search by name with a regular expression
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/subscribed_catalog#name_regex DataVcdSubscribedCatalog#name_regex}
    */
    readonly nameRegex?: string;
    /**
    * metadata block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/subscribed_catalog#metadata DataVcdSubscribedCatalog#metadata}
    */
    readonly metadata?: DataVcdSubscribedCatalogFilterMetadata[] | cdktf.IResolvable;
}
export declare function dataVcdSubscribedCatalogFilterToTerraform(struct?: DataVcdSubscribedCatalogFilterOutputReference | DataVcdSubscribedCatalogFilter): any;
export declare function dataVcdSubscribedCatalogFilterToHclTerraform(struct?: DataVcdSubscribedCatalogFilterOutputReference | DataVcdSubscribedCatalogFilter): any;
export declare class DataVcdSubscribedCatalogFilterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataVcdSubscribedCatalogFilter | undefined;
    set internalValue(value: DataVcdSubscribedCatalogFilter | undefined);
    private _date?;
    get date(): string;
    set date(value: string);
    resetDate(): void;
    get dateInput(): string | undefined;
    private _earliest?;
    get earliest(): boolean | cdktf.IResolvable;
    set earliest(value: boolean | cdktf.IResolvable);
    resetEarliest(): void;
    get earliestInput(): boolean | cdktf.IResolvable | undefined;
    private _latest?;
    get latest(): boolean | cdktf.IResolvable;
    set latest(value: boolean | cdktf.IResolvable);
    resetLatest(): void;
    get latestInput(): boolean | cdktf.IResolvable | undefined;
    private _nameRegex?;
    get nameRegex(): string;
    set nameRegex(value: string);
    resetNameRegex(): void;
    get nameRegexInput(): string | undefined;
    private _metadata;
    get metadata(): DataVcdSubscribedCatalogFilterMetadataList;
    putMetadata(value: DataVcdSubscribedCatalogFilterMetadata[] | cdktf.IResolvable): void;
    resetMetadata(): void;
    get metadataInput(): cdktf.IResolvable | DataVcdSubscribedCatalogFilterMetadata[] | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/subscribed_catalog vcd_subscribed_catalog}
*/
export declare class DataVcdSubscribedCatalog extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_subscribed_catalog";
    /**
    * Generates CDKTF code for importing a DataVcdSubscribedCatalog resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdSubscribedCatalog to import
    * @param importFromId The id of the existing DataVcdSubscribedCatalog that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/subscribed_catalog#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdSubscribedCatalog to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/subscribed_catalog vcd_subscribed_catalog} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdSubscribedCatalogConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdSubscribedCatalogConfig);
    get catalogVersion(): number;
    get created(): string;
    get description(): string;
    get failedTasks(): string[];
    get href(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get isLocal(): cdktf.IResolvable;
    get isPublished(): cdktf.IResolvable;
    get isShared(): cdktf.IResolvable;
    get makeLocalCopy(): cdktf.IResolvable;
    get mediaItemList(): string[];
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get numberOfMedia(): number;
    get numberOfVappTemplates(): number;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    get ownerName(): string;
    get publishSubscriptionType(): string;
    get runningTasks(): string[];
    get storageProfileId(): string;
    get subscriptionUrl(): string;
    get vappTemplateList(): string[];
    private _filter;
    get filter(): DataVcdSubscribedCatalogFilterOutputReference;
    putFilter(value: DataVcdSubscribedCatalogFilter): void;
    resetFilter(): void;
    get filterInput(): DataVcdSubscribedCatalogFilter | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
