import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdTaskConfig extends cdktf.TerraformMetaArguments {
    /**
    * ID of the task.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/task#id DataVcdTask#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/task vcd_task}
*/
export declare class DataVcdTask extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_task";
    /**
    * Generates CDKTF code for importing a DataVcdTask resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdTask to import
    * @param importFromId The id of the existing DataVcdTask that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/task#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdTask to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/task vcd_task} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdTaskConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdTaskConfig);
    get cancelRequested(): cdktf.IResolvable;
    get description(): string;
    get endTime(): string;
    get error(): string;
    get expiryTime(): string;
    get href(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    get idInput(): string | undefined;
    get name(): string;
    get operation(): string;
    get operationName(): string;
    get orgId(): string;
    get orgName(): string;
    get ownerId(): string;
    get ownerName(): string;
    get ownerType(): string;
    get progress(): number;
    get startTime(): string;
    get status(): string;
    get type(): string;
    get userId(): string;
    get userName(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
