import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdUiPluginConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ui_plugin#id DataVcdUiPlugin#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The UI Plugin name. Combination of `vendor`, `name` and `version` must be unique
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ui_plugin#name DataVcdUiPlugin#name}
    */
    readonly name: string;
    /**
    * The UI Plugin vendor name. Combination of `vendor`, `name` and `version` must be unique
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ui_plugin#vendor DataVcdUiPlugin#vendor}
    */
    readonly vendor: string;
    /**
    * The version of the UI Plugin. Combination of `vendor`, `name` and `version` must be unique
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ui_plugin#version DataVcdUiPlugin#version}
    */
    readonly version: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ui_plugin vcd_ui_plugin}
*/
export declare class DataVcdUiPlugin extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_ui_plugin";
    /**
    * Generates CDKTF code for importing a DataVcdUiPlugin resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdUiPlugin to import
    * @param importFromId The id of the existing DataVcdUiPlugin that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ui_plugin#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdUiPlugin to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/ui_plugin vcd_ui_plugin} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdUiPluginConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdUiPluginConfig);
    get description(): string;
    get enabled(): cdktf.IResolvable;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get license(): string;
    get link(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get providerScoped(): cdktf.IResolvable;
    get status(): string;
    get tenantIds(): string[];
    get tenantScoped(): cdktf.IResolvable;
    private _vendor?;
    get vendor(): string;
    set vendor(value: string);
    get vendorInput(): string | undefined;
    private _version?;
    get version(): string;
    set version(value: string);
    get versionInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
