import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdVappNetworkConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vapp_network#id DataVcdVappNetwork#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * vApp network name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vapp_network#name DataVcdVappNetwork#name}
    */
    readonly name: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vapp_network#org DataVcdVappNetwork#org}
    */
    readonly org?: string;
    /**
    * vApp to use
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vapp_network#vapp_name DataVcdVappNetwork#vapp_name}
    */
    readonly vappName: string;
    /**
    * The name of VDC to use, optional if defined at provider level
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vapp_network#vdc DataVcdVappNetwork#vdc}
    */
    readonly vdc?: string;
}
export interface DataVcdVappNetworkDhcpPool {
}
export declare function dataVcdVappNetworkDhcpPoolToTerraform(struct?: DataVcdVappNetworkDhcpPool): any;
export declare function dataVcdVappNetworkDhcpPoolToHclTerraform(struct?: DataVcdVappNetworkDhcpPool): any;
export declare class DataVcdVappNetworkDhcpPoolOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdVappNetworkDhcpPool | undefined;
    set internalValue(value: DataVcdVappNetworkDhcpPool | undefined);
    get defaultLeaseTime(): number;
    get enabled(): cdktf.IResolvable;
    get endAddress(): string;
    get maxLeaseTime(): number;
    get startAddress(): string;
}
export declare class DataVcdVappNetworkDhcpPoolList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdVappNetworkDhcpPoolOutputReference;
}
export interface DataVcdVappNetworkStaticIpPool {
}
export declare function dataVcdVappNetworkStaticIpPoolToTerraform(struct?: DataVcdVappNetworkStaticIpPool): any;
export declare function dataVcdVappNetworkStaticIpPoolToHclTerraform(struct?: DataVcdVappNetworkStaticIpPool): any;
export declare class DataVcdVappNetworkStaticIpPoolOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdVappNetworkStaticIpPool | undefined;
    set internalValue(value: DataVcdVappNetworkStaticIpPool | undefined);
    get endAddress(): string;
    get startAddress(): string;
}
export declare class DataVcdVappNetworkStaticIpPoolList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdVappNetworkStaticIpPoolOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vapp_network vcd_vapp_network}
*/
export declare class DataVcdVappNetwork extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_vapp_network";
    /**
    * Generates CDKTF code for importing a DataVcdVappNetwork resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdVappNetwork to import
    * @param importFromId The id of the existing DataVcdVappNetwork that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vapp_network#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdVappNetwork to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vapp_network vcd_vapp_network} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdVappNetworkConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdVappNetworkConfig);
    get description(): string;
    private _dhcpPool;
    get dhcpPool(): DataVcdVappNetworkDhcpPoolList;
    get dns1(): string;
    get dns2(): string;
    get dnsSuffix(): string;
    get gateway(): string;
    get guestVlanAllowed(): cdktf.IResolvable;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get netmask(): string;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    get orgNetworkName(): string;
    get prefixLength(): string;
    get retainIpMacEnabled(): cdktf.IResolvable;
    private _staticIpPool;
    get staticIpPool(): DataVcdVappNetworkStaticIpPoolList;
    private _vappName?;
    get vappName(): string;
    set vappName(value: string);
    get vappNameInput(): string | undefined;
    private _vdc?;
    get vdc(): string;
    set vdc(value: string);
    resetVdc(): void;
    get vdcInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
