import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdVdcGroupConfig extends cdktf.TerraformMetaArguments {
    /**
    * Default Policy Status
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vdc_group#default_policy_status DataVcdVdcGroup#default_policy_status}
    */
    readonly defaultPolicyStatus?: boolean | cdktf.IResolvable;
    /**
    * VDC group description
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vdc_group#description DataVcdVdcGroup#description}
    */
    readonly description?: string;
    /**
    * More detailed error message when VDC group has error status
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vdc_group#error_message DataVcdVdcGroup#error_message}
    */
    readonly errorMessage?: string;
    /**
    * VDC group ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vdc_group#id DataVcdVdcGroup#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Status whether local egress is enabled for a universal router belonging to a universal VDC group
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vdc_group#local_egress DataVcdVdcGroup#local_egress}
    */
    readonly localEgress?: boolean | cdktf.IResolvable;
    /**
    * Name of VDC group
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vdc_group#name DataVcdVdcGroup#name}
    */
    readonly name?: string;
    /**
    * ID of used network pool
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vdc_group#network_pool_id DataVcdVdcGroup#network_pool_id}
    */
    readonly networkPoolId?: string;
    /**
    * The network provider’s universal id that is backing the universal network pool
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vdc_group#network_pool_universal_id DataVcdVdcGroup#network_pool_universal_id}
    */
    readonly networkPoolUniversalId?: string;
    /**
    * Defines the networking provider backing the VDC Group
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vdc_group#network_provider_type DataVcdVdcGroup#network_provider_type}
    */
    readonly networkProviderType?: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vdc_group#org DataVcdVdcGroup#org}
    */
    readonly org?: string;
    /**
    * The status that the group can be in (e.g. 'SAVING', 'SAVED', 'CONFIGURING', 'REALIZED', 'REALIZATION_FAILED', 'DELETING', 'DELETE_FAILED', 'OBJECT_NOT_FOUND', 'UNCONFIGURED')
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vdc_group#status DataVcdVdcGroup#status}
    */
    readonly status?: string;
    /**
    * Defines the group as LOCAL or UNIVERSAL
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vdc_group#type DataVcdVdcGroup#type}
    */
    readonly type?: string;
    /**
    * True means that a VDC group router has been created
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vdc_group#universal_networking_enabled DataVcdVdcGroup#universal_networking_enabled}
    */
    readonly universalNetworkingEnabled?: boolean | cdktf.IResolvable;
}
export interface DataVcdVdcGroupParticipatingOrgVdcs {
}
export declare function dataVcdVdcGroupParticipatingOrgVdcsToTerraform(struct?: DataVcdVdcGroupParticipatingOrgVdcs): any;
export declare function dataVcdVdcGroupParticipatingOrgVdcsToHclTerraform(struct?: DataVcdVdcGroupParticipatingOrgVdcs): any;
export declare class DataVcdVdcGroupParticipatingOrgVdcsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdVdcGroupParticipatingOrgVdcs | undefined;
    set internalValue(value: DataVcdVdcGroupParticipatingOrgVdcs | undefined);
    get faultDomainTag(): string;
    get isRemoteOrg(): cdktf.IResolvable;
    get networkProviderScope(): string;
    get orgId(): string;
    get orgName(): string;
    get siteId(): string;
    get siteName(): string;
    get status(): string;
    get vdcId(): string;
    get vdcName(): string;
}
export declare class DataVcdVdcGroupParticipatingOrgVdcsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdVdcGroupParticipatingOrgVdcsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vdc_group vcd_vdc_group}
*/
export declare class DataVcdVdcGroup extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_vdc_group";
    /**
    * Generates CDKTF code for importing a DataVcdVdcGroup resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdVdcGroup to import
    * @param importFromId The id of the existing DataVcdVdcGroup that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vdc_group#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdVdcGroup to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vdc_group vcd_vdc_group} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdVdcGroupConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataVcdVdcGroupConfig);
    private _defaultPolicyStatus?;
    get defaultPolicyStatus(): boolean | cdktf.IResolvable;
    set defaultPolicyStatus(value: boolean | cdktf.IResolvable);
    resetDefaultPolicyStatus(): void;
    get defaultPolicyStatusInput(): boolean | cdktf.IResolvable | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    get dfwEnabled(): cdktf.IResolvable;
    private _errorMessage?;
    get errorMessage(): string;
    set errorMessage(value: string);
    resetErrorMessage(): void;
    get errorMessageInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _localEgress?;
    get localEgress(): boolean | cdktf.IResolvable;
    set localEgress(value: boolean | cdktf.IResolvable);
    resetLocalEgress(): void;
    get localEgressInput(): boolean | cdktf.IResolvable | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _networkPoolId?;
    get networkPoolId(): string;
    set networkPoolId(value: string);
    resetNetworkPoolId(): void;
    get networkPoolIdInput(): string | undefined;
    private _networkPoolUniversalId?;
    get networkPoolUniversalId(): string;
    set networkPoolUniversalId(value: string);
    resetNetworkPoolUniversalId(): void;
    get networkPoolUniversalIdInput(): string | undefined;
    private _networkProviderType?;
    get networkProviderType(): string;
    set networkProviderType(value: string);
    resetNetworkProviderType(): void;
    get networkProviderTypeInput(): string | undefined;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    private _participatingOrgVdcs;
    get participatingOrgVdcs(): DataVcdVdcGroupParticipatingOrgVdcsList;
    private _status?;
    get status(): string;
    set status(value: string);
    resetStatus(): void;
    get statusInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _universalNetworkingEnabled?;
    get universalNetworkingEnabled(): boolean | cdktf.IResolvable;
    set universalNetworkingEnabled(value: boolean | cdktf.IResolvable);
    resetUniversalNetworkingEnabled(): void;
    get universalNetworkingEnabledInput(): boolean | cdktf.IResolvable | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
