import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdVmGroupConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vm_group#id DataVcdVmGroup#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Name of the VM Group to fetch
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vm_group#name DataVcdVmGroup#name}
    */
    readonly name: string;
    /**
    * ID of the Provider VDC to which the VM Group to fetch belongs
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vm_group#provider_vdc_id DataVcdVmGroup#provider_vdc_id}
    */
    readonly providerVdcId: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vm_group vcd_vm_group}
*/
export declare class DataVcdVmGroup extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_vm_group";
    /**
    * Generates CDKTF code for importing a DataVcdVmGroup resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdVmGroup to import
    * @param importFromId The id of the existing DataVcdVmGroup that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vm_group#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdVmGroup to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vm_group vcd_vm_group} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdVmGroupConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdVmGroupConfig);
    get clusterMoref(): string;
    get clusterName(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get namedVmGroupId(): string;
    private _providerVdcId?;
    get providerVdcId(): string;
    set providerVdcId(value: string);
    get providerVdcIdInput(): string | undefined;
    get vcenterId(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
