import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdVmPlacementPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vm_placement_policy#id DataVcdVmPlacementPolicy#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Name of the VM Placement Policy
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vm_placement_policy#name DataVcdVmPlacementPolicy#name}
    */
    readonly name: string;
    /**
    * ID of the Provider VDC to which the VM Placement Policy belongs. To be used by System administrators instead of `vdc_id`
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vm_placement_policy#provider_vdc_id DataVcdVmPlacementPolicy#provider_vdc_id}
    */
    readonly providerVdcId?: string;
    /**
    * ID of the VDC to which the VM Placement Policy is assigned. To be used by tenants instead of `provider_vdc_id`
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vm_placement_policy#vdc_id DataVcdVmPlacementPolicy#vdc_id}
    */
    readonly vdcId?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vm_placement_policy vcd_vm_placement_policy}
*/
export declare class DataVcdVmPlacementPolicy extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_vm_placement_policy";
    /**
    * Generates CDKTF code for importing a DataVcdVmPlacementPolicy resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdVmPlacementPolicy to import
    * @param importFromId The id of the existing DataVcdVmPlacementPolicy that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vm_placement_policy#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdVmPlacementPolicy to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vm_placement_policy vcd_vm_placement_policy} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdVmPlacementPolicyConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdVmPlacementPolicyConfig);
    get description(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get logicalVmGroupIds(): string[];
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _providerVdcId?;
    get providerVdcId(): string;
    set providerVdcId(value: string);
    resetProviderVdcId(): void;
    get providerVdcIdInput(): string | undefined;
    private _vdcId?;
    get vdcId(): string;
    set vdcId(value: string);
    resetVdcId(): void;
    get vdcIdInput(): string | undefined;
    get vmGroupIds(): string[];
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
