import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdVmSizingPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vm_sizing_policy#id DataVcdVmSizingPolicy#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vm_sizing_policy#name DataVcdVmSizingPolicy#name}
    */
    readonly name: string;
    /**
    * The name of organization to use - Deprecated and unneeded: will be ignored if used
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vm_sizing_policy#org DataVcdVmSizingPolicy#org}
    */
    readonly org?: string;
}
export interface DataVcdVmSizingPolicyCpu {
}
export declare function dataVcdVmSizingPolicyCpuToTerraform(struct?: DataVcdVmSizingPolicyCpu): any;
export declare function dataVcdVmSizingPolicyCpuToHclTerraform(struct?: DataVcdVmSizingPolicyCpu): any;
export declare class DataVcdVmSizingPolicyCpuOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdVmSizingPolicyCpu | undefined;
    set internalValue(value: DataVcdVmSizingPolicyCpu | undefined);
    get coresPerSocket(): string;
    get count(): string;
    get limitInMhz(): string;
    get reservationGuarantee(): string;
    get shares(): string;
    get speedInMhz(): string;
}
export declare class DataVcdVmSizingPolicyCpuList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdVmSizingPolicyCpuOutputReference;
}
export interface DataVcdVmSizingPolicyMemory {
}
export declare function dataVcdVmSizingPolicyMemoryToTerraform(struct?: DataVcdVmSizingPolicyMemory): any;
export declare function dataVcdVmSizingPolicyMemoryToHclTerraform(struct?: DataVcdVmSizingPolicyMemory): any;
export declare class DataVcdVmSizingPolicyMemoryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdVmSizingPolicyMemory | undefined;
    set internalValue(value: DataVcdVmSizingPolicyMemory | undefined);
    get limitInMb(): string;
    get reservationGuarantee(): string;
    get shares(): string;
    get sizeInMb(): string;
}
export declare class DataVcdVmSizingPolicyMemoryList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdVmSizingPolicyMemoryOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vm_sizing_policy vcd_vm_sizing_policy}
*/
export declare class DataVcdVmSizingPolicy extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_vm_sizing_policy";
    /**
    * Generates CDKTF code for importing a DataVcdVmSizingPolicy resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdVmSizingPolicy to import
    * @param importFromId The id of the existing DataVcdVmSizingPolicy that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vm_sizing_policy#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdVmSizingPolicy to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vm_sizing_policy vcd_vm_sizing_policy} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdVmSizingPolicyConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdVmSizingPolicyConfig);
    private _cpu;
    get cpu(): DataVcdVmSizingPolicyCpuList;
    get description(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _memory;
    get memory(): DataVcdVmSizingPolicyMemoryList;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
