import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVcdVmVgpuPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vm_vgpu_policy#id DataVcdVmVgpuPolicy#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The unique name of the vGPU policy.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vm_vgpu_policy#name DataVcdVmVgpuPolicy#name}
    */
    readonly name: string;
}
export interface DataVcdVmVgpuPolicyCpu {
}
export declare function dataVcdVmVgpuPolicyCpuToTerraform(struct?: DataVcdVmVgpuPolicyCpu): any;
export declare function dataVcdVmVgpuPolicyCpuToHclTerraform(struct?: DataVcdVmVgpuPolicyCpu): any;
export declare class DataVcdVmVgpuPolicyCpuOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdVmVgpuPolicyCpu | undefined;
    set internalValue(value: DataVcdVmVgpuPolicyCpu | undefined);
    get coresPerSocket(): string;
    get count(): string;
    get limitInMhz(): string;
    get reservationGuarantee(): string;
    get shares(): string;
    get speedInMhz(): string;
}
export declare class DataVcdVmVgpuPolicyCpuList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdVmVgpuPolicyCpuOutputReference;
}
export interface DataVcdVmVgpuPolicyMemory {
}
export declare function dataVcdVmVgpuPolicyMemoryToTerraform(struct?: DataVcdVmVgpuPolicyMemory): any;
export declare function dataVcdVmVgpuPolicyMemoryToHclTerraform(struct?: DataVcdVmVgpuPolicyMemory): any;
export declare class DataVcdVmVgpuPolicyMemoryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdVmVgpuPolicyMemory | undefined;
    set internalValue(value: DataVcdVmVgpuPolicyMemory | undefined);
    get limitInMb(): string;
    get reservationGuarantee(): string;
    get shares(): string;
    get sizeInMb(): string;
}
export declare class DataVcdVmVgpuPolicyMemoryList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdVmVgpuPolicyMemoryOutputReference;
}
export interface DataVcdVmVgpuPolicyProviderVdcScope {
}
export declare function dataVcdVmVgpuPolicyProviderVdcScopeToTerraform(struct?: DataVcdVmVgpuPolicyProviderVdcScope): any;
export declare function dataVcdVmVgpuPolicyProviderVdcScopeToHclTerraform(struct?: DataVcdVmVgpuPolicyProviderVdcScope): any;
export declare class DataVcdVmVgpuPolicyProviderVdcScopeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdVmVgpuPolicyProviderVdcScope | undefined;
    set internalValue(value: DataVcdVmVgpuPolicyProviderVdcScope | undefined);
    get clusterNames(): string[];
    get providerVdcId(): string;
    get vmGroupId(): string;
}
export declare class DataVcdVmVgpuPolicyProviderVdcScopeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdVmVgpuPolicyProviderVdcScopeOutputReference;
}
export interface DataVcdVmVgpuPolicyVgpuProfile {
}
export declare function dataVcdVmVgpuPolicyVgpuProfileToTerraform(struct?: DataVcdVmVgpuPolicyVgpuProfile): any;
export declare function dataVcdVmVgpuPolicyVgpuProfileToHclTerraform(struct?: DataVcdVmVgpuPolicyVgpuProfile): any;
export declare class DataVcdVmVgpuPolicyVgpuProfileOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataVcdVmVgpuPolicyVgpuProfile | undefined;
    set internalValue(value: DataVcdVmVgpuPolicyVgpuProfile | undefined);
    get count(): number;
    get id(): string;
}
export declare class DataVcdVmVgpuPolicyVgpuProfileList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataVcdVmVgpuPolicyVgpuProfileOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vm_vgpu_policy vcd_vm_vgpu_policy}
*/
export declare class DataVcdVmVgpuPolicy extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vcd_vm_vgpu_policy";
    /**
    * Generates CDKTF code for importing a DataVcdVmVgpuPolicy resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVcdVmVgpuPolicy to import
    * @param importFromId The id of the existing DataVcdVmVgpuPolicy that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vm_vgpu_policy#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVcdVmVgpuPolicy to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/data-sources/vm_vgpu_policy vcd_vm_vgpu_policy} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVcdVmVgpuPolicyConfig
    */
    constructor(scope: Construct, id: string, config: DataVcdVmVgpuPolicyConfig);
    private _cpu;
    get cpu(): DataVcdVmVgpuPolicyCpuList;
    get description(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _memory;
    get memory(): DataVcdVmVgpuPolicyMemoryList;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _providerVdcScope;
    get providerVdcScope(): DataVcdVmVgpuPolicyProviderVdcScopeList;
    private _vgpuProfile;
    get vgpuProfile(): DataVcdVmVgpuPolicyVgpuProfileList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
