import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface EdgegatewayVpnConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/edgegateway_vpn#description EdgegatewayVpn#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/edgegateway_vpn#edge_gateway EdgegatewayVpn#edge_gateway}
    */
    readonly edgeGateway: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/edgegateway_vpn#encryption_protocol EdgegatewayVpn#encryption_protocol}
    */
    readonly encryptionProtocol: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/edgegateway_vpn#id EdgegatewayVpn#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/edgegateway_vpn#local_id EdgegatewayVpn#local_id}
    */
    readonly localId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/edgegateway_vpn#local_ip_address EdgegatewayVpn#local_ip_address}
    */
    readonly localIpAddress: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/edgegateway_vpn#mtu EdgegatewayVpn#mtu}
    */
    readonly mtu: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/edgegateway_vpn#name EdgegatewayVpn#name}
    */
    readonly name: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/edgegateway_vpn#org EdgegatewayVpn#org}
    */
    readonly org?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/edgegateway_vpn#peer_id EdgegatewayVpn#peer_id}
    */
    readonly peerId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/edgegateway_vpn#peer_ip_address EdgegatewayVpn#peer_ip_address}
    */
    readonly peerIpAddress: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/edgegateway_vpn#shared_secret EdgegatewayVpn#shared_secret}
    */
    readonly sharedSecret: string;
    /**
    * The name of VDC to use, optional if defined at provider level
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/edgegateway_vpn#vdc EdgegatewayVpn#vdc}
    */
    readonly vdc?: string;
    /**
    * local_subnets block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/edgegateway_vpn#local_subnets EdgegatewayVpn#local_subnets}
    */
    readonly localSubnets?: EdgegatewayVpnLocalSubnets[] | cdktf.IResolvable;
    /**
    * peer_subnets block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/edgegateway_vpn#peer_subnets EdgegatewayVpn#peer_subnets}
    */
    readonly peerSubnets?: EdgegatewayVpnPeerSubnets[] | cdktf.IResolvable;
}
export interface EdgegatewayVpnLocalSubnets {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/edgegateway_vpn#local_subnet_gateway EdgegatewayVpn#local_subnet_gateway}
    */
    readonly localSubnetGateway: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/edgegateway_vpn#local_subnet_mask EdgegatewayVpn#local_subnet_mask}
    */
    readonly localSubnetMask: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/edgegateway_vpn#local_subnet_name EdgegatewayVpn#local_subnet_name}
    */
    readonly localSubnetName: string;
}
export declare function edgegatewayVpnLocalSubnetsToTerraform(struct?: EdgegatewayVpnLocalSubnets | cdktf.IResolvable): any;
export declare function edgegatewayVpnLocalSubnetsToHclTerraform(struct?: EdgegatewayVpnLocalSubnets | cdktf.IResolvable): any;
export declare class EdgegatewayVpnLocalSubnetsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): EdgegatewayVpnLocalSubnets | cdktf.IResolvable | undefined;
    set internalValue(value: EdgegatewayVpnLocalSubnets | cdktf.IResolvable | undefined);
    private _localSubnetGateway?;
    get localSubnetGateway(): string;
    set localSubnetGateway(value: string);
    get localSubnetGatewayInput(): string | undefined;
    private _localSubnetMask?;
    get localSubnetMask(): string;
    set localSubnetMask(value: string);
    get localSubnetMaskInput(): string | undefined;
    private _localSubnetName?;
    get localSubnetName(): string;
    set localSubnetName(value: string);
    get localSubnetNameInput(): string | undefined;
}
export declare class EdgegatewayVpnLocalSubnetsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: EdgegatewayVpnLocalSubnets[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): EdgegatewayVpnLocalSubnetsOutputReference;
}
export interface EdgegatewayVpnPeerSubnets {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/edgegateway_vpn#peer_subnet_gateway EdgegatewayVpn#peer_subnet_gateway}
    */
    readonly peerSubnetGateway: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/edgegateway_vpn#peer_subnet_mask EdgegatewayVpn#peer_subnet_mask}
    */
    readonly peerSubnetMask: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/edgegateway_vpn#peer_subnet_name EdgegatewayVpn#peer_subnet_name}
    */
    readonly peerSubnetName: string;
}
export declare function edgegatewayVpnPeerSubnetsToTerraform(struct?: EdgegatewayVpnPeerSubnets | cdktf.IResolvable): any;
export declare function edgegatewayVpnPeerSubnetsToHclTerraform(struct?: EdgegatewayVpnPeerSubnets | cdktf.IResolvable): any;
export declare class EdgegatewayVpnPeerSubnetsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): EdgegatewayVpnPeerSubnets | cdktf.IResolvable | undefined;
    set internalValue(value: EdgegatewayVpnPeerSubnets | cdktf.IResolvable | undefined);
    private _peerSubnetGateway?;
    get peerSubnetGateway(): string;
    set peerSubnetGateway(value: string);
    get peerSubnetGatewayInput(): string | undefined;
    private _peerSubnetMask?;
    get peerSubnetMask(): string;
    set peerSubnetMask(value: string);
    get peerSubnetMaskInput(): string | undefined;
    private _peerSubnetName?;
    get peerSubnetName(): string;
    set peerSubnetName(value: string);
    get peerSubnetNameInput(): string | undefined;
}
export declare class EdgegatewayVpnPeerSubnetsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: EdgegatewayVpnPeerSubnets[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): EdgegatewayVpnPeerSubnetsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/edgegateway_vpn vcd_edgegateway_vpn}
*/
export declare class EdgegatewayVpn extends cdktf.TerraformResource {
    static readonly tfResourceType = "vcd_edgegateway_vpn";
    /**
    * Generates CDKTF code for importing a EdgegatewayVpn resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the EdgegatewayVpn to import
    * @param importFromId The id of the existing EdgegatewayVpn that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/edgegateway_vpn#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the EdgegatewayVpn to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/edgegateway_vpn vcd_edgegateway_vpn} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options EdgegatewayVpnConfig
    */
    constructor(scope: Construct, id: string, config: EdgegatewayVpnConfig);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _edgeGateway?;
    get edgeGateway(): string;
    set edgeGateway(value: string);
    get edgeGatewayInput(): string | undefined;
    private _encryptionProtocol?;
    get encryptionProtocol(): string;
    set encryptionProtocol(value: string);
    get encryptionProtocolInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _localId?;
    get localId(): string;
    set localId(value: string);
    get localIdInput(): string | undefined;
    private _localIpAddress?;
    get localIpAddress(): string;
    set localIpAddress(value: string);
    get localIpAddressInput(): string | undefined;
    private _mtu?;
    get mtu(): number;
    set mtu(value: number);
    get mtuInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    private _peerId?;
    get peerId(): string;
    set peerId(value: string);
    get peerIdInput(): string | undefined;
    private _peerIpAddress?;
    get peerIpAddress(): string;
    set peerIpAddress(value: string);
    get peerIpAddressInput(): string | undefined;
    private _sharedSecret?;
    get sharedSecret(): string;
    set sharedSecret(value: string);
    get sharedSecretInput(): string | undefined;
    private _vdc?;
    get vdc(): string;
    set vdc(value: string);
    resetVdc(): void;
    get vdcInput(): string | undefined;
    private _localSubnets;
    get localSubnets(): EdgegatewayVpnLocalSubnetsList;
    putLocalSubnets(value: EdgegatewayVpnLocalSubnets[] | cdktf.IResolvable): void;
    resetLocalSubnets(): void;
    get localSubnetsInput(): cdktf.IResolvable | EdgegatewayVpnLocalSubnets[] | undefined;
    private _peerSubnets;
    get peerSubnets(): EdgegatewayVpnPeerSubnetsList;
    putPeerSubnets(value: EdgegatewayVpnPeerSubnets[] | cdktf.IResolvable): void;
    resetPeerSubnets(): void;
    get peerSubnetsInput(): cdktf.IResolvable | EdgegatewayVpnPeerSubnets[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
