import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ExternalNetworkConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/external_network#description ExternalNetwork#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/external_network#id ExternalNetwork#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/external_network#name ExternalNetwork#name}
    */
    readonly name: string;
    /**
    * Specifies whether the network resources such as IP/MAC of router will be retained across deployments. Default is false.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/external_network#retain_net_info_across_deployments ExternalNetwork#retain_net_info_across_deployments}
    */
    readonly retainNetInfoAcrossDeployments?: boolean | cdktf.IResolvable;
    /**
    * ip_scope block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/external_network#ip_scope ExternalNetwork#ip_scope}
    */
    readonly ipScope: ExternalNetworkIpScope[] | cdktf.IResolvable;
    /**
    * vsphere_network block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/external_network#vsphere_network ExternalNetwork#vsphere_network}
    */
    readonly vsphereNetwork: ExternalNetworkVsphereNetwork[] | cdktf.IResolvable;
}
export interface ExternalNetworkIpScopeStaticIpPool {
    /**
    * End address of the IP range
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/external_network#end_address ExternalNetwork#end_address}
    */
    readonly endAddress: string;
    /**
    * Start address of the IP range
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/external_network#start_address ExternalNetwork#start_address}
    */
    readonly startAddress: string;
}
export declare function externalNetworkIpScopeStaticIpPoolToTerraform(struct?: ExternalNetworkIpScopeStaticIpPool | cdktf.IResolvable): any;
export declare function externalNetworkIpScopeStaticIpPoolToHclTerraform(struct?: ExternalNetworkIpScopeStaticIpPool | cdktf.IResolvable): any;
export declare class ExternalNetworkIpScopeStaticIpPoolOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ExternalNetworkIpScopeStaticIpPool | cdktf.IResolvable | undefined;
    set internalValue(value: ExternalNetworkIpScopeStaticIpPool | cdktf.IResolvable | undefined);
    private _endAddress?;
    get endAddress(): string;
    set endAddress(value: string);
    get endAddressInput(): string | undefined;
    private _startAddress?;
    get startAddress(): string;
    set startAddress(value: string);
    get startAddressInput(): string | undefined;
}
export declare class ExternalNetworkIpScopeStaticIpPoolList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ExternalNetworkIpScopeStaticIpPool[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ExternalNetworkIpScopeStaticIpPoolOutputReference;
}
export interface ExternalNetworkIpScope {
    /**
    * Primary DNS server
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/external_network#dns1 ExternalNetwork#dns1}
    */
    readonly dns1?: string;
    /**
    * Secondary DNS server
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/external_network#dns2 ExternalNetwork#dns2}
    */
    readonly dns2?: string;
    /**
    * DNS suffix
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/external_network#dns_suffix ExternalNetwork#dns_suffix}
    */
    readonly dnsSuffix?: string;
    /**
    * Gateway of the network
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/external_network#gateway ExternalNetwork#gateway}
    */
    readonly gateway: string;
    /**
    * Network mask
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/external_network#netmask ExternalNetwork#netmask}
    */
    readonly netmask: string;
    /**
    * static_ip_pool block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/external_network#static_ip_pool ExternalNetwork#static_ip_pool}
    */
    readonly staticIpPool?: ExternalNetworkIpScopeStaticIpPool[] | cdktf.IResolvable;
}
export declare function externalNetworkIpScopeToTerraform(struct?: ExternalNetworkIpScope | cdktf.IResolvable): any;
export declare function externalNetworkIpScopeToHclTerraform(struct?: ExternalNetworkIpScope | cdktf.IResolvable): any;
export declare class ExternalNetworkIpScopeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ExternalNetworkIpScope | cdktf.IResolvable | undefined;
    set internalValue(value: ExternalNetworkIpScope | cdktf.IResolvable | undefined);
    private _dns1?;
    get dns1(): string;
    set dns1(value: string);
    resetDns1(): void;
    get dns1Input(): string | undefined;
    private _dns2?;
    get dns2(): string;
    set dns2(value: string);
    resetDns2(): void;
    get dns2Input(): string | undefined;
    private _dnsSuffix?;
    get dnsSuffix(): string;
    set dnsSuffix(value: string);
    resetDnsSuffix(): void;
    get dnsSuffixInput(): string | undefined;
    private _gateway?;
    get gateway(): string;
    set gateway(value: string);
    get gatewayInput(): string | undefined;
    private _netmask?;
    get netmask(): string;
    set netmask(value: string);
    get netmaskInput(): string | undefined;
    private _staticIpPool;
    get staticIpPool(): ExternalNetworkIpScopeStaticIpPoolList;
    putStaticIpPool(value: ExternalNetworkIpScopeStaticIpPool[] | cdktf.IResolvable): void;
    resetStaticIpPool(): void;
    get staticIpPoolInput(): cdktf.IResolvable | ExternalNetworkIpScopeStaticIpPool[] | undefined;
}
export declare class ExternalNetworkIpScopeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ExternalNetworkIpScope[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ExternalNetworkIpScopeOutputReference;
}
export interface ExternalNetworkVsphereNetwork {
    /**
    * The name of the port group
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/external_network#name ExternalNetwork#name}
    */
    readonly name: string;
    /**
    * The vSphere port group type. One of: DV_PORTGROUP (distributed virtual port group), NETWORK
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/external_network#type ExternalNetwork#type}
    */
    readonly type: string;
    /**
    * The vCenter server name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/external_network#vcenter ExternalNetwork#vcenter}
    */
    readonly vcenter: string;
}
export declare function externalNetworkVsphereNetworkToTerraform(struct?: ExternalNetworkVsphereNetwork | cdktf.IResolvable): any;
export declare function externalNetworkVsphereNetworkToHclTerraform(struct?: ExternalNetworkVsphereNetwork | cdktf.IResolvable): any;
export declare class ExternalNetworkVsphereNetworkOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ExternalNetworkVsphereNetwork | cdktf.IResolvable | undefined;
    set internalValue(value: ExternalNetworkVsphereNetwork | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
    private _vcenter?;
    get vcenter(): string;
    set vcenter(value: string);
    get vcenterInput(): string | undefined;
}
export declare class ExternalNetworkVsphereNetworkList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ExternalNetworkVsphereNetwork[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ExternalNetworkVsphereNetworkOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/external_network vcd_external_network}
*/
export declare class ExternalNetwork extends cdktf.TerraformResource {
    static readonly tfResourceType = "vcd_external_network";
    /**
    * Generates CDKTF code for importing a ExternalNetwork resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the ExternalNetwork to import
    * @param importFromId The id of the existing ExternalNetwork that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/external_network#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the ExternalNetwork to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/external_network vcd_external_network} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ExternalNetworkConfig
    */
    constructor(scope: Construct, id: string, config: ExternalNetworkConfig);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _retainNetInfoAcrossDeployments?;
    get retainNetInfoAcrossDeployments(): boolean | cdktf.IResolvable;
    set retainNetInfoAcrossDeployments(value: boolean | cdktf.IResolvable);
    resetRetainNetInfoAcrossDeployments(): void;
    get retainNetInfoAcrossDeploymentsInput(): boolean | cdktf.IResolvable | undefined;
    private _ipScope;
    get ipScope(): ExternalNetworkIpScopeList;
    putIpScope(value: ExternalNetworkIpScope[] | cdktf.IResolvable): void;
    get ipScopeInput(): cdktf.IResolvable | ExternalNetworkIpScope[] | undefined;
    private _vsphereNetwork;
    get vsphereNetwork(): ExternalNetworkVsphereNetworkList;
    putVsphereNetwork(value: ExternalNetworkVsphereNetwork[] | cdktf.IResolvable): void;
    get vsphereNetworkInput(): cdktf.IResolvable | ExternalNetworkVsphereNetwork[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
