import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface IndependentDiskConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/independent_disk#bus_sub_type IndependentDisk#bus_sub_type}
    */
    readonly busSubType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/independent_disk#bus_type IndependentDisk#bus_type}
    */
    readonly busType?: string;
    /**
    * independent disk description
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/independent_disk#description IndependentDisk#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/independent_disk#id IndependentDisk#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Key value map of metadata to assign to this disk. Key and value can be any string.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/independent_disk#metadata IndependentDisk#metadata}
    */
    readonly metadata?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/independent_disk#name IndependentDisk#name}
    */
    readonly name: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/independent_disk#org IndependentDisk#org}
    */
    readonly org?: string;
    /**
    * This is the sharing type. This attribute can only have values defined one of: `DiskSharing`,`ControllerSharing`, `None`
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/independent_disk#sharing_type IndependentDisk#sharing_type}
    */
    readonly sharingType?: string;
    /**
    * size in MB
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/independent_disk#size_in_mb IndependentDisk#size_in_mb}
    */
    readonly sizeInMb: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/independent_disk#storage_profile IndependentDisk#storage_profile}
    */
    readonly storageProfile?: string;
    /**
    * The name of VDC to use, optional if defined at provider level
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/independent_disk#vdc IndependentDisk#vdc}
    */
    readonly vdc?: string;
    /**
    * metadata_entry block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/independent_disk#metadata_entry IndependentDisk#metadata_entry}
    */
    readonly metadataEntry?: IndependentDiskMetadataEntry[] | cdktf.IResolvable;
}
export interface IndependentDiskMetadataEntry {
    /**
    * Domain for this metadata entry. true, if it belongs to SYSTEM. false, if it belongs to GENERAL
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/independent_disk#is_system IndependentDisk#is_system}
    */
    readonly isSystem?: boolean | cdktf.IResolvable;
    /**
    * Key of this metadata entry. Required if the metadata entry is not empty
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/independent_disk#key IndependentDisk#key}
    */
    readonly key?: string;
    /**
    * Type of this metadata entry. One of: 'MetadataStringValue', 'MetadataNumberValue', 'MetadataBooleanValue', 'MetadataDateTimeValue'
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/independent_disk#type IndependentDisk#type}
    */
    readonly type?: string;
    /**
    * User access level for this metadata entry. One of: 'READWRITE', 'READONLY', 'PRIVATE'
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/independent_disk#user_access IndependentDisk#user_access}
    */
    readonly userAccess?: string;
    /**
    * Value of this metadata entry. Required if the metadata entry is not empty
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/independent_disk#value IndependentDisk#value}
    */
    readonly value?: string;
}
export declare function independentDiskMetadataEntryToTerraform(struct?: IndependentDiskMetadataEntry | cdktf.IResolvable): any;
export declare function independentDiskMetadataEntryToHclTerraform(struct?: IndependentDiskMetadataEntry | cdktf.IResolvable): any;
export declare class IndependentDiskMetadataEntryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): IndependentDiskMetadataEntry | cdktf.IResolvable | undefined;
    set internalValue(value: IndependentDiskMetadataEntry | cdktf.IResolvable | undefined);
    private _isSystem?;
    get isSystem(): boolean | cdktf.IResolvable;
    set isSystem(value: boolean | cdktf.IResolvable);
    resetIsSystem(): void;
    get isSystemInput(): boolean | cdktf.IResolvable | undefined;
    private _key?;
    get key(): string;
    set key(value: string);
    resetKey(): void;
    get keyInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _userAccess?;
    get userAccess(): string;
    set userAccess(value: string);
    resetUserAccess(): void;
    get userAccessInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
}
export declare class IndependentDiskMetadataEntryList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: IndependentDiskMetadataEntry[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): IndependentDiskMetadataEntryOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/independent_disk vcd_independent_disk}
*/
export declare class IndependentDisk extends cdktf.TerraformResource {
    static readonly tfResourceType = "vcd_independent_disk";
    /**
    * Generates CDKTF code for importing a IndependentDisk resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the IndependentDisk to import
    * @param importFromId The id of the existing IndependentDisk that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/independent_disk#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the IndependentDisk to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/independent_disk vcd_independent_disk} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options IndependentDiskConfig
    */
    constructor(scope: Construct, id: string, config: IndependentDiskConfig);
    get attachedVmIds(): string[];
    private _busSubType?;
    get busSubType(): string;
    set busSubType(value: string);
    resetBusSubType(): void;
    get busSubTypeInput(): string | undefined;
    private _busType?;
    get busType(): string;
    set busType(value: string);
    resetBusType(): void;
    get busTypeInput(): string | undefined;
    get datastoreName(): string;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    get encrypted(): cdktf.IResolvable;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get iops(): number;
    get isAttached(): cdktf.IResolvable;
    private _metadata?;
    get metadata(): {
        [key: string]: string;
    };
    set metadata(value: {
        [key: string]: string;
    });
    resetMetadata(): void;
    get metadataInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    get ownerName(): string;
    private _sharingType?;
    get sharingType(): string;
    set sharingType(value: string);
    resetSharingType(): void;
    get sharingTypeInput(): string | undefined;
    private _sizeInMb?;
    get sizeInMb(): number;
    set sizeInMb(value: number);
    get sizeInMbInput(): number | undefined;
    private _storageProfile?;
    get storageProfile(): string;
    set storageProfile(value: string);
    resetStorageProfile(): void;
    get storageProfileInput(): string | undefined;
    get uuid(): string;
    private _vdc?;
    get vdc(): string;
    set vdc(value: string);
    resetVdc(): void;
    get vdcInput(): string | undefined;
    private _metadataEntry;
    get metadataEntry(): IndependentDiskMetadataEntryList;
    putMetadataEntry(value: IndependentDiskMetadataEntry[] | cdktf.IResolvable): void;
    resetMetadataEntry(): void;
    get metadataEntryInput(): cdktf.IResolvable | IndependentDiskMetadataEntry[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
