import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface NetworkRoutedV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Network description
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2#description NetworkRoutedV2#description}
    */
    readonly description?: string;
    /**
    * DNS server 1
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2#dns1 NetworkRoutedV2#dns1}
    */
    readonly dns1?: string;
    /**
    * DNS server 1
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2#dns2 NetworkRoutedV2#dns2}
    */
    readonly dns2?: string;
    /**
    * DNS suffix
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2#dns_suffix NetworkRoutedV2#dns_suffix}
    */
    readonly dnsSuffix?: string;
    /**
    * Boolean value if Dual-Stack mode should be enabled (default `false`)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2#dual_stack_enabled NetworkRoutedV2#dual_stack_enabled}
    */
    readonly dualStackEnabled?: boolean | cdktf.IResolvable;
    /**
    * Edge gateway ID in which Routed network should be located
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2#edge_gateway_id NetworkRoutedV2#edge_gateway_id}
    */
    readonly edgeGatewayId: string;
    /**
    * Gateway IP address
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2#gateway NetworkRoutedV2#gateway}
    */
    readonly gateway: string;
    /**
    * True if network allows guest VLAN tagging
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2#guest_vlan_allowed NetworkRoutedV2#guest_vlan_allowed}
    */
    readonly guestVlanAllowed?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2#id NetworkRoutedV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Optional interface type (only for NSX-V networks). One of 'INTERNAL' (default), 'DISTRIBUTED', 'SUBINTERFACE'
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2#interface_type NetworkRoutedV2#interface_type}
    */
    readonly interfaceType?: string;
    /**
    * Key value map of metadata to assign to this network. Key and value can be any string
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2#metadata NetworkRoutedV2#metadata}
    */
    readonly metadata?: {
        [key: string]: string;
    };
    /**
    * Network name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2#name NetworkRoutedV2#name}
    */
    readonly name: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2#org NetworkRoutedV2#org}
    */
    readonly org?: string;
    /**
    * Network prefix
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2#prefix_length NetworkRoutedV2#prefix_length}
    */
    readonly prefixLength: number;
    /**
    * Whether this network is advertised so that it can be routed out to the external networks.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2#route_advertisement_enabled NetworkRoutedV2#route_advertisement_enabled}
    */
    readonly routeAdvertisementEnabled?: boolean | cdktf.IResolvable;
    /**
    * Secondary gateway (can only be IPv6 and requires enabled Dual Stack mode)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2#secondary_gateway NetworkRoutedV2#secondary_gateway}
    */
    readonly secondaryGateway?: string;
    /**
    * Secondary prefix (can only be IPv6 and requires enabled Dual Stack mode)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2#secondary_prefix_length NetworkRoutedV2#secondary_prefix_length}
    */
    readonly secondaryPrefixLength?: string;
    /**
    * The name of VDC to use, optional if defined at provider level
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2#vdc NetworkRoutedV2#vdc}
    */
    readonly vdc?: string;
    /**
    * metadata_entry block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2#metadata_entry NetworkRoutedV2#metadata_entry}
    */
    readonly metadataEntry?: NetworkRoutedV2MetadataEntry[] | cdktf.IResolvable;
    /**
    * secondary_static_ip_pool block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2#secondary_static_ip_pool NetworkRoutedV2#secondary_static_ip_pool}
    */
    readonly secondaryStaticIpPool?: NetworkRoutedV2SecondaryStaticIpPool[] | cdktf.IResolvable;
    /**
    * static_ip_pool block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2#static_ip_pool NetworkRoutedV2#static_ip_pool}
    */
    readonly staticIpPool?: NetworkRoutedV2StaticIpPool[] | cdktf.IResolvable;
}
export interface NetworkRoutedV2MetadataEntry {
    /**
    * Domain for this metadata entry. true, if it belongs to SYSTEM. false, if it belongs to GENERAL
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2#is_system NetworkRoutedV2#is_system}
    */
    readonly isSystem?: boolean | cdktf.IResolvable;
    /**
    * Key of this metadata entry. Required if the metadata entry is not empty
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2#key NetworkRoutedV2#key}
    */
    readonly key?: string;
    /**
    * Type of this metadata entry. One of: 'MetadataStringValue', 'MetadataNumberValue', 'MetadataBooleanValue', 'MetadataDateTimeValue'
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2#type NetworkRoutedV2#type}
    */
    readonly type?: string;
    /**
    * User access level for this metadata entry. One of: 'READWRITE', 'READONLY', 'PRIVATE'
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2#user_access NetworkRoutedV2#user_access}
    */
    readonly userAccess?: string;
    /**
    * Value of this metadata entry. Required if the metadata entry is not empty
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2#value NetworkRoutedV2#value}
    */
    readonly value?: string;
}
export declare function networkRoutedV2MetadataEntryToTerraform(struct?: NetworkRoutedV2MetadataEntry | cdktf.IResolvable): any;
export declare function networkRoutedV2MetadataEntryToHclTerraform(struct?: NetworkRoutedV2MetadataEntry | cdktf.IResolvable): any;
export declare class NetworkRoutedV2MetadataEntryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): NetworkRoutedV2MetadataEntry | cdktf.IResolvable | undefined;
    set internalValue(value: NetworkRoutedV2MetadataEntry | cdktf.IResolvable | undefined);
    private _isSystem?;
    get isSystem(): boolean | cdktf.IResolvable;
    set isSystem(value: boolean | cdktf.IResolvable);
    resetIsSystem(): void;
    get isSystemInput(): boolean | cdktf.IResolvable | undefined;
    private _key?;
    get key(): string;
    set key(value: string);
    resetKey(): void;
    get keyInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _userAccess?;
    get userAccess(): string;
    set userAccess(value: string);
    resetUserAccess(): void;
    get userAccessInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
}
export declare class NetworkRoutedV2MetadataEntryList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: NetworkRoutedV2MetadataEntry[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): NetworkRoutedV2MetadataEntryOutputReference;
}
export interface NetworkRoutedV2SecondaryStaticIpPool {
    /**
    * End address of the IP range
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2#end_address NetworkRoutedV2#end_address}
    */
    readonly endAddress: string;
    /**
    * Start address of the IP range
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2#start_address NetworkRoutedV2#start_address}
    */
    readonly startAddress: string;
}
export declare function networkRoutedV2SecondaryStaticIpPoolToTerraform(struct?: NetworkRoutedV2SecondaryStaticIpPool | cdktf.IResolvable): any;
export declare function networkRoutedV2SecondaryStaticIpPoolToHclTerraform(struct?: NetworkRoutedV2SecondaryStaticIpPool | cdktf.IResolvable): any;
export declare class NetworkRoutedV2SecondaryStaticIpPoolOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): NetworkRoutedV2SecondaryStaticIpPool | cdktf.IResolvable | undefined;
    set internalValue(value: NetworkRoutedV2SecondaryStaticIpPool | cdktf.IResolvable | undefined);
    private _endAddress?;
    get endAddress(): string;
    set endAddress(value: string);
    get endAddressInput(): string | undefined;
    private _startAddress?;
    get startAddress(): string;
    set startAddress(value: string);
    get startAddressInput(): string | undefined;
}
export declare class NetworkRoutedV2SecondaryStaticIpPoolList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: NetworkRoutedV2SecondaryStaticIpPool[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): NetworkRoutedV2SecondaryStaticIpPoolOutputReference;
}
export interface NetworkRoutedV2StaticIpPool {
    /**
    * End address of the IP range
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2#end_address NetworkRoutedV2#end_address}
    */
    readonly endAddress: string;
    /**
    * Start address of the IP range
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2#start_address NetworkRoutedV2#start_address}
    */
    readonly startAddress: string;
}
export declare function networkRoutedV2StaticIpPoolToTerraform(struct?: NetworkRoutedV2StaticIpPool | cdktf.IResolvable): any;
export declare function networkRoutedV2StaticIpPoolToHclTerraform(struct?: NetworkRoutedV2StaticIpPool | cdktf.IResolvable): any;
export declare class NetworkRoutedV2StaticIpPoolOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): NetworkRoutedV2StaticIpPool | cdktf.IResolvable | undefined;
    set internalValue(value: NetworkRoutedV2StaticIpPool | cdktf.IResolvable | undefined);
    private _endAddress?;
    get endAddress(): string;
    set endAddress(value: string);
    get endAddressInput(): string | undefined;
    private _startAddress?;
    get startAddress(): string;
    set startAddress(value: string);
    get startAddressInput(): string | undefined;
}
export declare class NetworkRoutedV2StaticIpPoolList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: NetworkRoutedV2StaticIpPool[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): NetworkRoutedV2StaticIpPoolOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2 vcd_network_routed_v2}
*/
export declare class NetworkRoutedV2 extends cdktf.TerraformResource {
    static readonly tfResourceType = "vcd_network_routed_v2";
    /**
    * Generates CDKTF code for importing a NetworkRoutedV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the NetworkRoutedV2 to import
    * @param importFromId The id of the existing NetworkRoutedV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the NetworkRoutedV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/network_routed_v2 vcd_network_routed_v2} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options NetworkRoutedV2Config
    */
    constructor(scope: Construct, id: string, config: NetworkRoutedV2Config);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _dns1?;
    get dns1(): string;
    set dns1(value: string);
    resetDns1(): void;
    get dns1Input(): string | undefined;
    private _dns2?;
    get dns2(): string;
    set dns2(value: string);
    resetDns2(): void;
    get dns2Input(): string | undefined;
    private _dnsSuffix?;
    get dnsSuffix(): string;
    set dnsSuffix(value: string);
    resetDnsSuffix(): void;
    get dnsSuffixInput(): string | undefined;
    private _dualStackEnabled?;
    get dualStackEnabled(): boolean | cdktf.IResolvable;
    set dualStackEnabled(value: boolean | cdktf.IResolvable);
    resetDualStackEnabled(): void;
    get dualStackEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _edgeGatewayId?;
    get edgeGatewayId(): string;
    set edgeGatewayId(value: string);
    get edgeGatewayIdInput(): string | undefined;
    private _gateway?;
    get gateway(): string;
    set gateway(value: string);
    get gatewayInput(): string | undefined;
    private _guestVlanAllowed?;
    get guestVlanAllowed(): boolean | cdktf.IResolvable;
    set guestVlanAllowed(value: boolean | cdktf.IResolvable);
    resetGuestVlanAllowed(): void;
    get guestVlanAllowedInput(): boolean | cdktf.IResolvable | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _interfaceType?;
    get interfaceType(): string;
    set interfaceType(value: string);
    resetInterfaceType(): void;
    get interfaceTypeInput(): string | undefined;
    private _metadata?;
    get metadata(): {
        [key: string]: string;
    };
    set metadata(value: {
        [key: string]: string;
    });
    resetMetadata(): void;
    get metadataInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    get ownerId(): string;
    private _prefixLength?;
    get prefixLength(): number;
    set prefixLength(value: number);
    get prefixLengthInput(): number | undefined;
    private _routeAdvertisementEnabled?;
    get routeAdvertisementEnabled(): boolean | cdktf.IResolvable;
    set routeAdvertisementEnabled(value: boolean | cdktf.IResolvable);
    resetRouteAdvertisementEnabled(): void;
    get routeAdvertisementEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _secondaryGateway?;
    get secondaryGateway(): string;
    set secondaryGateway(value: string);
    resetSecondaryGateway(): void;
    get secondaryGatewayInput(): string | undefined;
    private _secondaryPrefixLength?;
    get secondaryPrefixLength(): string;
    set secondaryPrefixLength(value: string);
    resetSecondaryPrefixLength(): void;
    get secondaryPrefixLengthInput(): string | undefined;
    private _vdc?;
    get vdc(): string;
    set vdc(value: string);
    resetVdc(): void;
    get vdcInput(): string | undefined;
    private _metadataEntry;
    get metadataEntry(): NetworkRoutedV2MetadataEntryList;
    putMetadataEntry(value: NetworkRoutedV2MetadataEntry[] | cdktf.IResolvable): void;
    resetMetadataEntry(): void;
    get metadataEntryInput(): cdktf.IResolvable | NetworkRoutedV2MetadataEntry[] | undefined;
    private _secondaryStaticIpPool;
    get secondaryStaticIpPool(): NetworkRoutedV2SecondaryStaticIpPoolList;
    putSecondaryStaticIpPool(value: NetworkRoutedV2SecondaryStaticIpPool[] | cdktf.IResolvable): void;
    resetSecondaryStaticIpPool(): void;
    get secondaryStaticIpPoolInput(): cdktf.IResolvable | NetworkRoutedV2SecondaryStaticIpPool[] | undefined;
    private _staticIpPool;
    get staticIpPool(): NetworkRoutedV2StaticIpPoolList;
    putStaticIpPool(value: NetworkRoutedV2StaticIpPool[] | cdktf.IResolvable): void;
    resetStaticIpPool(): void;
    get staticIpPoolInput(): cdktf.IResolvable | NetworkRoutedV2StaticIpPool[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
