import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface NsxtAlbCloudConfig extends cdktf.TerraformMetaArguments {
    /**
    * NSX-T ALB Controller ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_cloud#controller_id NsxtAlbCloud#controller_id}
    */
    readonly controllerId: string;
    /**
    * NSX-T ALB Cloud description
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_cloud#description NsxtAlbCloud#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_cloud#id NsxtAlbCloud#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * NSX-T ALB Importable Cloud ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_cloud#importable_cloud_id NsxtAlbCloud#importable_cloud_id}
    */
    readonly importableCloudId: string;
    /**
    * NSX-T ALB Cloud name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_cloud#name NsxtAlbCloud#name}
    */
    readonly name: string;
    /**
    * Network pool ID for NSX-T ALB Importable Cloud
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_cloud#network_pool_id NsxtAlbCloud#network_pool_id}
    */
    readonly networkPoolId: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_cloud vcd_nsxt_alb_cloud}
*/
export declare class NsxtAlbCloud extends cdktf.TerraformResource {
    static readonly tfResourceType = "vcd_nsxt_alb_cloud";
    /**
    * Generates CDKTF code for importing a NsxtAlbCloud resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the NsxtAlbCloud to import
    * @param importFromId The id of the existing NsxtAlbCloud that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_cloud#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the NsxtAlbCloud to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_cloud vcd_nsxt_alb_cloud} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options NsxtAlbCloudConfig
    */
    constructor(scope: Construct, id: string, config: NsxtAlbCloudConfig);
    private _controllerId?;
    get controllerId(): string;
    set controllerId(value: string);
    get controllerIdInput(): string | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    get healthMessage(): string;
    get healthStatus(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _importableCloudId?;
    get importableCloudId(): string;
    set importableCloudId(value: string);
    get importableCloudIdInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _networkPoolId?;
    get networkPoolId(): string;
    set networkPoolId(value: string);
    get networkPoolIdInput(): string | undefined;
    get networkPoolName(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
