import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface NsxtAlbEdgegatewayServiceEngineGroupConfig extends cdktf.TerraformMetaArguments {
    /**
    * Edge Gateway ID in which ALB Service Engine Group should be located
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_edgegateway_service_engine_group#edge_gateway_id NsxtAlbEdgegatewayServiceEngineGroup#edge_gateway_id}
    */
    readonly edgeGatewayId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_edgegateway_service_engine_group#id NsxtAlbEdgegatewayServiceEngineGroup#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Maximum number of virtual services to be used in this Service Engine Group
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_edgegateway_service_engine_group#max_virtual_services NsxtAlbEdgegatewayServiceEngineGroup#max_virtual_services}
    */
    readonly maxVirtualServices?: number;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_edgegateway_service_engine_group#org NsxtAlbEdgegatewayServiceEngineGroup#org}
    */
    readonly org?: string;
    /**
    * Number of reserved virtual services for this Service Engine Group
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_edgegateway_service_engine_group#reserved_virtual_services NsxtAlbEdgegatewayServiceEngineGroup#reserved_virtual_services}
    */
    readonly reservedVirtualServices?: string;
    /**
    * Service Engine Group ID to attach to this NSX-T Edge Gateway
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_edgegateway_service_engine_group#service_engine_group_id NsxtAlbEdgegatewayServiceEngineGroup#service_engine_group_id}
    */
    readonly serviceEngineGroupId: string;
    /**
    * The name of VDC to use, optional if defined at provider level
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_edgegateway_service_engine_group#vdc NsxtAlbEdgegatewayServiceEngineGroup#vdc}
    */
    readonly vdc?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_edgegateway_service_engine_group vcd_nsxt_alb_edgegateway_service_engine_group}
*/
export declare class NsxtAlbEdgegatewayServiceEngineGroup extends cdktf.TerraformResource {
    static readonly tfResourceType = "vcd_nsxt_alb_edgegateway_service_engine_group";
    /**
    * Generates CDKTF code for importing a NsxtAlbEdgegatewayServiceEngineGroup resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the NsxtAlbEdgegatewayServiceEngineGroup to import
    * @param importFromId The id of the existing NsxtAlbEdgegatewayServiceEngineGroup that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_edgegateway_service_engine_group#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the NsxtAlbEdgegatewayServiceEngineGroup to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_edgegateway_service_engine_group vcd_nsxt_alb_edgegateway_service_engine_group} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options NsxtAlbEdgegatewayServiceEngineGroupConfig
    */
    constructor(scope: Construct, id: string, config: NsxtAlbEdgegatewayServiceEngineGroupConfig);
    get deployedVirtualServices(): number;
    private _edgeGatewayId?;
    get edgeGatewayId(): string;
    set edgeGatewayId(value: string);
    get edgeGatewayIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _maxVirtualServices?;
    get maxVirtualServices(): number;
    set maxVirtualServices(value: number);
    resetMaxVirtualServices(): void;
    get maxVirtualServicesInput(): number | undefined;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    private _reservedVirtualServices?;
    get reservedVirtualServices(): string;
    set reservedVirtualServices(value: string);
    resetReservedVirtualServices(): void;
    get reservedVirtualServicesInput(): string | undefined;
    private _serviceEngineGroupId?;
    get serviceEngineGroupId(): string;
    set serviceEngineGroupId(value: string);
    get serviceEngineGroupIdInput(): string | undefined;
    get serviceEngineGroupName(): string;
    private _vdc?;
    get vdc(): string;
    set vdc(value: string);
    resetVdc(): void;
    get vdcInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
