import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface NsxtAlbVirtualServiceConfig extends cdktf.TerraformMetaArguments {
    /**
    * HTTP, HTTPS, L4, L4_TLS
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_virtual_service#application_profile_type NsxtAlbVirtualService#application_profile_type}
    */
    readonly applicationProfileType: string;
    /**
    * Optional certificate ID to use for exposing service
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_virtual_service#ca_certificate_id NsxtAlbVirtualService#ca_certificate_id}
    */
    readonly caCertificateId?: string;
    /**
    * Description of ALB Virtual Service
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_virtual_service#description NsxtAlbVirtualService#description}
    */
    readonly description?: string;
    /**
    * Edge gateway ID in which ALB Pool should be created
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_virtual_service#edge_gateway_id NsxtAlbVirtualService#edge_gateway_id}
    */
    readonly edgeGatewayId: string;
    /**
    * Virtual Service is enabled or disabled (default true)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_virtual_service#enabled NsxtAlbVirtualService#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_virtual_service#id NsxtAlbVirtualService#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * IPv6 Virtual IP address (VIP) for Virtual Service (VCD 10.4.0+)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_virtual_service#ipv6_virtual_ip_address NsxtAlbVirtualService#ipv6_virtual_ip_address}
    */
    readonly ipv6VirtualIpAddress?: string;
    /**
    * Preserves Client IP on a Virtual Service (VCD 10.4.1+)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_virtual_service#is_transparent_mode_enabled NsxtAlbVirtualService#is_transparent_mode_enabled}
    */
    readonly isTransparentModeEnabled?: boolean | cdktf.IResolvable;
    /**
    * Name of ALB Virtual Service
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_virtual_service#name NsxtAlbVirtualService#name}
    */
    readonly name: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_virtual_service#org NsxtAlbVirtualService#org}
    */
    readonly org?: string;
    /**
    * Pool ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_virtual_service#pool_id NsxtAlbVirtualService#pool_id}
    */
    readonly poolId: string;
    /**
    * Service Engine Group ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_virtual_service#service_engine_group_id NsxtAlbVirtualService#service_engine_group_id}
    */
    readonly serviceEngineGroupId: string;
    /**
    * The name of VDC to use, optional if defined at provider level
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_virtual_service#vdc NsxtAlbVirtualService#vdc}
    */
    readonly vdc?: string;
    /**
    * Virtual IP address (VIP) for Virtual Service
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_virtual_service#virtual_ip_address NsxtAlbVirtualService#virtual_ip_address}
    */
    readonly virtualIpAddress: string;
    /**
    * service_port block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_virtual_service#service_port NsxtAlbVirtualService#service_port}
    */
    readonly servicePort?: NsxtAlbVirtualServiceServicePort[] | cdktf.IResolvable;
}
export interface NsxtAlbVirtualServiceServicePort {
    /**
    * Last port in the range
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_virtual_service#end_port NsxtAlbVirtualService#end_port}
    */
    readonly endPort?: number;
    /**
    * Defines if certificate should be used
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_virtual_service#ssl_enabled NsxtAlbVirtualService#ssl_enabled}
    */
    readonly sslEnabled?: boolean | cdktf.IResolvable;
    /**
    * Starting port in the range
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_virtual_service#start_port NsxtAlbVirtualService#start_port}
    */
    readonly startPort: number;
    /**
    * One of 'TCP_PROXY', 'TCP_FAST_PATH', 'UDP_FAST_PATH'
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_virtual_service#type NsxtAlbVirtualService#type}
    */
    readonly type: string;
}
export declare function nsxtAlbVirtualServiceServicePortToTerraform(struct?: NsxtAlbVirtualServiceServicePort | cdktf.IResolvable): any;
export declare function nsxtAlbVirtualServiceServicePortToHclTerraform(struct?: NsxtAlbVirtualServiceServicePort | cdktf.IResolvable): any;
export declare class NsxtAlbVirtualServiceServicePortOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): NsxtAlbVirtualServiceServicePort | cdktf.IResolvable | undefined;
    set internalValue(value: NsxtAlbVirtualServiceServicePort | cdktf.IResolvable | undefined);
    private _endPort?;
    get endPort(): number;
    set endPort(value: number);
    resetEndPort(): void;
    get endPortInput(): number | undefined;
    private _sslEnabled?;
    get sslEnabled(): boolean | cdktf.IResolvable;
    set sslEnabled(value: boolean | cdktf.IResolvable);
    resetSslEnabled(): void;
    get sslEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _startPort?;
    get startPort(): number;
    set startPort(value: number);
    get startPortInput(): number | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
export declare class NsxtAlbVirtualServiceServicePortList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: NsxtAlbVirtualServiceServicePort[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): NsxtAlbVirtualServiceServicePortOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_virtual_service vcd_nsxt_alb_virtual_service}
*/
export declare class NsxtAlbVirtualService extends cdktf.TerraformResource {
    static readonly tfResourceType = "vcd_nsxt_alb_virtual_service";
    /**
    * Generates CDKTF code for importing a NsxtAlbVirtualService resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the NsxtAlbVirtualService to import
    * @param importFromId The id of the existing NsxtAlbVirtualService that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_virtual_service#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the NsxtAlbVirtualService to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_alb_virtual_service vcd_nsxt_alb_virtual_service} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options NsxtAlbVirtualServiceConfig
    */
    constructor(scope: Construct, id: string, config: NsxtAlbVirtualServiceConfig);
    private _applicationProfileType?;
    get applicationProfileType(): string;
    set applicationProfileType(value: string);
    get applicationProfileTypeInput(): string | undefined;
    private _caCertificateId?;
    get caCertificateId(): string;
    set caCertificateId(value: string);
    resetCaCertificateId(): void;
    get caCertificateIdInput(): string | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _edgeGatewayId?;
    get edgeGatewayId(): string;
    set edgeGatewayId(value: string);
    get edgeGatewayIdInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _ipv6VirtualIpAddress?;
    get ipv6VirtualIpAddress(): string;
    set ipv6VirtualIpAddress(value: string);
    resetIpv6VirtualIpAddress(): void;
    get ipv6VirtualIpAddressInput(): string | undefined;
    private _isTransparentModeEnabled?;
    get isTransparentModeEnabled(): boolean | cdktf.IResolvable;
    set isTransparentModeEnabled(value: boolean | cdktf.IResolvable);
    resetIsTransparentModeEnabled(): void;
    get isTransparentModeEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    private _poolId?;
    get poolId(): string;
    set poolId(value: string);
    get poolIdInput(): string | undefined;
    private _serviceEngineGroupId?;
    get serviceEngineGroupId(): string;
    set serviceEngineGroupId(value: string);
    get serviceEngineGroupIdInput(): string | undefined;
    private _vdc?;
    get vdc(): string;
    set vdc(value: string);
    resetVdc(): void;
    get vdcInput(): string | undefined;
    private _virtualIpAddress?;
    get virtualIpAddress(): string;
    set virtualIpAddress(value: string);
    get virtualIpAddressInput(): string | undefined;
    private _servicePort;
    get servicePort(): NsxtAlbVirtualServiceServicePortList;
    putServicePort(value: NsxtAlbVirtualServiceServicePort[] | cdktf.IResolvable): void;
    resetServicePort(): void;
    get servicePortInput(): cdktf.IResolvable | NsxtAlbVirtualServiceServicePort[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
