import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface NsxtEdgegatewayBgpIpPrefixListConfig extends cdktf.TerraformMetaArguments {
    /**
    * BGP IP Prefix List description
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_edgegateway_bgp_ip_prefix_list#description NsxtEdgegatewayBgpIpPrefixList#description}
    */
    readonly description?: string;
    /**
    * Edge gateway ID for BGP IP Prefix List Configuration
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_edgegateway_bgp_ip_prefix_list#edge_gateway_id NsxtEdgegatewayBgpIpPrefixList#edge_gateway_id}
    */
    readonly edgeGatewayId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_edgegateway_bgp_ip_prefix_list#id NsxtEdgegatewayBgpIpPrefixList#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * BGP IP Prefix List name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_edgegateway_bgp_ip_prefix_list#name NsxtEdgegatewayBgpIpPrefixList#name}
    */
    readonly name: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_edgegateway_bgp_ip_prefix_list#org NsxtEdgegatewayBgpIpPrefixList#org}
    */
    readonly org?: string;
    /**
    * ip_prefix block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_edgegateway_bgp_ip_prefix_list#ip_prefix NsxtEdgegatewayBgpIpPrefixList#ip_prefix}
    */
    readonly ipPrefix: NsxtEdgegatewayBgpIpPrefixListIpPrefix[] | cdktf.IResolvable;
}
export interface NsxtEdgegatewayBgpIpPrefixListIpPrefix {
    /**
    * Action 'PERMIT' or 'DENY'
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_edgegateway_bgp_ip_prefix_list#action NsxtEdgegatewayBgpIpPrefixList#action}
    */
    readonly action: string;
    /**
    * Greater than or equal to subnet mask
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_edgegateway_bgp_ip_prefix_list#greater_than_or_equal_to NsxtEdgegatewayBgpIpPrefixList#greater_than_or_equal_to}
    */
    readonly greaterThanOrEqualTo?: number;
    /**
    * Less than or equal to subnet mask
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_edgegateway_bgp_ip_prefix_list#less_than_or_equal_to NsxtEdgegatewayBgpIpPrefixList#less_than_or_equal_to}
    */
    readonly lessThanOrEqualTo?: number;
    /**
    * Network in CIDR notation (e.g. '192.168.100.0/24', '2001:db8::/48')
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_edgegateway_bgp_ip_prefix_list#network NsxtEdgegatewayBgpIpPrefixList#network}
    */
    readonly network: string;
}
export declare function nsxtEdgegatewayBgpIpPrefixListIpPrefixToTerraform(struct?: NsxtEdgegatewayBgpIpPrefixListIpPrefix | cdktf.IResolvable): any;
export declare function nsxtEdgegatewayBgpIpPrefixListIpPrefixToHclTerraform(struct?: NsxtEdgegatewayBgpIpPrefixListIpPrefix | cdktf.IResolvable): any;
export declare class NsxtEdgegatewayBgpIpPrefixListIpPrefixOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): NsxtEdgegatewayBgpIpPrefixListIpPrefix | cdktf.IResolvable | undefined;
    set internalValue(value: NsxtEdgegatewayBgpIpPrefixListIpPrefix | cdktf.IResolvable | undefined);
    private _action?;
    get action(): string;
    set action(value: string);
    get actionInput(): string | undefined;
    private _greaterThanOrEqualTo?;
    get greaterThanOrEqualTo(): number;
    set greaterThanOrEqualTo(value: number);
    resetGreaterThanOrEqualTo(): void;
    get greaterThanOrEqualToInput(): number | undefined;
    private _lessThanOrEqualTo?;
    get lessThanOrEqualTo(): number;
    set lessThanOrEqualTo(value: number);
    resetLessThanOrEqualTo(): void;
    get lessThanOrEqualToInput(): number | undefined;
    private _network?;
    get network(): string;
    set network(value: string);
    get networkInput(): string | undefined;
}
export declare class NsxtEdgegatewayBgpIpPrefixListIpPrefixList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: NsxtEdgegatewayBgpIpPrefixListIpPrefix[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): NsxtEdgegatewayBgpIpPrefixListIpPrefixOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_edgegateway_bgp_ip_prefix_list vcd_nsxt_edgegateway_bgp_ip_prefix_list}
*/
export declare class NsxtEdgegatewayBgpIpPrefixList extends cdktf.TerraformResource {
    static readonly tfResourceType = "vcd_nsxt_edgegateway_bgp_ip_prefix_list";
    /**
    * Generates CDKTF code for importing a NsxtEdgegatewayBgpIpPrefixList resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the NsxtEdgegatewayBgpIpPrefixList to import
    * @param importFromId The id of the existing NsxtEdgegatewayBgpIpPrefixList that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_edgegateway_bgp_ip_prefix_list#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the NsxtEdgegatewayBgpIpPrefixList to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_edgegateway_bgp_ip_prefix_list vcd_nsxt_edgegateway_bgp_ip_prefix_list} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options NsxtEdgegatewayBgpIpPrefixListConfig
    */
    constructor(scope: Construct, id: string, config: NsxtEdgegatewayBgpIpPrefixListConfig);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _edgeGatewayId?;
    get edgeGatewayId(): string;
    set edgeGatewayId(value: string);
    get edgeGatewayIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    private _ipPrefix;
    get ipPrefix(): NsxtEdgegatewayBgpIpPrefixListIpPrefixList;
    putIpPrefix(value: NsxtEdgegatewayBgpIpPrefixListIpPrefix[] | cdktf.IResolvable): void;
    get ipPrefixInput(): cdktf.IResolvable | NsxtEdgegatewayBgpIpPrefixListIpPrefix[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
