import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface NsxtGlobalDefaultSegmentProfileTemplateConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_global_default_segment_profile_template#id NsxtGlobalDefaultSegmentProfileTemplate#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Global default NSX-T Segment Profile for vApp networks
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_global_default_segment_profile_template#vapp_networks_default_segment_profile_template_id NsxtGlobalDefaultSegmentProfileTemplate#vapp_networks_default_segment_profile_template_id}
    */
    readonly vappNetworksDefaultSegmentProfileTemplateId?: string;
    /**
    * Global default NSX-T Segment Profile for Org VDC networks
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_global_default_segment_profile_template#vdc_networks_default_segment_profile_template_id NsxtGlobalDefaultSegmentProfileTemplate#vdc_networks_default_segment_profile_template_id}
    */
    readonly vdcNetworksDefaultSegmentProfileTemplateId?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_global_default_segment_profile_template vcd_nsxt_global_default_segment_profile_template}
*/
export declare class NsxtGlobalDefaultSegmentProfileTemplate extends cdktf.TerraformResource {
    static readonly tfResourceType = "vcd_nsxt_global_default_segment_profile_template";
    /**
    * Generates CDKTF code for importing a NsxtGlobalDefaultSegmentProfileTemplate resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the NsxtGlobalDefaultSegmentProfileTemplate to import
    * @param importFromId The id of the existing NsxtGlobalDefaultSegmentProfileTemplate that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_global_default_segment_profile_template#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the NsxtGlobalDefaultSegmentProfileTemplate to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_global_default_segment_profile_template vcd_nsxt_global_default_segment_profile_template} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options NsxtGlobalDefaultSegmentProfileTemplateConfig = {}
    */
    constructor(scope: Construct, id: string, config?: NsxtGlobalDefaultSegmentProfileTemplateConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _vappNetworksDefaultSegmentProfileTemplateId?;
    get vappNetworksDefaultSegmentProfileTemplateId(): string;
    set vappNetworksDefaultSegmentProfileTemplateId(value: string);
    resetVappNetworksDefaultSegmentProfileTemplateId(): void;
    get vappNetworksDefaultSegmentProfileTemplateIdInput(): string | undefined;
    private _vdcNetworksDefaultSegmentProfileTemplateId?;
    get vdcNetworksDefaultSegmentProfileTemplateId(): string;
    set vdcNetworksDefaultSegmentProfileTemplateId(value: string);
    resetVdcNetworksDefaultSegmentProfileTemplateId(): void;
    get vdcNetworksDefaultSegmentProfileTemplateIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
