import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface NsxtNetworkImportedConfig extends cdktf.TerraformMetaArguments {
    /**
    * Network description
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_network_imported#description NsxtNetworkImported#description}
    */
    readonly description?: string;
    /**
    * DNS server 1
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_network_imported#dns1 NsxtNetworkImported#dns1}
    */
    readonly dns1?: string;
    /**
    * DNS server 1
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_network_imported#dns2 NsxtNetworkImported#dns2}
    */
    readonly dns2?: string;
    /**
    * DNS suffix
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_network_imported#dns_suffix NsxtNetworkImported#dns_suffix}
    */
    readonly dnsSuffix?: string;
    /**
    * Boolean value if Dual-Stack mode should be enabled (default `false`)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_network_imported#dual_stack_enabled NsxtNetworkImported#dual_stack_enabled}
    */
    readonly dualStackEnabled?: boolean | cdktf.IResolvable;
    /**
    * Name of existing Distributed Virtual Port Group
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_network_imported#dvpg_name NsxtNetworkImported#dvpg_name}
    */
    readonly dvpgName?: string;
    /**
    * Gateway IP address
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_network_imported#gateway NsxtNetworkImported#gateway}
    */
    readonly gateway: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_network_imported#id NsxtNetworkImported#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Network name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_network_imported#name NsxtNetworkImported#name}
    */
    readonly name: string;
    /**
    * Name of existing NSX-T Logical Switch
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_network_imported#nsxt_logical_switch_name NsxtNetworkImported#nsxt_logical_switch_name}
    */
    readonly nsxtLogicalSwitchName?: string;
    /**
    * The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organizations
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_network_imported#org NsxtNetworkImported#org}
    */
    readonly org?: string;
    /**
    * ID of VDC or VDC Group
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_network_imported#owner_id NsxtNetworkImported#owner_id}
    */
    readonly ownerId?: string;
    /**
    * Network prefix
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_network_imported#prefix_length NsxtNetworkImported#prefix_length}
    */
    readonly prefixLength: number;
    /**
    * Secondary gateway (can only be IPv6 and requires enabled Dual Stack mode)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_network_imported#secondary_gateway NsxtNetworkImported#secondary_gateway}
    */
    readonly secondaryGateway?: string;
    /**
    * Secondary prefix (can only be IPv6 and requires enabled Dual Stack mode)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_network_imported#secondary_prefix_length NsxtNetworkImported#secondary_prefix_length}
    */
    readonly secondaryPrefixLength?: string;
    /**
    * The name of VDC to use, optional if defined at provider level
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_network_imported#vdc NsxtNetworkImported#vdc}
    */
    readonly vdc?: string;
    /**
    * secondary_static_ip_pool block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_network_imported#secondary_static_ip_pool NsxtNetworkImported#secondary_static_ip_pool}
    */
    readonly secondaryStaticIpPool?: NsxtNetworkImportedSecondaryStaticIpPool[] | cdktf.IResolvable;
    /**
    * static_ip_pool block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_network_imported#static_ip_pool NsxtNetworkImported#static_ip_pool}
    */
    readonly staticIpPool?: NsxtNetworkImportedStaticIpPool[] | cdktf.IResolvable;
}
export interface NsxtNetworkImportedSecondaryStaticIpPool {
    /**
    * End address of the IP range
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_network_imported#end_address NsxtNetworkImported#end_address}
    */
    readonly endAddress: string;
    /**
    * Start address of the IP range
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_network_imported#start_address NsxtNetworkImported#start_address}
    */
    readonly startAddress: string;
}
export declare function nsxtNetworkImportedSecondaryStaticIpPoolToTerraform(struct?: NsxtNetworkImportedSecondaryStaticIpPool | cdktf.IResolvable): any;
export declare function nsxtNetworkImportedSecondaryStaticIpPoolToHclTerraform(struct?: NsxtNetworkImportedSecondaryStaticIpPool | cdktf.IResolvable): any;
export declare class NsxtNetworkImportedSecondaryStaticIpPoolOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): NsxtNetworkImportedSecondaryStaticIpPool | cdktf.IResolvable | undefined;
    set internalValue(value: NsxtNetworkImportedSecondaryStaticIpPool | cdktf.IResolvable | undefined);
    private _endAddress?;
    get endAddress(): string;
    set endAddress(value: string);
    get endAddressInput(): string | undefined;
    private _startAddress?;
    get startAddress(): string;
    set startAddress(value: string);
    get startAddressInput(): string | undefined;
}
export declare class NsxtNetworkImportedSecondaryStaticIpPoolList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: NsxtNetworkImportedSecondaryStaticIpPool[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): NsxtNetworkImportedSecondaryStaticIpPoolOutputReference;
}
export interface NsxtNetworkImportedStaticIpPool {
    /**
    * End address of the IP range
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_network_imported#end_address NsxtNetworkImported#end_address}
    */
    readonly endAddress: string;
    /**
    * Start address of the IP range
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_network_imported#start_address NsxtNetworkImported#start_address}
    */
    readonly startAddress: string;
}
export declare function nsxtNetworkImportedStaticIpPoolToTerraform(struct?: NsxtNetworkImportedStaticIpPool | cdktf.IResolvable): any;
export declare function nsxtNetworkImportedStaticIpPoolToHclTerraform(struct?: NsxtNetworkImportedStaticIpPool | cdktf.IResolvable): any;
export declare class NsxtNetworkImportedStaticIpPoolOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): NsxtNetworkImportedStaticIpPool | cdktf.IResolvable | undefined;
    set internalValue(value: NsxtNetworkImportedStaticIpPool | cdktf.IResolvable | undefined);
    private _endAddress?;
    get endAddress(): string;
    set endAddress(value: string);
    get endAddressInput(): string | undefined;
    private _startAddress?;
    get startAddress(): string;
    set startAddress(value: string);
    get startAddressInput(): string | undefined;
}
export declare class NsxtNetworkImportedStaticIpPoolList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: NsxtNetworkImportedStaticIpPool[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): NsxtNetworkImportedStaticIpPoolOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_network_imported vcd_nsxt_network_imported}
*/
export declare class NsxtNetworkImported extends cdktf.TerraformResource {
    static readonly tfResourceType = "vcd_nsxt_network_imported";
    /**
    * Generates CDKTF code for importing a NsxtNetworkImported resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the NsxtNetworkImported to import
    * @param importFromId The id of the existing NsxtNetworkImported that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_network_imported#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the NsxtNetworkImported to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_network_imported vcd_nsxt_network_imported} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options NsxtNetworkImportedConfig
    */
    constructor(scope: Construct, id: string, config: NsxtNetworkImportedConfig);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _dns1?;
    get dns1(): string;
    set dns1(value: string);
    resetDns1(): void;
    get dns1Input(): string | undefined;
    private _dns2?;
    get dns2(): string;
    set dns2(value: string);
    resetDns2(): void;
    get dns2Input(): string | undefined;
    private _dnsSuffix?;
    get dnsSuffix(): string;
    set dnsSuffix(value: string);
    resetDnsSuffix(): void;
    get dnsSuffixInput(): string | undefined;
    private _dualStackEnabled?;
    get dualStackEnabled(): boolean | cdktf.IResolvable;
    set dualStackEnabled(value: boolean | cdktf.IResolvable);
    resetDualStackEnabled(): void;
    get dualStackEnabledInput(): boolean | cdktf.IResolvable | undefined;
    get dvpgId(): string;
    private _dvpgName?;
    get dvpgName(): string;
    set dvpgName(value: string);
    resetDvpgName(): void;
    get dvpgNameInput(): string | undefined;
    private _gateway?;
    get gateway(): string;
    set gateway(value: string);
    get gatewayInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get nsxtLogicalSwitchId(): string;
    private _nsxtLogicalSwitchName?;
    get nsxtLogicalSwitchName(): string;
    set nsxtLogicalSwitchName(value: string);
    resetNsxtLogicalSwitchName(): void;
    get nsxtLogicalSwitchNameInput(): string | undefined;
    private _org?;
    get org(): string;
    set org(value: string);
    resetOrg(): void;
    get orgInput(): string | undefined;
    private _ownerId?;
    get ownerId(): string;
    set ownerId(value: string);
    resetOwnerId(): void;
    get ownerIdInput(): string | undefined;
    private _prefixLength?;
    get prefixLength(): number;
    set prefixLength(value: number);
    get prefixLengthInput(): number | undefined;
    private _secondaryGateway?;
    get secondaryGateway(): string;
    set secondaryGateway(value: string);
    resetSecondaryGateway(): void;
    get secondaryGatewayInput(): string | undefined;
    private _secondaryPrefixLength?;
    get secondaryPrefixLength(): string;
    set secondaryPrefixLength(value: string);
    resetSecondaryPrefixLength(): void;
    get secondaryPrefixLengthInput(): string | undefined;
    private _vdc?;
    get vdc(): string;
    set vdc(value: string);
    resetVdc(): void;
    get vdcInput(): string | undefined;
    private _secondaryStaticIpPool;
    get secondaryStaticIpPool(): NsxtNetworkImportedSecondaryStaticIpPoolList;
    putSecondaryStaticIpPool(value: NsxtNetworkImportedSecondaryStaticIpPool[] | cdktf.IResolvable): void;
    resetSecondaryStaticIpPool(): void;
    get secondaryStaticIpPoolInput(): cdktf.IResolvable | NsxtNetworkImportedSecondaryStaticIpPool[] | undefined;
    private _staticIpPool;
    get staticIpPool(): NsxtNetworkImportedStaticIpPoolList;
    putStaticIpPool(value: NsxtNetworkImportedStaticIpPool[] | cdktf.IResolvable): void;
    resetStaticIpPool(): void;
    get staticIpPoolInput(): cdktf.IResolvable | NsxtNetworkImportedStaticIpPool[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
