import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface NsxtSegmentProfileTemplateConfig extends cdktf.TerraformMetaArguments {
    /**
    * Description of Segment Profile Template
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_segment_profile_template#description NsxtSegmentProfileTemplate#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_segment_profile_template#id NsxtSegmentProfileTemplate#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Segment IP Discovery Profile ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_segment_profile_template#ip_discovery_profile_id NsxtSegmentProfileTemplate#ip_discovery_profile_id}
    */
    readonly ipDiscoveryProfileId?: string;
    /**
    * Segment MAC Discovery Profile ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_segment_profile_template#mac_discovery_profile_id NsxtSegmentProfileTemplate#mac_discovery_profile_id}
    */
    readonly macDiscoveryProfileId?: string;
    /**
    * Name of Segment Profile Template
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_segment_profile_template#name NsxtSegmentProfileTemplate#name}
    */
    readonly name: string;
    /**
    * NSX-T Manager ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_segment_profile_template#nsxt_manager_id NsxtSegmentProfileTemplate#nsxt_manager_id}
    */
    readonly nsxtManagerId: string;
    /**
    * Segment QoS Profile ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_segment_profile_template#qos_profile_id NsxtSegmentProfileTemplate#qos_profile_id}
    */
    readonly qosProfileId?: string;
    /**
    * Segment Security Profile ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_segment_profile_template#segment_security_profile_id NsxtSegmentProfileTemplate#segment_security_profile_id}
    */
    readonly segmentSecurityProfileId?: string;
    /**
    * Segment Spoof Guard Profile ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_segment_profile_template#spoof_guard_profile_id NsxtSegmentProfileTemplate#spoof_guard_profile_id}
    */
    readonly spoofGuardProfileId?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_segment_profile_template vcd_nsxt_segment_profile_template}
*/
export declare class NsxtSegmentProfileTemplate extends cdktf.TerraformResource {
    static readonly tfResourceType = "vcd_nsxt_segment_profile_template";
    /**
    * Generates CDKTF code for importing a NsxtSegmentProfileTemplate resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the NsxtSegmentProfileTemplate to import
    * @param importFromId The id of the existing NsxtSegmentProfileTemplate that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_segment_profile_template#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the NsxtSegmentProfileTemplate to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxt_segment_profile_template vcd_nsxt_segment_profile_template} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options NsxtSegmentProfileTemplateConfig
    */
    constructor(scope: Construct, id: string, config: NsxtSegmentProfileTemplateConfig);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _ipDiscoveryProfileId?;
    get ipDiscoveryProfileId(): string;
    set ipDiscoveryProfileId(value: string);
    resetIpDiscoveryProfileId(): void;
    get ipDiscoveryProfileIdInput(): string | undefined;
    private _macDiscoveryProfileId?;
    get macDiscoveryProfileId(): string;
    set macDiscoveryProfileId(value: string);
    resetMacDiscoveryProfileId(): void;
    get macDiscoveryProfileIdInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _nsxtManagerId?;
    get nsxtManagerId(): string;
    set nsxtManagerId(value: string);
    get nsxtManagerIdInput(): string | undefined;
    private _qosProfileId?;
    get qosProfileId(): string;
    set qosProfileId(value: string);
    resetQosProfileId(): void;
    get qosProfileIdInput(): string | undefined;
    private _segmentSecurityProfileId?;
    get segmentSecurityProfileId(): string;
    set segmentSecurityProfileId(value: string);
    resetSegmentSecurityProfileId(): void;
    get segmentSecurityProfileIdInput(): string | undefined;
    private _spoofGuardProfileId?;
    get spoofGuardProfileId(): string;
    set spoofGuardProfileId(value: string);
    resetSpoofGuardProfileId(): void;
    get spoofGuardProfileIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
