import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface NsxvDistributedFirewallConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall#id NsxvDistributedFirewall#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The ID of VDC
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall#vdc_id NsxvDistributedFirewall#vdc_id}
    */
    readonly vdcId: string;
    /**
    * rule block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall#rule NsxvDistributedFirewall#rule}
    */
    readonly rule?: NsxvDistributedFirewallRule[] | cdktf.IResolvable;
}
export interface NsxvDistributedFirewallRuleApplication {
    /**
    * Destination port for this application. Leaving it empty means 'any' port
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall#destination_port NsxvDistributedFirewall#destination_port}
    */
    readonly destinationPort?: string;
    /**
    * Name of application (Application, ApplicationGroup)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall#name NsxvDistributedFirewall#name}
    */
    readonly name?: string;
    /**
    * Protocol of the application (one of TCP, UDP, ICMP) (When not using name/value)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall#protocol NsxvDistributedFirewall#protocol}
    */
    readonly protocol?: string;
    /**
    * Source port for this application. Leaving it empty means 'any' port
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall#source_port NsxvDistributedFirewall#source_port}
    */
    readonly sourcePort?: string;
    /**
    * Type of application
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall#type NsxvDistributedFirewall#type}
    */
    readonly type?: string;
    /**
    * Value of the application
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall#value NsxvDistributedFirewall#value}
    */
    readonly value?: string;
}
export declare function nsxvDistributedFirewallRuleApplicationToTerraform(struct?: NsxvDistributedFirewallRuleApplication | cdktf.IResolvable): any;
export declare function nsxvDistributedFirewallRuleApplicationToHclTerraform(struct?: NsxvDistributedFirewallRuleApplication | cdktf.IResolvable): any;
export declare class NsxvDistributedFirewallRuleApplicationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): NsxvDistributedFirewallRuleApplication | cdktf.IResolvable | undefined;
    set internalValue(value: NsxvDistributedFirewallRuleApplication | cdktf.IResolvable | undefined);
    private _destinationPort?;
    get destinationPort(): string;
    set destinationPort(value: string);
    resetDestinationPort(): void;
    get destinationPortInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _protocol?;
    get protocol(): string;
    set protocol(value: string);
    resetProtocol(): void;
    get protocolInput(): string | undefined;
    private _sourcePort?;
    get sourcePort(): string;
    set sourcePort(value: string);
    resetSourcePort(): void;
    get sourcePortInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
}
export declare class NsxvDistributedFirewallRuleApplicationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: NsxvDistributedFirewallRuleApplication[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): NsxvDistributedFirewallRuleApplicationOutputReference;
}
export interface NsxvDistributedFirewallRuleAppliedTo {
    /**
    * Name of the applied-to entity
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall#name NsxvDistributedFirewall#name}
    */
    readonly name: string;
    /**
    * Type of the applied-to entity (one of Network, Edge, VirtualMachine, IPSet, VDC, Ipv4Address)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall#type NsxvDistributedFirewall#type}
    */
    readonly type: string;
    /**
    * Value of the applied-to entity
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall#value NsxvDistributedFirewall#value}
    */
    readonly value: string;
}
export declare function nsxvDistributedFirewallRuleAppliedToToTerraform(struct?: NsxvDistributedFirewallRuleAppliedTo | cdktf.IResolvable): any;
export declare function nsxvDistributedFirewallRuleAppliedToToHclTerraform(struct?: NsxvDistributedFirewallRuleAppliedTo | cdktf.IResolvable): any;
export declare class NsxvDistributedFirewallRuleAppliedToOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): NsxvDistributedFirewallRuleAppliedTo | cdktf.IResolvable | undefined;
    set internalValue(value: NsxvDistributedFirewallRuleAppliedTo | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    get valueInput(): string | undefined;
}
export declare class NsxvDistributedFirewallRuleAppliedToList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: NsxvDistributedFirewallRuleAppliedTo[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): NsxvDistributedFirewallRuleAppliedToOutputReference;
}
export interface NsxvDistributedFirewallRuleDestination {
    /**
    * Name of the destination entity
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall#name NsxvDistributedFirewall#name}
    */
    readonly name: string;
    /**
    * Type of the destination entity (one of Network, Edge, VirtualMachine, IpSet, VDC, Ipv4Address)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall#type NsxvDistributedFirewall#type}
    */
    readonly type: string;
    /**
    * Value of the destination entity
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall#value NsxvDistributedFirewall#value}
    */
    readonly value: string;
}
export declare function nsxvDistributedFirewallRuleDestinationToTerraform(struct?: NsxvDistributedFirewallRuleDestination | cdktf.IResolvable): any;
export declare function nsxvDistributedFirewallRuleDestinationToHclTerraform(struct?: NsxvDistributedFirewallRuleDestination | cdktf.IResolvable): any;
export declare class NsxvDistributedFirewallRuleDestinationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): NsxvDistributedFirewallRuleDestination | cdktf.IResolvable | undefined;
    set internalValue(value: NsxvDistributedFirewallRuleDestination | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    get valueInput(): string | undefined;
}
export declare class NsxvDistributedFirewallRuleDestinationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: NsxvDistributedFirewallRuleDestination[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): NsxvDistributedFirewallRuleDestinationOutputReference;
}
export interface NsxvDistributedFirewallRuleSource {
    /**
    * Name of the source entity
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall#name NsxvDistributedFirewall#name}
    */
    readonly name: string;
    /**
    * Type of the source entity (one of Network, Edge, VirtualMachine, IpSet, VDC, Ipv4Address)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall#type NsxvDistributedFirewall#type}
    */
    readonly type: string;
    /**
    * Value of the source entity
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall#value NsxvDistributedFirewall#value}
    */
    readonly value: string;
}
export declare function nsxvDistributedFirewallRuleSourceToTerraform(struct?: NsxvDistributedFirewallRuleSource | cdktf.IResolvable): any;
export declare function nsxvDistributedFirewallRuleSourceToHclTerraform(struct?: NsxvDistributedFirewallRuleSource | cdktf.IResolvable): any;
export declare class NsxvDistributedFirewallRuleSourceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): NsxvDistributedFirewallRuleSource | cdktf.IResolvable | undefined;
    set internalValue(value: NsxvDistributedFirewallRuleSource | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    get valueInput(): string | undefined;
}
export declare class NsxvDistributedFirewallRuleSourceList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: NsxvDistributedFirewallRuleSource[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): NsxvDistributedFirewallRuleSourceOutputReference;
}
export interface NsxvDistributedFirewallRule {
    /**
    * Action of the rule (allow, deny)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall#action NsxvDistributedFirewall#action}
    */
    readonly action: string;
    /**
    * Direction of the rule (in, out, inout)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall#direction NsxvDistributedFirewall#direction}
    */
    readonly direction: string;
    /**
    * Whether the rule is enabled
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall#enabled NsxvDistributedFirewall#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * If true, the content of the destination elements is reversed
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall#exclude_destination NsxvDistributedFirewall#exclude_destination}
    */
    readonly excludeDestination?: boolean | cdktf.IResolvable;
    /**
    * If true, the content of the source elements is reversed
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall#exclude_source NsxvDistributedFirewall#exclude_source}
    */
    readonly excludeSource?: boolean | cdktf.IResolvable;
    /**
    * Whether the rule traffic is logged
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall#logged NsxvDistributedFirewall#logged}
    */
    readonly logged?: boolean | cdktf.IResolvable;
    /**
    * Firewall Rule name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall#name NsxvDistributedFirewall#name}
    */
    readonly name?: string;
    /**
    * Packet type of the rule (any, ipv4, ipv6)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall#packet_type NsxvDistributedFirewall#packet_type}
    */
    readonly packetType?: string;
    /**
    * application block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall#application NsxvDistributedFirewall#application}
    */
    readonly application?: NsxvDistributedFirewallRuleApplication[] | cdktf.IResolvable;
    /**
    * applied_to block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall#applied_to NsxvDistributedFirewall#applied_to}
    */
    readonly appliedTo: NsxvDistributedFirewallRuleAppliedTo[] | cdktf.IResolvable;
    /**
    * destination block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall#destination NsxvDistributedFirewall#destination}
    */
    readonly destination?: NsxvDistributedFirewallRuleDestination[] | cdktf.IResolvable;
    /**
    * source block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall#source NsxvDistributedFirewall#source}
    */
    readonly source?: NsxvDistributedFirewallRuleSource[] | cdktf.IResolvable;
}
export declare function nsxvDistributedFirewallRuleToTerraform(struct?: NsxvDistributedFirewallRule | cdktf.IResolvable): any;
export declare function nsxvDistributedFirewallRuleToHclTerraform(struct?: NsxvDistributedFirewallRule | cdktf.IResolvable): any;
export declare class NsxvDistributedFirewallRuleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): NsxvDistributedFirewallRule | cdktf.IResolvable | undefined;
    set internalValue(value: NsxvDistributedFirewallRule | cdktf.IResolvable | undefined);
    private _action?;
    get action(): string;
    set action(value: string);
    get actionInput(): string | undefined;
    private _direction?;
    get direction(): string;
    set direction(value: string);
    get directionInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _excludeDestination?;
    get excludeDestination(): boolean | cdktf.IResolvable;
    set excludeDestination(value: boolean | cdktf.IResolvable);
    resetExcludeDestination(): void;
    get excludeDestinationInput(): boolean | cdktf.IResolvable | undefined;
    private _excludeSource?;
    get excludeSource(): boolean | cdktf.IResolvable;
    set excludeSource(value: boolean | cdktf.IResolvable);
    resetExcludeSource(): void;
    get excludeSourceInput(): boolean | cdktf.IResolvable | undefined;
    get id(): number;
    private _logged?;
    get logged(): boolean | cdktf.IResolvable;
    set logged(value: boolean | cdktf.IResolvable);
    resetLogged(): void;
    get loggedInput(): boolean | cdktf.IResolvable | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _packetType?;
    get packetType(): string;
    set packetType(value: string);
    resetPacketType(): void;
    get packetTypeInput(): string | undefined;
    private _application;
    get application(): NsxvDistributedFirewallRuleApplicationList;
    putApplication(value: NsxvDistributedFirewallRuleApplication[] | cdktf.IResolvable): void;
    resetApplication(): void;
    get applicationInput(): cdktf.IResolvable | NsxvDistributedFirewallRuleApplication[] | undefined;
    private _appliedTo;
    get appliedTo(): NsxvDistributedFirewallRuleAppliedToList;
    putAppliedTo(value: NsxvDistributedFirewallRuleAppliedTo[] | cdktf.IResolvable): void;
    get appliedToInput(): cdktf.IResolvable | NsxvDistributedFirewallRuleAppliedTo[] | undefined;
    private _destination;
    get destination(): NsxvDistributedFirewallRuleDestinationList;
    putDestination(value: NsxvDistributedFirewallRuleDestination[] | cdktf.IResolvable): void;
    resetDestination(): void;
    get destinationInput(): cdktf.IResolvable | NsxvDistributedFirewallRuleDestination[] | undefined;
    private _source;
    get source(): NsxvDistributedFirewallRuleSourceList;
    putSource(value: NsxvDistributedFirewallRuleSource[] | cdktf.IResolvable): void;
    resetSource(): void;
    get sourceInput(): cdktf.IResolvable | NsxvDistributedFirewallRuleSource[] | undefined;
}
export declare class NsxvDistributedFirewallRuleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: NsxvDistributedFirewallRule[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): NsxvDistributedFirewallRuleOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall vcd_nsxv_distributed_firewall}
*/
export declare class NsxvDistributedFirewall extends cdktf.TerraformResource {
    static readonly tfResourceType = "vcd_nsxv_distributed_firewall";
    /**
    * Generates CDKTF code for importing a NsxvDistributedFirewall resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the NsxvDistributedFirewall to import
    * @param importFromId The id of the existing NsxvDistributedFirewall that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the NsxvDistributedFirewall to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/nsxv_distributed_firewall vcd_nsxv_distributed_firewall} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options NsxvDistributedFirewallConfig
    */
    constructor(scope: Construct, id: string, config: NsxvDistributedFirewallConfig);
    get enabled(): cdktf.IResolvable;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _vdcId?;
    get vdcId(): string;
    set vdcId(value: string);
    get vdcIdInput(): string | undefined;
    private _rule;
    get rule(): NsxvDistributedFirewallRuleList;
    putRule(value: NsxvDistributedFirewallRule[] | cdktf.IResolvable): void;
    resetRule(): void;
    get ruleInput(): cdktf.IResolvable | NsxvDistributedFirewallRule[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
