import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface RdeTypeBehaviorAclConfig extends cdktf.TerraformMetaArguments {
    /**
    * Set of Access Level IDs to associate to the Behavior defined in `behavior_id` argument
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/rde_type_behavior_acl#access_level_ids RdeTypeBehaviorAcl#access_level_ids}
    */
    readonly accessLevelIds: string[];
    /**
    * The ID of either a RDE Interface Behavior or RDE Type Behavior
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/rde_type_behavior_acl#behavior_id RdeTypeBehaviorAcl#behavior_id}
    */
    readonly behaviorId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/rde_type_behavior_acl#id RdeTypeBehaviorAcl#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The ID of the RDE Type
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/rde_type_behavior_acl#rde_type_id RdeTypeBehaviorAcl#rde_type_id}
    */
    readonly rdeTypeId: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/rde_type_behavior_acl vcd_rde_type_behavior_acl}
*/
export declare class RdeTypeBehaviorAcl extends cdktf.TerraformResource {
    static readonly tfResourceType = "vcd_rde_type_behavior_acl";
    /**
    * Generates CDKTF code for importing a RdeTypeBehaviorAcl resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the RdeTypeBehaviorAcl to import
    * @param importFromId The id of the existing RdeTypeBehaviorAcl that should be imported. Refer to the {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/rde_type_behavior_acl#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the RdeTypeBehaviorAcl to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vmware/vcd/3.12.0/docs/resources/rde_type_behavior_acl vcd_rde_type_behavior_acl} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options RdeTypeBehaviorAclConfig
    */
    constructor(scope: Construct, id: string, config: RdeTypeBehaviorAclConfig);
    private _accessLevelIds?;
    get accessLevelIds(): string[];
    set accessLevelIds(value: string[]);
    get accessLevelIdsInput(): string[] | undefined;
    private _behaviorId?;
    get behaviorId(): string;
    set behaviorId(value: string);
    get behaviorIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _rdeTypeId?;
    get rdeTypeId(): string;
    set rdeTypeId(value: string);
    get rdeTypeIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
